Library ieee;
USE ieee.std_logic_1164.ALL;

Library std_developerskit;
USE std_developerskit.synth_regpak.ALL;

PACKAGE conversions IS
	SUBTYPE word_16 IS std_logic_vector(0 TO 15);
	FUNCTION bit_to_std(byte:word_16) RETURN bit_vector;
	FUNCTION byte_to_int (byte:word_16) RETURN integer;
END conversions;

PACKAGE BODY conversions IS

FUNCTION byte_to_int(byte: word_16) RETURN integer IS
    VARIABLE result: integer := 0;
    VARIABLE temp:bit_vector(0 to 15);
BEGIN
    temp := bit_to_std(byte);	
    FOR index IN 0 TO 15 LOOP
      result := result*2 + BIT'POS(temp(index));
    END LOOP;
  	    RETURN result;
END byte_to_int;


FUNCTION bit_to_std(byte: word_16) RETURN bit_vector IS
    VARIABLE result: bit_vector(0 to 15);
BEGIN
    
    FOR index IN 0 TO 15 LOOP
            if byte(index)='1' then
		result(index):='1';
	    elsif byte(index)='0' then
		result(index):='0';
	    end if;
    END LOOP;
  	    RETURN result;
END bit_to_std;


END conversions;
