Library ieee;
Use ieee.std_logic_1164.ALL;

Library std_developerskit;
USE std_developerskit.synth_regpak.ALL;

Use work.binary2int.ALL;


Entity shifter is
	
   PORT(input: IN std_logic_vector( 15 downto 0);
	control: IN std_logic_vector(7 downto 0);
	secondInput: IN std_logic_vector(31 downto 0);
	SF: IN std_logic_vector(3 downto 0);
	upOutput: OUT std_logic_vector(15 downto 0);
	bottomOutput: OUT std_logic_vector( 15 downto 0)
	);
end shifter;

Architecture behav of shifter is
	
	Begin
	Process(SF, input)
		variable x : std_logic;
		variable shft : integer;
		variable outputStore : std_logic_vector(31 downto 0);
		Begin

		x := input(15);
		case SF is

		when "0000" =>
			
			--puts input in the upper 16bits and fills the
			--lower bits with zero.
			--then shifts left and fills with zeros.
		If x = '0' then
			shft := b2i(control);
			outputStore := input(15 downto 0) & "0000000000000000";

			while shft > 0 loop
				outputStore := outputStore(30 downto 0) & "0";
				shft := shft - 1;
			END loop;
		Elseif x = '1' then
			shft := b2i(control);
			outputStore := input(15 downto 0) & "0000000000000000";

			while shft > 0 loop
				outputStore := "0" & outputStore(30 downto 0);
				shft := shft - 1;
			END loop;
		End if;	
		when "0001" =>
			
			--same as above.
			--not sure what OR means
			shft := b2i(control);
		if x = '0' then
			outputStore := input(15 downto 0) & "0000000000000000";
			
			while shft > 0 loop
				outputStore := outputStore(30 downto 0) & "0";
				shft := shft - 1;
			END loop;
			
			outputStore := outputStore or secondInput;

		elseif x = '1' then
			outputStore := input(15 downto 0) & "0000000000000000";
			
			while shft > 0 loop
				outputStore := "0" & outputStore(30 downto 0);
				shft := shft - 1;
			END loop;
			
			outputStore := outputStore or secondInput;
		end if;

		when "0010" =>
			
			--inserts zeros in the upper 16bits
			--shifts left and fills with zeros
			shft := b2i(control);
		if x = '0' then	
			outputStore := "0000000000000000" & input(15 downto 0);
 			while shft > 0 loop
				outputStore := outputStore(30 downto 0) & "0";
				shft := shft - 1;
			END loop;	
		elseif x = '1' then
			outputStore := "0000000000000000" & input(15 downto 0);
 			while shft > 0 loop
				outputStore := "0" & outputStore(30 downto 0);
				shft := shft - 1;
			END loop;
		end if;


		when "0011" =>
			shft := b2i(control);
		if x = '0' then	
			
			outputStore := input(15 downto 0) & "0000000000000000";
			
			while shft > 0 loop
				outputStore := outputStore(30 downto 0) & "0";						shft := shft - 1;
			END loop;

			outputStore := outputStore or secondInput;
		elseif x = '1' then
			outputStore := input(15 downto 0) & "0000000000000000";
			
			while shft > 0 loop
				outputStore := "0" & outputStore(30 downto 0);						shft := shft - 1;
			END loop;

			outputStore := outputStore or secondInput;
		end if;
		when "0100" =>

			shft := b2i(control);
			if x = '0' then
			
				outputStore := input(15 downto 0) & "0000000000000000";	
			elsif x = '1' then 
				outputStore := input(15 downto 0) & "1111111111111111";
			end if;

			while shft > 0 loop
				outputStore := outputStore(30 downto 0) & x;
				shft := shft - 1;
			END loop;
		elseif x = '1' then
			if x = '0' then
				outputStore := input(15 downto 0) & "0000000000000000";
			elsif x = '1' then 
				outputStore := input(15 downto 0) & "1111111111111111";
			end if;

			while shft > 0 loop
				outputStore := x & outputStore(30 downto 0);
				shft := shft - 1;
			END loop;
		end if

		when "0101" =>
			
         		shft := b2i(control);
 		if x = '0' then
			if x = '0' then
				outputStore := input(15 downto 0) & "0000000000000000";
			elsif x = '1' then 
				outputStore := input(15 downto 0) & "1111111111111111";
			end if;

        		 while shft > 0 loop
				outputStore := outputStore(30 downto 0) & x;
				shft := shft - 1;
			END loop;

			outputStore := outputStore or secondInput;	

		elseif x = '1' then
			if x = '0' then
				outputStore := input(15 downto 0) & "0000000000000000";
			elsif x = '1' then 
				outputStore := input(15 downto 0) & "1111111111111111";
			end if;

        		 while shft > 0 loop
				outputStore := x & outputStore(30 downto 0);
				shft := shft - 1;
			END loop;

			outputStore := outputStore or secondInput;	

		end if;
		when "0110" => 
         
         		shft := b2i(control);
		if x = '0' then	
			if x = '0' then
				outputStore := "0000000000000000" & input(15 downto 0);
			elsif x = '1' then 
				outputStore := "1111111111111111" & input(15 downto 0);
			end if;

 			while shft > 0 loop
				outputStore := outputStore(30 downto 0) & x;
				shft := shft - 1;
			END loop;	
		elseif x = '1' then
			if x = '0' then
				outputStore := "0000000000000000" & input(15 downto 0);
			elsif x = '1' then 
				outputStore := "1111111111111111" & input(15 downto 0);
			end if;

 			while shft > 0 loop
				outputStore := x & outputStore(30 downto 0);
				shft := shft - 1;
			END loop;	
		end if;
		when "0111" =>

			shft := b2i(control);
		if x = '0' then
			if x = '0' then
				outputStore := "0000000000000000" & input(15 downto 0);
			elsif x = '1' then 
				outputStore := "1111111111111111" & input(15 downto 0);
			end if;

 			while shft > 0 loop
				outputStore := outputStore(30 downto 0) & x;
				shft := shft - 1;
			END loop;	

			outputStore := outputStore or secondInput;
		elseif x = '1' then
			if x = '0' then
				outputStore := "0000000000000000" & input(15 downto 0);
			elsif x = '1' then 
				outputStore := "1111111111111111" & input(15 downto 0);
			end if;

 			while shft > 0 loop
				outputStore := x & outputStore(30 downto 0);
				shft := shft - 1;
			END loop;	

			outputStore := outputStore or secondInput;
		end if;
		when others =>

		end case;
	
		upOutput <= outputStore(31 downto 16);
		bottomOutput <= outputStore(15 downto 0);

	end process;
end behav;


