LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;

LIBRARY work;
USE work.conversions.ALL;

entity shifter_or_pass is
  port ( DSI : in std_logic_vector (15 downto 0);
        CONTROL : in std_logic_vector (7 downto 0);
        OR_PASS :in std_logic_vector (31 downto 0);
        
        SHIFT_OUT_HI: out std_logic_vector (15 downto 0);
        SHIFT_OUT_LO: out std_logic_vector (15 downto 0)
         );

end shifter_or_pass;


ARCHITECTURE behavior of shifter_or_pass is

BEGIN
part1:
 process (DSI, CONTROL)
     variable COND: std_logic_vector(3 downto 0);
     variable EXPONENT: std_logic_vector (3 downto 0);
     variable TEMPOUT:std_logic_vector (31 downto 0);
     variable TEMP_NEG:std_logic_vector (31 downto 0);
     variable SHIFT_OUT1:std_logic_vector (31 downto 0);
     variable i:integer;
     
     begin
    
     COND:=CONTROL(3 downto 0);
     EXPONENT:=CONTROL (7 downto 4);
    
     i:=byte_to_int(EXPONENT);
    TEMP_NEG:="11111111111111111111111111111111";

	case COND is
		when "0000" =>-- logical shift HI
		TEMPOUT:="00000000000000000000000000000000";	
      if EXPONENT(3)= '1' then
			   TEMPOUT((31-i)downto ((31-i)-15)):=DSI(15 downto 0);
			else
        			TEMPOUT(31 downto (16+i)):= DSI((15-i) downto 0);
	    end if;
      SHIFT_OUT1 := TEMPOUT ;

    when "0001" =>--HI,OR
		TEMPOUT:="00000000000000000000000000000000";	
      if EXPONENT(3)= '1' then
			   TEMPOUT((31-i)downto ((31-i)-15)):=DSI(15 downto 0);
			else
        			TEMPOUT(31 downto (16+i)):= DSI((15-i) downto 0);
	    end if;
      SHIFT_OUT1:=TEMPOUT or OR_PASS; 	


	  when "0010" =>--LO
     TEMPOUT:="00000000000000000000000000000000";	
      if EXPONENT(3)= '1' then
			   TEMPOUT((15-i) downto 0):=DSI(15 downto i);
			else
        			TEMPOUT((15+i) downto i):= DSI(15 downto 0);
	    end if;
      SHIFT_OUT1 := TEMPOUT ; 
      
		
	   when "0011" =>--LO,OR
    TEMPOUT:="00000000000000000000000000000000";	
      if EXPONENT(3)= '1' then
			   TEMPOUT((15-i) downto 0):=DSI(15 downto i);
			else
        			TEMPOUT((15+i) downto i):= DSI(15 downto 0);
	    end if;
      SHIFT_OUT1 := TEMPOUT or OR_PASS ; 


		when "0100" => --arithemtic shift hi
     TEMPOUT:="00000000000000000000000000000000";	
      if EXPONENT(2)= '1' then
			   if DSI(15)= '1' then
           TEMPOUT(31 downto (31-i)):= TEMP_NEG (31 downto (31-i));
           end if; 
           TEMPOUT((31-i)downto ((31-i)-15)):=DSI(15 downto 0);
			    
       else
        			TEMPOUT(31 downto (16+i)):= DSI((15-i) downto 0);

	    end if;
      SHIFT_OUT1 := TEMPOUT ;
 
    when "0101" => -- ashift hi or
     TEMPOUT:="00000000000000000000000000000000";	
      if EXPONENT(3)= '1' then
			   if DSI(15)= '1' then
           TEMPOUT(31 downto (31-i)):= TEMP_NEG (31 downto (31-i));
           end if; 
           TEMPOUT((31-i)downto ((31-i)-15)):=DSI(15 downto 0);
			    
       else   -- positive shift
        			TEMPOUT(31 downto (16+i)):= DSI((15-i) downto 0);

	    end if;
      SHIFT_OUT1 := TEMPOUT or OR_PASS ;

    when "0110" =>  -- ashift lo
     
     TEMPOUT:="00000000000000000000000000000000";	
      if EXPONENT(3)= '1' then
          if DSI(15)= '1' then
             
			   TEMPOUT((16-i) downto 0):=DSI(15 downto i);
          end if;
			else   -- positive shift
           if DSI(15)= '1' then
            TEMPOUT(i downto 0):= TEMP_NEG(i downto 0);
        			end if;
            TEMPOUT((31-(16+i)) downto i):= DSI(15 downto 0);
	    end if;
      SHIFT_OUT1 := TEMPOUT ; 


     when "0111" =>
     
     TEMPOUT:="00000000000000000000000000000000";	
      if EXPONENT(3)= '1' then
          if DSI(15)= '1' then
             
			   TEMPOUT((16-i) downto 0):=DSI(15 downto i);
			 end if;
        else   -- positive shift
           if DSI(15)= '1' then
            TEMPOUT(i downto 0):= TEMP_NEG(i downto 0);
        			end if;
            TEMPOUT((31-(16+i)) downto i):= DSI(15 downto 0);
	    end if;
      SHIFT_OUT1 := TEMPOUT or OR_PASS ; 



		when others =>
		
	end case;
    
     SHIFT_OUT_HI<= SHIFT_OUT1(31 downto 16) ;
     SHIFT_OUT_LO<= SHIFT_OUT1(15 downto 0) ;
     

        
   end process part1;
  end behavior;   

-- edwin the only error when compiling has to do with the delay wich i could'nt correct but maybe you can help me tomorrow or today if you want  
