--
-- Copyright (C) 1988-1999 Altera Corporation
--
-- Any megafunction design, and related net list (encrypted or decrypted),
-- support information, device programming or simulation file, and any
-- other associated documentation or information provided by Altera or a
-- partner under Altera's Megafunction Partnership Program may be used only
-- to program PLD devices (but not masked PLD devices) from Altera.  Any
-- other use of such megafunction design, net list, support information,
-- device programming or simulation file, or any other related
-- documentation or information is prohibited for any other purpose,
-- including, but not limited to modification, reverse engineering, de-
-- compiling, or use with any other silicon devices, unless such use is
-- explicitly licensed under a separate agreement with Altera or a
-- megafunction partner.  Title to the intellectual property, including
-- patents, copyrights, trademarks, trade secrets, or maskworks, embodied
-- in any such megafunction design, net list, support information, device
-- programming or simulation file, or any other related documentation or
-- information provided by Altera or a megafunction partner, remains with
-- Altera, the megafunction partner, or their respective licensors.  No
-- other licenses, including any licenses needed under any third party's
-- intellectual property, are provided herein.
----------------------------------------------------------------------------
----------------------------------------------------------------------------
-- ALtera Megafunction Simulation File
--
-- Version QuartusII 1.0 Date: 01/09/01
--
-- 01/09/01: Fix SPR 79392 for altcdr_rx.
-- 01/05/01: Default value of altlvds_tx outclock_divide_by set to zero.
-- 01/04/01: Fix sprs 79179 & 79181 for altddio and altcdr.
--           Also added missing lcell, global, carry and cascade
-- 12/11/00: During SR78303 found a variable initialization VSS problem.
-- 12/05/00: Fix SPR78085. Fix altcam, altdpram and altqpram to support
--           width >32 bit hex files.
-- 12/05/00: Fix SPR77901. Modified altcam warning messages.
-- 11/27/00: Fix SPR75474. Add tx_pll_enable and rx_pll_enable to altlvds_tx
--           and altlvds_rx respectively.
-- 11/27/00: Fix SPR75144. Mercury altlvds_tx and new port tx_coreclock.
-- New components:
--      alt_exc_dpram, alt_exc_upcore, altdido_in, altdido_out,
--      altdido_bidir, altcdr_rx, altcdr_tx
----------------------------------------------------------------------------
-- Version 1.01 Date: 11/08/00
--
-- 11/08/00: Added alt_exc_dpram and alt_exc_upcore.
-- 11/03/00: Fixed altqpram to behave correctly.
-- 10/19/00: Allow write-on-pattern-change for altcam when pattern is
--           unregistered. And provide workaround for when mstart and mnext
--           are unused in fast multiple mode. See SPR76920. 
-- 10/04/00: Fix altclklock valid_lock_cycles counting when inclock starts
--           off low. SPR77687.
-- 10/03/00: Fix altclklock. SPR76627.
-- 09/22/00: Fixed altqpram to get input data at rising clock edge and
--           write data at falling clock edge.
-- 09/20/00: Changed altdpram to output 0 when rden is low for APEX20K
--           device family.  Output remains when rden is low for other
--           device families.
-- 09/19/00: Fixed altdpram to get input data at rising clock edge and
--           write data at falling clock edge.
-- 08/22/00: Added synchronous mode to dcfifo.
-- 08/21/00: Added default values to aclr and sclr of dcfifo and scfifo.
-- 08/18/00: Added INTENDED_DEVICE_FAMILY parameter to altdpram.
-- 08/14/00: Valid values for *_ACLR_* parameters of altqpram have changed
--           from ON and OFF to INACLR_A (or INACLR_B) and NONE
--           respectively.
-- 08/14/00: SPR 74650
--           Removed several internal-use only parameters (MAXIMUM_DEPTH,
--           CASCADE_CHAIN, DEVICE_FAMILY, DATA_INTERLEAVE_OFFSET_IN_BITS,
--           and DATA_INTERLEAVE_WIDTH_IN_BITS) from altqpram so that
--           Quartus won't behave strangely.  Also removed DEVICE_FAMILY
--           and OPTIMIZE_FOR_SPEED parameters from scfifo.
-- 08/11/00: dcfifo and scfifo are fully implemented.
-- 08/03/00: Added default values to all altqpram ports and parameters.
-- 08/02/00: Removed MAXIMIZE_SPEED, ALMOST_FULL_VALUE, ALMOST_EMPTY_VALUE,
--           and ALLOW_RWCYCLE_WHEN_FULL parameters from dcfifo.  Added
--           LPM_HINT parameter to dcfifo.
-- 08/02/00: Removed MAXIMIZE_SPEED parameter from scfifo.
-- 07/29/00: Added WRADDRESS_ACLR_A, WRADDRESS_ACLR_B, and LPM_HINT
--           parameters to altqpram.
-- 07/29/00: Added default value to CASCADE_CHAIN and DEVICE_FAMILY
--           parameters of altqpram.
-- 07/28/00: INCLOCK_PERIOD defaulted to "10000". See SPR73860.
-- 07/26/00: Update altdpram to use "lpm_file" and "lpm_hint".
--           Latest altlvds_rx and altlvds_tx dfactor changes added.
-- 07/26/00: Updating altclklock for mercury support.
-- 07/24/00: Changing altlvds_rx and altlvds_tx warning msgs to errors.
-- 07/17/00: Changing altclklock *time_delay* parameter to string type to
--           allow for negative values.
-- 06/28/00: Fix altlvds_tx shift out on 3rd posedge.
-- 06/27/00: adding mercury support to altlvds_rx&tx.
-- 06/26/00: adding "operation_mode" param to altlvds_rx&tx.
-- 06/23/00: altclklock will come out of lock if inclock is unchanged.
-- 06/23/00: Added explicit type conversion for vector comparison.
-- 06/23/00: Adding intended_device_parameter to altclklock, altlvds_rx and
--           altlvds_tx. Minor changes to altclklock, altlvds_rx and
--           altlvds_tx to match Quartus sim behavior at startup.
-- 06/21/00: Changed all parameters of scfifo and dcfifo from type positive
--             to type natural.  scfifo and dcfifo are added back.
--           The scfifo implementation is a "placeholder" only.  The dcfifo
--             implementation is working except for some parameters
--             (almost_empty_value, overflow_checking, underflow_checking,
--             allow_rwcycle_when_full).
-- 06/15/00: Significant fixes to altclklock, altlvds_rx and altlvds_rx.
--           SPR 71839, 72411 and 72570. Corrected bit-ordering, deskew
--           usage, issues with "Duty Cycle violation" etc.
-- 06/13/00: SPR 72514
--           Fixed inclock edge detection problem, which caused output
--             clock to shift 180 degree for some designs.
-- 06/02/00: Added "jumbo" fix for altcam. SPR 70735, 71239, 71240, 71614
--           71617, 71940. Passes all regtest. NB: The state of the outputs
--           during a MULTIPLE mode write cycle is not modelled. (trying to
--           determine what correct behavior is; this behavior is of no 
--           importance to users.)
-- 05/22/00: Added 4 other modes of altqpram.
-- 05/11/00: Added implementation of altqpram.
--           Commented out scfifo and dcfifo.
-- 04/24/00: Added implementation of scfifo and dcfifo.  Currently they
--             require LPM library.
-- 04/20/00: Added implementation of altdpram.
----------------------------------------------------------------------------
-- Version 1.00 Date: 04/17/00
--
-- 04/17/00: SPR 70506
--           Corrected the match_mode parameter of altcam.
-- 04/17/00: SPR 70385
--           Fixed PLL output clocks to resume correctly after input clock
--             is disabled and then re-enabled.
-- 04/05/00: SPR 69196
--           Add a "placeholder" implementation for altdpram.
-- 03/08/00: SPR 69684
--           Fixed PLL duty cycle violation checking when clock does NOT
--             start at time=0.
--           SPR 69745, 69816
--           Fixed PLL output clock of 180 degree shifted problem.
--           SPR 68829
--           Added use_eab parameter to altcam
-- 11/15/99: Made altclklock locked output sensetive to clock variations.
-- 11/15/99: Fixed the lvds deskew according to the new spec.
-- 10/27/99: SPR 65010
--           Fixed lvds reciever and transmitter number of cycles to output.
--           Converted integer and positive types to natural to work with
--             Quartus Wizard. 
--           Changed altclklock outclock_phase_shift type from real to
--             natural which defaults to ps.
-- 10/22/99: SPR 65544
--           Corrected SINGLE mode operation when outputreg is clocked on
--             either "INCLOCK" or "OUTCLOCK".
-- 10/19/99: SPR 65264
--           Corrected CAM initialization from *.hex; i.e. fix to function
--             hex_to_stdlogicarray (s: string).
-- 10/05/99: Changed inclock_frequency to inclock_period for ALTCLKLOCK,
--             ALTLVDS_RX, and ALTLVDS_TX
-- 09/28/99: [lvds receiver]
--             Changed input_frequency to inclock_frequency 
--             Changed rx_clkin to rx_inclock
--             Changed rx_outclk to rx_outclock
--             Corrected the x7 loop index problem
--           [lvds transmitter]
--             Changed input_frequency to inclock_frequency 
--             Changed tx_clkin to tx_inclock
--             Changed tx_outclk to tx_outclock
--             Changed synch_clock_in  to sync_inclock
-- 09/20/99: Changed ALTPLL name to ALTCLKLOCK
--           Changed mult_factor_clock0 to clock0_boost
--           Changed mult_factor_clock1 to clock1_boost
--           Changed divide_factor_clock0 to clock0_divide
--           Changed divide_factor_clock1 to clock1_divide
--           Added lvds_rx and lvds_tx megafuntions
----------------------------------------------------------------------------


----------------------------------------------------------------------------
-- altcam 
----------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use std.textio.all;


entity altcam is
    generic
      ( width:            natural := 1;
        widthad:          natural := 1;
        numwords:         natural := 1;
        lpm_file:         string := "UNUSED";
        lpm_filex:        string := "UNUSED";
        match_mode:       string := "MULTIPLE";
        output_reg:       string := "UNREGISTERED";
        output_aclr:      string := "OFF";
        pattern_reg:      string := "INCLOCK";
        pattern_aclr:     string := "ON";
        wraddress_aclr:   string := "ON";
        wrx_reg:          string := "UNUSED";
        wrx_aclr:         string := "UNUSED";
        wrcontrol_aclr:   string := "OFF";
        use_eab:          string := "ON" );
    port
      ( pattern:    in std_logic_vector(width-1 downto 0);
        wrx:        in std_logic_vector(width-1 downto 0) := (others => '0');
        wrxused:    in std_logic := '1';
        wrdelete:   in std_logic := '0';
        wraddress:  in std_logic_vector(widthad-1 downto 0);
        wren:       in std_logic;
        inclock:    in std_logic;
        inclocken:  in std_logic := '1';
        inaclr:     in std_logic := '0';
        mstart:     in std_logic := 'X';
        mnext:      in std_logic := '0';
        outclock:   in std_logic := '0';
        outclocken: in std_logic := '1';
        outaclr:    in std_logic := '0';
        maddress:   out std_logic_vector(widthad-1 downto 0);
        mbits:      out std_logic_vector(numwords-1 downto 0);
        mfound:     out std_logic;
        mcount:     out std_logic_vector(widthad-1 downto 0);
        rdbusy:     out std_logic;
        wrbusy:     out std_logic );

    type lpm_memory is array
        (numwords-1 downto 0) of std_logic_vector(width-1 downto 0);

    function int_to_str( value : integer ) return string is
    variable ivalue,index : integer;
    variable digit : integer;
    variable line_no: string(8 downto 1) := "        ";  
    begin
        ivalue := value;
        index := 1;   
        while (ivalue > 0) loop
            digit := ivalue MOD 10;
            ivalue := ivalue/10;
            case digit is
                when 0 =>
                    line_no(index) := '0';
                when 1 =>
                    line_no(index) := '1';
                when 2 =>
                    line_no(index) := '2';
                when 3 =>
                    line_no(index) := '3';
                when 4 =>
                    line_no(index) := '4';
                when 5 =>
                    line_no(index) := '5';
                when 6 =>
                    line_no(index) := '6';
                when 7 =>
                    line_no(index) := '7';
                when 8 =>
                    line_no(index) := '8';
                when 9 =>
                    line_no(index) := '9';
                when others =>
                    ASSERT FALSE
                    REPORT "Illegal number!"
                    SEVERITY ERROR;
            end case;
            index := index + 1;
        end loop;
        return line_no;
    end;

    function hex_str_to_int( str : string ) return integer is
    variable len : integer := str'length;
    variable ivalue : integer := 0;
    variable digit : integer;
    begin
        for i in len downto 1 loop
            case str(i) is
                when '0' =>
                    digit := 0;
                when '1' =>
                    digit := 1;
                when '2' =>
                    digit := 2;
                when '3' =>
                    digit := 3;
                when '4' =>
                    digit := 4;
                when '5' =>
                    digit := 5;
                when '6' =>
                    digit := 6;
                when '7' =>
                    digit := 7;
                when '8' =>
                    digit := 8;
                when '9' =>
                    digit := 9;
                when 'A' =>
                    digit := 10;
                when 'a' =>
                    digit := 10;
                when 'B' =>
                    digit := 11;
                when 'b' =>
                    digit := 11;
                when 'C' =>
                    digit := 12;
                when 'c' =>
                    digit := 12;
                when 'D' =>
                    digit := 13;
                when 'd' =>
                    digit := 13;
                when 'E' =>
                    digit := 14;
                when 'e' =>
                    digit := 14;
                when 'F' =>
                    digit := 15;
                when 'f' =>
                    digit := 15;
                when others =>
                    ASSERT FALSE
                    REPORT "Illegal character "&  str(i) & "in Intel Hex File! "
                    SEVERITY ERROR;
            end case;
            ivalue := ivalue * 16 + digit;
        end loop;
        return ivalue;
    end;

    procedure Shrink_line(L : inout LINE; pos : in integer) is
    subtype nstring is string(1 to pos);
    variable stmp : nstring;
    begin
        if pos >= 1 then
            read(l,stmp);
        end if;
    end;

    function hex_to_stdlogicarray (s: string) return lpm_memory is
    variable mem_data : lpm_memory;
    variable mem_data_word : std_logic_vector(width-1 downto 0);
    variable i,j,k,n,m,lineno: integer := 0;
    variable buf: line;
    variable booval: boolean;
    FILE mem_data_file: TEXT IS IN s;
    variable base, byte, rec_type, datain, checksum: string(2 downto 1);
    variable startadd: string(4 downto 1);
    variable ibase: integer := 0;
    variable ibyte: integer := 0;
    variable istartadd: integer := 0;
    variable check_sum_vec, check_sum_vec_tmp: std_logic_vector(7 downto 0);
    begin
        WHILE NOT ENDFILE(mem_data_file) loop
            booval := true;
            READLINE(mem_data_file, buf);
            lineno := lineno + 1;
            check_sum_vec := (OTHERS => '0');
            if (buf(buf'LOW) = ':') then  -- check for start of record char ':'
                i := 1;
                shrink_line(buf, i);
                READ(L=>buf, VALUE=>byte, good=>booval); -- read length of record (2 hex chars)
                if not (booval) then
                    ASSERT FALSE
                    REPORT "[Line "& int_to_str(lineno) & "]:Illegal Intel Hex Format!"
                    SEVERITY ERROR;
                end if;
                ibyte := hex_str_to_int(byte);
                check_sum_vec := unsigned(check_sum_vec) + unsigned(CONV_STD_LOGIC_VECTOR(ibyte, 8));
                READ(L=>buf, VALUE=>startadd, good=>booval); -- read start/load address (4 hex chars)
                if not (booval) then 
                    ASSERT FALSE
                    REPORT "[Line "& int_to_str(lineno) & "]:Illegal Intel Hex Format! "
                    SEVERITY ERROR;
                end if;
                istartadd := hex_str_to_int(startadd);
                byte(2) := startadd(4);
                byte(1) := startadd(3);
                check_sum_vec := unsigned(check_sum_vec) + unsigned(CONV_STD_LOGIC_VECTOR(hex_str_to_int(byte), 8));
                byte(2) := startadd(2);
                byte(1) := startadd(1);
                check_sum_vec := unsigned(check_sum_vec) + unsigned(CONV_STD_LOGIC_VECTOR(hex_str_to_int(byte), 8));
                READ(L=>buf, VALUE=>rec_type, good=>booval);  -- read record type (2 hex chars)
                if not (booval) then
                    ASSERT FALSE
                    REPORT "[Line "& int_to_str(lineno) & "]:Illegal Intel Hex Format! "
                    SEVERITY ERROR;
                end if;
                check_sum_vec := unsigned(check_sum_vec) + unsigned(CONV_STD_LOGIC_VECTOR(hex_str_to_int(rec_type), 8));
            else
                ASSERT FALSE
                REPORT "[Line "& int_to_str(lineno) & "]:Illegal Intel Hex Format! "
                SEVERITY ERROR;
            end if;

            case rec_type is
                when "00"=>  -- Data record
                    i := 0;
                    k := width/8;
                    if ( (width MOD 8) /= 0 ) then
                        k := k + 1; 
                    end if;
                    -- k = no. of bytes per CAM entry.
                    while( i < ibyte ) loop
                       mem_data_word := (others => '0');
                       n := (k - 1)*8;
                       m := width - 1;
                       for j in 1 to k loop
                            READ(L=>buf, VALUE=>datain,good=>booval); -- read in data a byte (2 hex chars) at a time.
                            if not (booval) then
                                ASSERT FALSE
                                REPORT "[Line "& int_to_str(lineno) & "]:Illegal Intel Hex Format! "
                                SEVERITY ERROR;
                            end if;
                            check_sum_vec := unsigned(check_sum_vec) + unsigned(CONV_STD_LOGIC_VECTOR(hex_str_to_int(datain), 8));
                            mem_data_word(m downto n) := CONV_STD_LOGIC_VECTOR(hex_str_to_int(datain), m-n+1);
                            m := n - 1;
                            n := n - 8;
                        end loop;
                        i := i + k;
                        mem_data(ibase + istartadd) := mem_data_word;
                        istartadd := istartadd + 1;
                    end loop;
                when "01"=>
                    exit;
                when "02"=>
                    ibase := 0;
                    if (ibyte /= 2) then
                        ASSERT FALSE
                        REPORT "[Line "& int_to_str(lineno) & "]:Illegal Intel Hex Format for record type 02! "
                        SEVERITY ERROR;
                    end if;
                    for i in 0 to (ibyte-1) loop
                        READ(L=>buf, VALUE=>base,good=>booval);
                        if not (booval) then
                            ASSERT FALSE
                            REPORT "[Line "& int_to_str(lineno) & "]:Illegal Intel Hex Format! "
                            SEVERITY ERROR;
                        end if;
                        ibase := ibase * 256 + hex_str_to_int(base);
                        check_sum_vec := unsigned(check_sum_vec) + unsigned(CONV_STD_LOGIC_VECTOR(hex_str_to_int(base), 8));
                    end loop;
                    ibase := ibase * 16;  -- because std load addr is 2 bytes.
                when OTHERS =>
                    ASSERT FALSE
                    REPORT "[Line "& int_to_str(lineno) & "]:Illegal record type in Intel Hex File! "
                    SEVERITY ERROR;
            end case;
            READ(L=>buf, VALUE=>checksum,good=>booval);
            if not (booval) then
                ASSERT FALSE
                REPORT "[Line "& int_to_str(lineno) & "]:Checksum is missing! "
                SEVERITY ERROR;
            end if;

            check_sum_vec := unsigned(not (check_sum_vec)) + 1;
            check_sum_vec_tmp := CONV_STD_LOGIC_VECTOR(hex_str_to_int(checksum),8);

            if (check_sum_vec /= check_sum_vec_tmp) then
                ASSERT FALSE
                REPORT "[Line "& int_to_str(lineno) & "]:Incorrect checksum!"
                SEVERITY ERROR;
            end if;
         end loop;
         return mem_data;
    end;

end altcam;    

architecture behave of altcam is

signal pattern_rgd: std_logic_vector(width-1 downto 0) := (others => '0'); -- registered input
signal pattern_int: std_logic_vector(width-1 downto 0) := (others => '0'); -- internal input
signal wrx_rgd: std_logic_vector(width-1 downto 0) := (others => '0'); -- registered input
signal wrx_int: std_logic_vector(width-1 downto 0) := (others => '0'); -- internal input
signal wrxused_rgd : std_logic := '0'; -- registered input
signal wrxused_int : std_logic := '0'; -- internal input
signal wraddress_rgd: std_logic_vector(widthad-1 downto 0) := (others => '0'); -- registered input
signal wren_rgd: std_logic := '0'; -- registered input
signal wrdelete_rgd: std_logic := '0'; -- internally registered input
signal maddress_rgd: std_logic_vector(widthad-1 downto 0) := (others => '0'); -- registered output
signal maddress_int: std_logic_vector(widthad-1 downto 0) := (others => '0'); -- internal output
signal mbits_rgd: std_logic_vector(numwords-1 downto 0) := (others => '0'); -- registered output
signal mbits_int: std_logic_vector(numwords-1 downto 0) := (others => '0'); -- internal output
signal mfound_rgd: std_logic := '0'; -- registered output
signal mfound_int: std_logic := '0'; -- internal output
signal mcount_rgd: std_logic_vector(widthad-1 downto 0) := (others => '0'); -- registered output
signal mcount_int: std_logic_vector(widthad-1 downto 0) := (others => '0'); -- internal output
signal wrbusy_int : std_logic := '0'; -- internal output
signal rdbusy_int : std_logic := '0'; -- internal output
signal outclock_int: std_logic;  -- internal outclock
signal outaclr_int: std_logic;   -- internal outaclr

-- CAM signals
signal cam_init: integer := 1;
signal cam_array: lpm_memory;
signal x_array: lpm_memory;

-- Read control signals
signal get_first_match : boolean := false;
signal get_next_match : boolean := true;
signal first_read_clock : boolean := false;
signal mstart_rgd1: std_logic := '0';
signal mstart_rgd2: std_logic := '0';
signal rdbusy_delayed : std_logic;
signal first_read_in_write: boolean := false;
signal mstart_used: boolean := false;

-- Write control signals
signal write_start : std_logic;
signal write_start_rgd: std_logic := '0';
signal write_start_1: std_logic := '0';
signal write0: boolean := true;
signal write1: boolean := false;
signal writex: boolean := false;
signal write0_done: boolean := false;
signal write1_done: boolean := false;
signal writex_done: boolean := false;
signal write_incomplete: std_logic := '0';

begin

    msg: process (wraddress_rgd, wrdelete_rgd, wren_rgd, 
                  wrxused_int, pattern_int, mstart_rgd1)
    begin
        if wren_rgd'event and wren_rgd = '0' and write_incomplete = '1' then
            ASSERT FALSE
            REPORT "Insufficient write cycle time, write maybe invalid! "
            SEVERITY WARNING;
        elsif pattern_int'event and write_incomplete = '1' then
            ASSERT FALSE
            REPORT "Insufficient pattern hold time, write maybe invalid! "
            SEVERITY WARNING;
        elsif wraddress_rgd'event and write_incomplete = '1' then
            ASSERT FALSE
            REPORT "Insufficient address hold time, write maybe invalid! "
            SEVERITY WARNING;
        elsif wrdelete_rgd'event and wrdelete_rgd = '0' and 
            write_incomplete = '1' then
            ASSERT FALSE
            REPORT "Insufficient delete cycle time, delete failed! "
            SEVERITY WARNING;
        elsif wrdelete_rgd'event and wrdelete_rgd = '1' and 
            write_incomplete = '1' then
            ASSERT FALSE
            REPORT "Insufficient write cycle time, write maybe invalid! "
            SEVERITY WARNING;
        elsif wrxused_int'event and write_incomplete = '1' and 
            wrdelete_rgd = '0' then
            ASSERT FALSE
            REPORT "wrxused signal changed during write! "
            SEVERITY WARNING;
        elsif mstart_rgd1'event and write_incomplete = '1' and 
            mstart_rgd1 = '1' then
            ASSERT FALSE
            REPORT "Incorrect read attempt during write! "
            SEVERITY WARNING;
        end if;
        if pattern_int'event then
            if rdbusy_delayed = '1' then
                ASSERT FALSE
                REPORT "Insufficient read time, read failed! "
                SEVERITY WARNING;
            elsif rdbusy_delayed = '0' and mnext = '1' then
                ASSERT FALSE
                REPORT "Illegal pattern change during read, read failed! "
                SEVERITY WARNING;
            end if;
        end if;      
    end process msg;

    -- Evaluate parameters
    pattern_int <= pattern when pattern_reg = "UNREGISTERED" else pattern_rgd;
    wrx_int     <= wrx when wrx_reg = "UNREGISTERED" else wrx_rgd;
    wrxused_int <= wrxused when wrx_reg = "UNREGISTERED" else wrxused_rgd;
    maddress    <= maddress_int when output_reg = "UNREGISTERED" else maddress_rgd;
    mbits       <= mbits_int when output_reg = "UNREGISTERED" else mbits_rgd;
    mcount      <= mcount_int when output_reg = "UNREGISTERED" else mcount_rgd;
    mfound      <= mfound_int when output_reg = "UNREGISTERED" else mfound_rgd;
    wrbusy      <= wrbusy_int;
    rdbusy      <= rdbusy_int;
    outclock_int <= outclock when output_reg = "OUTCLOCK" else inclock;
    outaclr_int  <= outaclr when output_reg = "OUTCLOCK" else inaclr;

    rdbusy_delayed <= rdbusy_int after 2 ns;

    mstart_update: process (mstart)
    begin
        mstart_used <= true;
    end process mstart_update;


    -----------------------------------------
    -- Evaluate ALTCAM reading and writing --
    -----------------------------------------
    read_write: process (inaclr, inclock, pattern)
    variable count : natural := 0;
    variable index : natural :=0;
    variable addr : natural :=0;
    variable next_search : natural := 0;
    variable restart_read : boolean := false;
    variable reset_read : boolean := true;
    variable ipattern: std_logic_vector(width-1 downto 0); 
    variable iwraddress: std_logic_vector(widthad-1 downto 0);
    variable iwrx: std_logic_vector(width-1 downto 0); 
    variable iwren: std_logic;
    variable iwrxused : std_logic;
    variable mbits_tmp: std_logic_vector(numwords-1 downto 0);
    variable cam_array_tmp: lpm_memory;
    variable x_array_tmp: lpm_memory;
    begin
        -- Initialise the CAM at startup.
        if cam_init = 1  then 
            if lpm_file = "UNUSED" then
                for i in 0 to numwords-1 loop
                    cam_array(i) <= (others => '1');
                    x_array(i) <= (others => '1');
                end loop;
            elsif lpm_filex = "UNUSED" then
                cam_array <= hex_to_stdlogicarray(lpm_file);
                for i in 0 to numwords-1 loop
                    x_array(i) <= (others => '0');
                end loop;
            else
                cam_array <= hex_to_stdlogicarray(lpm_file);
                x_array <= hex_to_stdlogicarray(lpm_filex);
            end if;
            if match_mode /= "SINGLE" then
                maddress_int <= (others => '1');
            end if;
        end if;
        cam_init <= 0;

        ipattern := pattern;
        iwrx := wrx;
        iwraddress := wraddress;
        iwren := wren;
        if (wrx_reg = "UNUSED") or (wrx_aclr = "UNUSED") then
            iwrxused := '0';  -- must be unconnected
        else
            iwrxused := wrxused;
        end if;
        
        if inaclr = '1' then
            if (mstart_used = true) then
                reset_read := true;
            end if;
            first_read_clock <= false;
            get_first_match <= false;
            if pattern_aclr = "ON" then 
                pattern_rgd <= (others => '0'); 
                ipattern := (others => '0'); 
            end if;
            if wrx_aclr = "ON" then 
                wrx_rgd <= (others => '0'); 
                iwrx := (others => '0'); 
                wrxused_rgd <= '0';
                iwrxused := '0';
            end if;
            if wraddress_aclr = "ON" then 
                wraddress_rgd <= (others => '0'); 
                iwraddress := (others => '0'); 
            end if;
            if wrcontrol_aclr = "ON" then 
                wren_rgd <= '0'; 
                iwren := '0'; 
                write0_done <= false;
                write1_done <= false;
                writex_done <= false;
            end if;
            if (pattern_aclr = "ON") then 
                mbits_int <= (others => '0');
                mcount_int <= (others => '0');
                mfound_int <= '0';
                if (match_mode = "SINGLE") then
                    maddress_int <= (others => '0');
                else 
                    maddress_int <= (others => '1');
                end if;
            end if;
        end if;

        if inclock'event and (inclocken = '1') then
          if inclock = '1' then
            pattern_rgd <= ipattern;
            wrx_rgd <= iwrx;
            wrxused_rgd <= iwrxused;
            wraddress_rgd <= iwraddress;
            wren_rgd <= iwren;

            write_start_rgd <= write_start;
            write_incomplete <= wrbusy_int;
            mstart_rgd1 <= mstart;
            mstart_rgd2 <= mstart_rgd1;
            wrdelete_rgd <= wrdelete;

            if iwren = '0' then
                write0_done <= false;
                write1_done <= false;
                writex_done <= false;
                --------------------
                -- CAM READ MODES --
                --------------------
                -- If pattern changed or mstart asserted again then restart
                -- read cycle.
                if (match_mode = "FAST_MULTIPLE" and mstart_used = false and reset_read = true) 
                    or (mstart = '1' and mstart_rgd1 = '0')
                    or ((ipattern /= pattern_rgd) and (reset_read=false)) then
                    restart_read := true;
                    reset_read := false;
                    get_first_match <= false;
                else
                    restart_read := false;
                end if;
                -------------------------
                -- FAST MULTIPLE: READ --
                -------------------------
                if match_mode = "FAST_MULTIPLE" then
                    if get_first_match = true and restart_read = false then
                        if get_next_match = true then -- start of next read cycle
                            index := next_search; 
                            maddr_fm0: for i in index to numwords-1 loop
                                mword_fm0: for j in 0 to width-1 loop
                                    if (((x_array(i)(j) = '0') and (cam_array(i)(j) = ipattern(j))) or 
                                        ((x_array(i)(j) = '1') and (cam_array(i)(j) = '0'))) then
                                        if j = width-1 then 
                                            next_search := i+1;
                                            exit maddr_fm0;
                                        end if;
                                    else 
                                        exit mword_fm0;
                                    end if;
                                end loop mword_fm0;
                            end loop maddr_fm0;
                            if index = next_search then -- no more matches
                                mfound_int <= '0';
                                maddress_int <= (others => '1');
                            else
                                maddress_int <= ieee.std_logic_arith.conv_std_logic_vector(next_search-1, widthad);
                            end if;
                        end if;
                    else -- start of new read cycle
                        count := 0;
                        mbits_tmp := (others => '0');
                        maddr_fm1: for i in 0 to numwords -1 loop
                            mword_fm1: for j in 0 to width-1 loop
                                if (((x_array(i)(j) = '0') and (cam_array(i)(j) = ipattern(j))) or 
                                    ((x_array(i)(j) = '1') and (cam_array(i)(j) = '0'))) then
                                    if j = width-1 then 
                                        if (count = 0) and (reset_read = false) and (restart_read = true) then
                                            mfound_int <= '1';
                                            maddress_int <= ieee.std_logic_arith.conv_std_logic_vector(i, widthad);
                                            get_first_match <= true;
                                            next_search := i+1;
                                        end if;
                                        mbits_tmp(i) := '1';
                                        count := count + 1;
                                    end if;
                                else 
                                    exit mword_fm1;
                                end if;
                            end loop mword_fm1;
                        end loop maddr_fm1;
                        mcount_int <= ieee.std_logic_arith.conv_std_logic_vector(count, widthad);
                        mbits_int <= mbits_tmp;
                        if (count = 0) or (reset_read = true) then -- no matches
                            mfound_int <= '0';
                            maddress_int <= (others => '1');
                        end if;
                    end if; -- end of initial read cycle
                end if; -- end of FAST MULTIPLE

                --------------------
                -- MULTIPLE: READ --
                --------------------
                if match_mode = "MULTIPLE" then
                    if get_first_match = true and restart_read = false then
                        if get_next_match = true then -- start of next read cycle
                            index := next_search; 
                            maddr_mm0: for i in index to numwords-1 loop
                                mword_mm0: for j in 0 to width-1 loop
                                    if (((x_array(i)(j) = '0') and (cam_array(i)(j) = ipattern(j))) or 
                                        ((x_array(i)(j) = '1') and (cam_array(i)(j) = '0'))) then
                                        if j = width-1 then 
                                            next_search := i+1;
                                            exit maddr_mm0;
                                        end if;
                                    else 
                                        exit mword_mm0;
                                    end if;
                                end loop mword_mm0;
                            end loop maddr_mm0;
                            if index = next_search then
                                mfound_int <= '0';
                                maddress_int <= (others => '1');
                            else
                                maddress_int <= ieee.std_logic_arith.conv_std_logic_vector(next_search-1, widthad);
                            end if;
                        end if;
                    else -- start of 1st match 
                      count := 0;
                      if reset_read=false then -- Not in reset state
                        if first_read_clock = false then 
                            -- 1st cycle: match with even and write to even
                            first_read_clock <= true;
                            maddress_int <= (others => '1');
                            mfound_int <= '0';
                            mbits_tmp := mbits_int;
                            maddr_mm1: for i in 0 to numwords-1 loop
                                if (i mod 2)=0 then
                                    if mbits_int(i) = '1' then
                                        count := count + 1;
                                    end if;
                                    mword_mm1: for j in 0 to width-1 loop
                                        if (((x_array(i)(j) = '0') and (cam_array(i)(j) = ipattern(j))) or 
                                            ((x_array(i)(j) = '1') and (cam_array(i)(j) = '0'))) then
                                            if j = width-1 then 
                                                mbits_tmp(i+1) := '1';
                                                count := count + 1;
                                            end if;
                                        else 
                                            mbits_tmp(i+1) := '0';
                                            exit mword_mm1;
                                        end if;
                                    end loop mword_mm1;
                                end if;
                            end loop maddr_mm1;
                        else -- 2nd read cycle
                            -- 2nd cycle: do match 
                            first_read_clock <= false;
                            mbits_tmp := (others => '0');
                            maddr_mm2: for i in 0 to numwords-1 loop
                                mword_mm2: for j in 0 to width-1 loop
                                    if (((x_array(i)(j) = '0') and (cam_array(i)(j) = ipattern(j))) or 
                                        ((x_array(i)(j) = '1') and (cam_array(i)(j) = '0'))) then
                                        if j = width-1 then 
                                            if count = 0 then
                                                next_search := i+1;
                                            end if;
                                            mbits_tmp(i) := '1';
                                            count := count + 1;
                                        end if;
                                    else 
                                        exit mword_mm2;
                                    end if;
                                end loop mword_mm2;
                            end loop maddr_mm2;
                            if count = 0 then -- no matches
                                maddress_int <= (others => '1');
                                mfound_int <= '0';
                            else
                                get_first_match <= true;
                                mfound_int <= '1';
                                maddress_int <= ieee.std_logic_arith.conv_std_logic_vector(next_search-1, widthad);
                            end if;
                        end if;
                      else -- In reset state
                           -- Match with even but write to odd
                        maddress_int <= (others => '1');
                        mfound_int <= '0';
                        mbits_tmp := (others => '0');
                        maddr_mm3: for i in 0 to numwords-1 loop
                            if (i mod 2)=0 then
                                mword_mm3: for j in 0 to width-1 loop
                                    if (((x_array(i)(j) = '0') and (cam_array(i)(j) = ipattern(j))) or 
                                        ((x_array(i)(j) = '1') and (cam_array(i)(j) = '0'))) then
                                        if j = width-1 then 
                                            mbits_tmp(i+1) := '1';
                                            count := count + 1;
                                        end if;
                                    else 
                                        exit mword_mm3;
                                    end if;
                                end loop mword_mm3;
                            end if;
                        end loop maddr_mm3;
                      end if; -- end of 1st match
                      mcount_int <= ieee.std_logic_arith.conv_std_logic_vector(count, widthad);
                      mbits_int <= mbits_tmp;
                    end if; -- end of initial read cycle
                end if; -- end of MULTIPLE

                ------------------
                -- SINGLE: READ --
                ------------------
                if match_mode = "SINGLE" then
                    mbits_tmp := (others => '0');
                    index := 0;
                    count := 0;
                    maddr_sm0: for i in 0 to numwords-1 loop
                        mword_sm0: for j in 0 to width-1 loop
                               if (((x_array(i)(j) = '0') and (cam_array(i)(j) = ipattern(j))) or 
                                   ((x_array(i)(j) = '1') and (cam_array(i)(j) = '0'))) then
                                   if j = width-1 then 
                                       mbits_tmp(i) := '1';
                                       index := i;
                                       count := 1;
                                       exit maddr_sm0;
                                    end if;
                                else
                                    exit mword_sm0;
                                end if;
                        end loop mword_sm0;
                    end loop maddr_sm0;
                    mcount_int <= ieee.std_logic_arith.conv_std_logic_vector(count, widthad);
                    mbits_int <= mbits_tmp;
                    if count = 0 then
                        maddress_int <= (others => '0');
                        mfound_int <= '0';
                    else
                        mfound_int <= '1';
                        maddress_int <= ieee.std_logic_arith.conv_std_logic_vector(index, widthad);
                    end if;
                end if; -- end of SINGLE
            else -- if wren = '1' 
                ----------------------
                -- READ AFTER WRITE --
                ----------------------
                -- Writing to CAM so reset read cycle.
                get_first_match <= false;
                first_read_clock <= false;
                restart_read := false;
                if (mstart_used = true) then
                    reset_read := true;
                end if;
                -------------------------------------
                -- FAST MULTIPLE: READ AFTER WRITE --
                -------------------------------------
                if match_mode = "FAST_MULTIPLE" then
                    mfound_int <= '0';
                    maddress_int <= (others => '1');
                    count := 0;
                    mbits_tmp := (others => '0');
                    if (writex = true) and (iwrxused = '1') then
                        waddr_fm0: for i in 0 to numwords-1 loop
                            wword_fm0: for j in 0 to width-1 loop
                                if (((x_array(i)(j) = '0') and (cam_array(i)(j) = (ipattern(j) xor iwrx(j)))) or 
                                    ((x_array(i)(j) = '1') and (cam_array(i)(j) = '0'))) then
                                    if j = width-1 then 
                                        mbits_tmp(i) := '1';
                                        count := count + 1;
                                    end if;
                                else 
                                    exit wword_fm0;
                                end if;
                            end loop wword_fm0;
                        end loop waddr_fm0;
                    else
                        waddr_fm1: for i in 0 to numwords-1 loop
                            wword_fm1: for j in 0 to width-1 loop
                                if (((x_array(i)(j) = '0') and (cam_array(i)(j) = ipattern(j))) or 
                                    ((x_array(i)(j) = '1') and (cam_array(i)(j) = '0'))) then
                                    if j = width-1 then 
                                        mbits_tmp(i) := '1';
                                        count := count + 1;
                                    end if;
                                else 
                                    exit wword_fm1;
                                end if;
                            end loop wword_fm1;
                        end loop waddr_fm1;
                    end if;
                    mcount_int <= ieee.std_logic_arith.conv_std_logic_vector(count, widthad);
                    mbits_int <= mbits_tmp;
                end if; -- end of FAST MULTIPLE

                --------------------------------
                -- MULTIPLE: READ AFTER WRITE --
                --------------------------------
                -- THIS IMPLEMENTATION IS INACCURATE
                if match_mode = "MULTIPLE" then
                    mfound_int <= '0';
                    maddress_int <= (others => '1');
                    mbits_tmp := (others => '0');
                    if (writex = true) and (iwrxused = '1') then
                        mcount_int <= (others => '0');
                    else
                        if first_read_in_write = false then
                        -- Read even addresses but they appear on the odd locations
                        -- of mbits.
                        count := 0;
                        waddr_mm0: for i in 0 to numwords-1 loop
                            if ( (i mod 2) = 0 ) then
                                if (mbits_int(i) = '1') then -- counting previous even address matches
                                    count := count + 1;
                                end if;
                            wword_mm0: for j in 0 to width-1 loop
                                if (((x_array(i)(j) = '0') and (cam_array(i)(j) = ipattern(j))) or 
                                    ((x_array(i)(j) = '1') and (cam_array(i)(j) = '0'))) then
                                    if j = width-1 then 
                                        mbits_tmp(i+1) := '1';
                                        count := count + 1;
                                    end if;
                                else 
                                    exit wword_mm0;
                                end if;
                            end loop wword_mm0;
                            end if;
                        end loop waddr_mm0;
                        else
                        --  Read odd addresses. 
                        count := 0;
                        waddr_mm1: for i in numwords-1 downto 0 loop
                                if (i mod 2) = 1 then
                                mbits_tmp(i-1) := mbits_tmp(i);
                            else
                            wword_mm1: for j in 0 to width-1 loop
                                if (((x_array(i)(j) = '0') and (cam_array(i)(j) = ipattern(j))) or 
                                    ((x_array(i)(j) = '1') and (cam_array(i)(j) = '0'))) then
                                    if j = width-1 then 
                                        mbits_tmp(i) := '1';
                                        count := count + 1;
                                    end if;
                                else 
                                    exit wword_mm1;
                                end if;
                            end loop wword_mm1;
                            end if;
                        end loop waddr_mm1;
                        end if;
                        mcount_int <= ieee.std_logic_arith.conv_std_logic_vector(count, widthad);
                        mbits_int <= mbits_tmp;
                    end if;
                end if; -- end of MULTIPLE

                ------------------------------
                -- SINGLE: READ AFTER WRITE --
                ------------------------------
                if match_mode = "SINGLE" then
                    mbits_tmp := (others => '0');
                    index := 0;
                    count := 0;
                    if (writex = true) and (iwrxused = '1') then
                        waddr_sm0: for i in 0 to numwords-1 loop
                            wword_sm0: for j in 0 to width-1 loop
                                if (((x_array(i)(j) = '0') and (cam_array(i)(j) = (ipattern(j) xor iwrx(j)))) or 
                                    ((x_array(i)(j) = '1') and (cam_array(i)(j) = '0'))) then
                                    if j = width-1 then 
                                        mbits_tmp(i) := '1';
                                        index := i;
                                        count := 1;
                                        exit waddr_sm0;
                                    end if;
                                else 
                                    exit wword_sm0;
                                end if;
                            end loop wword_sm0;
                        end loop waddr_sm0;
                    else
                        waddr_sm1: for i in 0 to numwords-1 loop
                            wword_sm1: for j in 0 to width-1 loop
                                if (((x_array(i)(j) = '0') and (cam_array(i)(j) = ipattern(j))) or 
                                    ((x_array(i)(j) = '1') and (cam_array(i)(j) = '0'))) then
                                    if j = width-1 then 
                                        mbits_tmp(i) := '1';
                                        index := i;
                                        count := 1;
                                        exit waddr_sm1;
                                    end if;
                                else 
                                    exit wword_sm1;
                                end if;
                            end loop wword_sm1;
                        end loop waddr_sm1;
                    end if;
                    mcount_int <= ieee.std_logic_arith.conv_std_logic_vector(count, widthad);
                    mbits_int <= mbits_tmp;
                    if count = 0 then
                        mfound_int <= '0';
                        maddress_int <= (others => '0');
                    else
                        mfound_int <= '1';
                        maddress_int <= ieee.std_logic_arith.conv_std_logic_vector(index, widthad);
                    end if;
                end if; -- end of SINGLE
            end if; 
          else -- if inclock negedge
            -- We write to the CAM on the low cycle of inclock 
            -- when wren_rgd='1'.
            if (wren_rgd='1') and (inclock='0') then
                if pattern_reg = "UNREGISTERED" then
                    ipattern := pattern;
                else
                    ipattern := pattern_rgd;
                end if;
                addr := ieee.std_logic_unsigned.conv_integer(wraddress_rgd);
                cam_array_tmp := cam_array;
                x_array_tmp := x_array;
                ---------------------
                -- CAM WRITE MODES --
                ---------------------
                if wrdelete_rgd = '0' then
                    if (wrxused_int = '1') and (wrx_reg /= "UNUSED") and (wrx_aclr /= "UNUSED") then
                        ------------------- 
                        -- 3 CYCLE WRITE -- 
                        ------------------- 
                        ----------------- 
                        -- WRITE_ZEROS -- 
                        ----------------- 
                        if write0 = true then
                        for i in 0 to width-1 loop
                            if ipattern(i) = '0' then
                                -- "0" => "0"
                                if (cam_array(addr)(i)='0' and x_array(addr)(i)='0') then -- "0"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '0';
                                -- "1" => "X"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='0') then -- "1"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "X" => "X"
                                elsif (cam_array(addr)(i)='0' and x_array(addr)(i)='1') then -- "X"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "U" => "0"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='1') then -- "U"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '0';
                                end if;
                            elsif ipattern(i) = '1' then
                                -- "0" => "X"
                                if (cam_array(addr)(i)='0' and x_array(addr)(i)='0') then -- "0"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "1" => "1"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='0') then -- "1"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '0';
                                -- "X" => "X"
                                elsif (cam_array(addr)(i)='0' and x_array(addr)(i)='1') then -- "X"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "U" => "1"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='1') then -- "U"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '0';
                                end if;
                            end if;
                        end loop;
                        write0_done <= true;
                        write1_done <= false;
                        writex_done <= false;
                        end if;
                        ----------------
                        -- WRITE_ONES --
                        ----------------
                        if write1 = true then
                        for i in 0 to width-1 loop
                            if ipattern(i) = '0' then
                                -- "0" => "0"
                                if (cam_array(addr)(i)='0' and x_array(addr)(i)='0') then -- "0"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '0';
                                -- "1" => "U"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='0') then -- "1"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '1';
                                -- "X" => "0"
                                elsif (cam_array(addr)(i)='0' and x_array(addr)(i)='1') then -- "X"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '0';
                                -- "U" => "U"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='1') then -- "U"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '1';
                                end if;
                            elsif ipattern(i) = '1' then
                                -- "0" => "U"
                                if (cam_array(addr)(i)='0' and x_array(addr)(i)='0') then -- "0"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '1';
                                -- "1" => "1"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='0') then -- "1"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '0';
                                -- "X" => "1"
                                elsif (cam_array(addr)(i)='0' and x_array(addr)(i)='1') then -- "X"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '0';
                                -- "U" => "U"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='1') then -- "U"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '1';
                                end if;
                            end if;
                        end loop;
                        write0_done <= false;
                        write1_done <= true;
                        writex_done <= false;
                        end if;
                        -------------
                        -- WRITE_X --
                        -------------
                        if writex = true then
                            for i in 0 to width-1 loop
                            if (ipattern(i) xor wrx_int(i)) = '0' then
                                -- "0" => "0"
                                if (cam_array(addr)(i)='0' and x_array(addr)(i)='0') then -- "0"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '0';
                                -- "1" => "X"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='0') then -- "1"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "X" => "X"
                                elsif (cam_array(addr)(i)='0' and x_array(addr)(i)='1') then -- "X"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "U" => "0"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='1') then -- "U"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '0';
                                end if;
                            elsif (ipattern(i) xor wrx_int(i)) = '1' then
                                -- "0" => "X"
                                if (cam_array(addr)(i)='0' and x_array(addr)(i)='0') then -- "0"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "1" => "1"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='0') then -- "1"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '0';
                                -- "X" => "X"
                                elsif (cam_array(addr)(i)='0' and x_array(addr)(i)='1') then -- "X"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "U" => "1"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='1') then -- "U"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '0';
                                end if;
                            end if;
                        end loop;
                        writex_done <= true;
                        write0_done <= false;
                        write1_done <= false;
                        end if;

                        if wrbusy_int = '1' then
                            write_start_1 <= '1';
                            write_start <= write_start_1;
                        else
                            write_start_1 <= '0';
                            write_start <= '0';
                        end if;
                    else -- 2 Cycle write
                        ------------------- 
                        -- 2 CYCLE WRITE -- 
                        ------------------- 
                        ----------------- 
                        -- WRITE_ZEROS -- 
                        ----------------- 
                        if write0 = true then
                        for i in 0 to width-1 loop
                            if ipattern(i) = '0' then
                                -- "0" => "0"
                                if (cam_array(addr)(i)='0' and x_array(addr)(i)='0') then -- "0"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '0';
                                -- "1" => "X"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='0') then -- "1"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "X" => "X"
                                elsif (cam_array(addr)(i)='0' and x_array(addr)(i)='1') then -- "X"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "U" => "0"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='1') then -- "U"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '0';
                                end if;
                            elsif ipattern(i) = '1' then
                                -- "0" => "X"
                                if (cam_array(addr)(i)='0' and x_array(addr)(i)='0') then -- "0"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "1" => "1"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='0') then -- "1"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '0';
                                -- "X" => "X"
                                elsif (cam_array(addr)(i)='0' and x_array(addr)(i)='1') then -- "X"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "U" => "1"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='1') then -- "U"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '0';
                                end if;
                            end if;
                        end loop;
                        write0_done <= true;
                        write1_done <= false;
                        writex_done <= false;
                        end if;
                        ----------------
                        -- WRITE_ONES --
                        ----------------
                        if write1 = true then
                        for i in 0 to width-1 loop
                            if ipattern(i) = '0' then
                                -- "0" => "0"
                                if (cam_array(addr)(i)='0' and x_array(addr)(i)='0') then -- "0"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '0';
                                -- "1" => "U"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='0') then -- "1"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '1';
                                -- "X" => "0"
                                elsif (cam_array(addr)(i)='0' and x_array(addr)(i)='1') then -- "X"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '0';
                                -- "U" => "U"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='1') then -- "U"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '1';
                                end if;
                            elsif ipattern(i) = '1' then
                                -- "0" => "U"
                                if (cam_array(addr)(i)='0' and x_array(addr)(i)='0') then -- "0"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '1';
                                -- "1" => "1"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='0') then -- "1"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '0';
                                -- "X" => "1"
                                elsif (cam_array(addr)(i)='0' and x_array(addr)(i)='1') then -- "X"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '0';
                                -- "U" => "U"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='1') then -- "U"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '1';
                                end if;
                            end if;
                        end loop;
                        write0_done <= false;
                        write1_done <= true;
                        writex_done <= false;
                        end if;

                        if wrbusy_int = '1' then
                            write_start <= '1';
                        else
                            write_start <= '0';
                        end if;
                    end if; -- wrxused_int
                else -- if wrdelete = '1' then
                    -------------------- 
                    -- 2 CYCLE DELETE -- 
                    -------------------- 
                    -- Delete is a 2-cycle write
                    ----------------
                    -- WRITE_ONES --
                    ----------------
                    if write0 = true then
                        for i in 0 to width-1 loop
                            cam_array_tmp(addr)(i) := '1';
                        end loop;
                        write0_done <= true;
                        write1_done <= false;
                        writex_done <= false;
                    end if;
                    -------------
                    -- WRITE_X --
                    -------------
                    if write1 = true then
                        for i in 0 to width-1 loop
                            x_array_tmp(addr)(i) := '1';
                        end loop;
                        write1_done <= true;
                        write0_done <= false;
                        writex_done <= false;
                    end if;

                    if wrbusy_int = '1' then
                        write_start <= '1';
                    else
                        write_start <= '0';
                    end if;
                end if; -- wrdelete

                cam_array <= cam_array_tmp;
                x_array <= x_array_tmp;

                --------------------------------------
                -- FAST MULTIPLE: READ DURING WRITE --
                --------------------------------------
                -- Now we need to update mbits, mcount during the write.
                if match_mode = "FAST_MULTIPLE" then
                    mfound_int <= '0';
                    maddress_int <= (others => '1');
                    count := 0;
                    mbits_tmp := (others => '0');
                    if (writex = true) and (wrxused_int = '1') then
                        waddr_fm2: for i in 0 to numwords-1 loop
                            wword_fm2: for j in 0 to width-1 loop
                                if (((x_array_tmp(i)(j) = '0') and (cam_array_tmp(i)(j) = (ipattern(j) xor wrx_int(j)))) or 
                                    ((x_array_tmp(i)(j) = '1') and (cam_array_tmp(i)(j) = '0'))) then
                                    if j = width-1 then 
                                        mbits_tmp(i) := '1';
                                        count := count + 1;
                                    end if;
                                else 
                                    exit wword_fm2;
                                end if;
                            end loop wword_fm2;
                        end loop waddr_fm2;
                    else
                        waddr_fm3: for i in 0 to numwords-1 loop
                            wword_fm3: for j in 0 to width-1 loop
                                if (((x_array_tmp(i)(j) = '0') and (cam_array_tmp(i)(j) = ipattern(j))) or 
                                    ((x_array_tmp(i)(j) = '1') and (cam_array_tmp(i)(j) = '0'))) then
                                    if j = width-1 then 
                                        mbits_tmp(i) := '1';
                                        count := count + 1;
                                    end if;
                                else 
                                    exit wword_fm3;
                                end if;
                            end loop wword_fm3;
                        end loop waddr_fm3;
                    end if;
                    mcount_int <= ieee.std_logic_arith.conv_std_logic_vector(count, widthad);
                    mbits_int <= mbits_tmp;
                end if; -- end of FAST MULTIPLE

                ---------------------------------
                -- MULTIPLE: READ DURING WRITE --
                ---------------------------------
                -- THIS IMPLEMENTATION IS INACCURATE
                if match_mode = "MULTIPLE" then
                    mfound_int <= '0';
                    maddress_int <= (others => '1');
                    mbits_tmp := (others => '0');
                    if (writex = true) and (wrxused_int = '1') then
                        mcount_int <= (others => '0');
                        first_read_in_write <= false;
                    else
                        if first_read_in_write = false then
                        first_read_in_write <= true;
                        -- Read even addresses but they appear on the odd locations
                        -- of mbits.
                        count := 0;
                        waddr_mm2: for i in 0 to numwords-1 loop
                            if ( (i mod 2) = 0 ) then
                                if (mbits_int(i) = '1') then -- counting previous even address matches
                                    count := count + 1;
                                end if;
                            wword_mm2: for j in 0 to width-1 loop
                                if (((x_array_tmp(i)(j) = '0') and (cam_array_tmp(i)(j) = ipattern(j))) or 
                                    ((x_array_tmp(i)(j) = '1') and (cam_array_tmp(i)(j) = '0'))) then
                                    if j = width-1 then 
                                        mbits_tmp(i+1) := '1';
                                        count := count + 1;
                                    end if;
                                else 
                                    exit wword_mm2;
                                end if;
                            end loop wword_mm2;
                            end if;
                        end loop waddr_mm2;
                        else
                        first_read_in_write <= false;
                        --  Read odd addresses. 
                        count := 0;
                        waddr_mm3: for i in numwords-1 downto 0 loop
                                if (i mod 2) = 1 then
                                mbits_tmp(i-1) := mbits_tmp(i);
                            else
                            wword_mm3: for j in 0 to width-1 loop
                                if (((x_array_tmp(i)(j) = '0') and (cam_array_tmp(i)(j) = ipattern(j))) or 
                                    ((x_array_tmp(i)(j) = '1') and (cam_array_tmp(i)(j) = '0'))) then
                                    if j = width-1 then 
                                        mbits_tmp(i) := '1';
                                        count := count + 1;
                                    end if;
                                else 
                                    exit wword_mm3;
                                end if;
                            end loop wword_mm3;
                            end if;
                        end loop waddr_mm3;
                        end if;
                        mcount_int <= ieee.std_logic_arith.conv_std_logic_vector(count, widthad);
                        mbits_int <= mbits_tmp;
                    end if;
                end if; -- end of MULTIPLE
            
                ------------------------------
                -- SINGLE: READ DURING WRITE --
                ------------------------------
                if match_mode = "SINGLE" then
                    mbits_tmp := (others => '0');
                    index := 0;
                    count := 0;
                    if (writex = true) and (wrxused_int = '1') then
                        waddr_sm2: for i in 0 to numwords-1 loop
                            wword_sm2: for j in 0 to width-1 loop
                                if (((x_array_tmp(i)(j) = '0') and (cam_array_tmp(i)(j) = (ipattern(j) xor wrx_int(j)))) or 
                                    ((x_array_tmp(i)(j) = '1') and (cam_array_tmp(i)(j) = '0'))) then
                                    if j = width-1 then 
                                        mbits_tmp(i) := '1';
                                        index := i;
                                        count := 1;
                                        exit waddr_sm2;
                                    end if;
                                else 
                                    exit wword_sm2;
                                end if;
                            end loop wword_sm2;
                        end loop waddr_sm2;
                    else
                        waddr_sm3: for i in 0 to numwords-1 loop
                            wword_sm3: for j in 0 to width-1 loop
                                if (((x_array_tmp(i)(j) = '0') and (cam_array_tmp(i)(j) = ipattern(j))) or 
                                    ((x_array_tmp(i)(j) = '1') and (cam_array_tmp(i)(j) = '0'))) then
                                    if j = width-1 then 
                                        mbits_tmp(i) := '1';
                                        index := i;
                                        count := 1;
                                        exit waddr_sm3;
                                    end if;
                                else 
                                    exit wword_sm3;
                                end if;
                            end loop wword_sm3;
                        end loop waddr_sm3;
                    end if;
                    mcount_int <= ieee.std_logic_arith.conv_std_logic_vector(count, widthad);
                    mbits_int <= mbits_tmp;
                    if count = 0 then
                        mfound_int <= '0';
                        maddress_int <= (others => '0');
                    else
                        mfound_int <= '1';
                        maddress_int <= ieee.std_logic_arith.conv_std_logic_vector(index, widthad);
                    end if;
                end if; -- end of SINGLE
            end if; -- end of Write
          end if; -- end of inclock edges
        else -- if the pattern changes
            -- Only updating mbits, mcount, mfound and maddress if
            -- the pattern input in unregistered, wren_rgd='0' and the pattern
            -- patterb changes.
            if pattern'event and (pattern_reg="UNREGISTERED") then
            if wren_rgd='0' then
                ----------------------------------------
                -- FAST MULTIPLE: READ ON NEW PATTERN --
                ----------------------------------------
                if match_mode = "FAST_MULTIPLE" then
                    count := 0;
                    mbits_tmp := (others => '0');
                    maddr_fm2: for i in 0 to numwords-1 loop
                        mword_fm2: for j in 0 to width-1 loop
                            if (((x_array(i)(j) = '0') and (cam_array(i)(j) = pattern(j))) or 
                                ((x_array(i)(j) = '1') and (cam_array(i)(j) = '0'))) then
                                if j = width-1 then 
                                    if (count = 0) and (reset_read = false) then
                                        mfound_int <= '1';
                                        maddress_int <= ieee.std_logic_arith.conv_std_logic_vector(i, widthad);
                                    end if;
                                    mbits_tmp(i) := '1';
                                    count := count + 1;
                                end if;
                            else 
                                exit mword_fm2;
                            end if;
                        end loop mword_fm2;
                    end loop maddr_fm2;
                    mcount_int <= ieee.std_logic_arith.conv_std_logic_vector(count, widthad);
                    mbits_int <= mbits_tmp;
                    if (count = 0) or (reset_read = true) then
                        mfound_int <= '0';
                        maddress_int <= (others => '1');
                    end if;
                end if; -- end of FAST MULTIPLE

                -----------------------------------
                -- MULTIPLE: READ ON NEW PATTERN --
                -----------------------------------
                if match_mode = "MULTIPLE" then
                     count := 0;
                     mbits_tmp := mbits_int;
                     if reset_read = true then
                        maddr_mm4: for i in 0 to numwords-1 loop
                            if (i mod 2)=0 then
                                mword_mm4: for j in 0 to width-1 loop
                                    if (((x_array(i)(j) = '0') and (cam_array(i)(j) = pattern(j))) or 
                                        ((x_array(i)(j) = '1') and (cam_array(i)(j) = '0'))) then
                                        if j = width-1 then 
                                            mbits_tmp(i+1) := '1';
                                            count := count + 1;
                                        end if;
                                    else 
                                        mbits_tmp(i+1) := '0';
                                        exit mword_mm4;
                                    end if;
                                end loop mword_mm4;
                            end if;
                        end loop maddr_mm4;
                    else
                        -- Match odd addresses and write to odd
                        maddr_mm5: for i in 0 to numwords-1 loop
                            if (i mod 2)=1 then
                                mword_mm5: for j in 0 to width-1 loop
                                    if (((x_array(i)(j) = '0') and (cam_array(i)(j) = pattern(j))) or 
                                        ((x_array(i)(j) = '1') and (cam_array(i)(j) = '0'))) then
                                        if j = width-1 then 
                                            mbits_tmp(i) := '1';
                                            if (count = 0) then
                                                maddress_int <= ieee.std_logic_arith.conv_std_logic_vector(i, widthad);
                                            end if;
                                            count := count + 1;
                                        end if;
                                    else 
                                        mbits_tmp(i) := '0';
                                        exit mword_mm5;
                                    end if;
                                end loop mword_mm5;
                            else
                                if mbits_tmp(i) = '1' then
                                    if (count = 0) then
                                        maddress_int <= ieee.std_logic_arith.conv_std_logic_vector(i, widthad);
                                    end if;
                                    count := count + 1;
                                end if;
                            end if;
                        end loop maddr_mm5;
                        if count > 0 then
                            mfound_int <= '1';
                        else
                            mfound_int <= '0';
                            maddress_int <= (others => '1');
                        end if;
                    end if;
                    mcount_int <= ieee.std_logic_arith.conv_std_logic_vector(count, widthad);
                    mbits_int <= mbits_tmp;
                end if;

                ---------------------------------
                -- SINGLE: READ ON NEW PATTERN --
                ---------------------------------
                if match_mode = "SINGLE" then
                    mbits_tmp := (others => '0');
                    index := 0;
                    count := 0;
                    maddr_sm1: for i in 0 to numwords-1 loop
                        mword_sm1: for j in 0 to width-1 loop
                           if (((x_array(i)(j) = '0') and (cam_array(i)(j) = pattern(j))) or 
                               ((x_array(i)(j) = '1') and (cam_array(i)(j) = '0'))) then
                               if j = width-1 then 
                                   mbits_tmp(i) := '1';
                                   count := 1;
                                   index := i;
                                   exit maddr_sm1;
                                end if;
                            else
                                exit mword_sm1;
                            end if;
                        end loop mword_sm1;
                    end loop maddr_sm1;
                    mcount_int <= ieee.std_logic_arith.conv_std_logic_vector(count, widthad);
                    mbits_int <= mbits_tmp;
                    if count = 0 then
                        maddress_int <= (others => '0');
                        mfound_int <= '0';
                    else
                        mfound_int <= '1';
                        maddress_int <= ieee.std_logic_arith.conv_std_logic_vector(index, widthad);
                    end if;
                end if; -- end of SINGLE
            else
            -- We write to the CAM on the low cycle of inclock 
            -- when wren_rgd='1' and pattern changes.
            if (wren_rgd='1') and (inclock='0') then
                addr := ieee.std_logic_unsigned.conv_integer(wraddress_rgd);
                cam_array_tmp := cam_array;
                x_array_tmp := x_array;
                ---------------------
                -- CAM WRITE MODES --
                ---------------------
                if wrdelete_rgd = '0' then
                    if (wrxused_int = '1') and (wrx_reg /= "UNUSED") and (wrx_aclr /= "UNUSED") then
                        ------------------- 
                        -- 3 CYCLE WRITE -- 
                        ------------------- 
                        ----------------- 
                        -- WRITE_ZEROS -- 
                        ----------------- 
                        if write0_done = true then
                        for i in 0 to width-1 loop
                            if pattern(i) = '0' then
                                -- "0" => "0"
                                if (cam_array(addr)(i)='0' and x_array(addr)(i)='0') then -- "0"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '0';
                                -- "1" => "X"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='0') then -- "1"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "X" => "X"
                                elsif (cam_array(addr)(i)='0' and x_array(addr)(i)='1') then -- "X"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "U" => "0"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='1') then -- "U"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '0';
                                end if;
                            elsif pattern(i) = '1' then
                                -- "0" => "X"
                                if (cam_array(addr)(i)='0' and x_array(addr)(i)='0') then -- "0"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "1" => "1"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='0') then -- "1"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '0';
                                -- "X" => "X"
                                elsif (cam_array(addr)(i)='0' and x_array(addr)(i)='1') then -- "X"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "U" => "1"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='1') then -- "U"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '0';
                                end if;
                            end if;
                        end loop;
                        end if;
                        ----------------
                        -- WRITE_ONES --
                        ----------------
                        if write1_done = true then
                        for i in 0 to width-1 loop
                            if pattern(i) = '0' then
                                -- "0" => "0"
                                if (cam_array(addr)(i)='0' and x_array(addr)(i)='0') then -- "0"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '0';
                                -- "1" => "U"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='0') then -- "1"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '1';
                                -- "X" => "0"
                                elsif (cam_array(addr)(i)='0' and x_array(addr)(i)='1') then -- "X"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '0';
                                -- "U" => "U"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='1') then -- "U"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '1';
                                end if;
                            elsif pattern(i) = '1' then
                                -- "0" => "U"
                                if (cam_array(addr)(i)='0' and x_array(addr)(i)='0') then -- "0"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '1';
                                -- "1" => "1"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='0') then -- "1"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '0';
                                -- "X" => "1"
                                elsif (cam_array(addr)(i)='0' and x_array(addr)(i)='1') then -- "X"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '0';
                                -- "U" => "U"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='1') then -- "U"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '1';
                                end if;
                            end if;
                        end loop;
                        end if;
                        -------------
                        -- WRITE_X --
                        -------------
                        if writex_done = true then
                            for i in 0 to width-1 loop
                            if (pattern(i) xor wrx_int(i)) = '0' then
                                -- "0" => "0"
                                if (cam_array(addr)(i)='0' and x_array(addr)(i)='0') then -- "0"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '0';
                                -- "1" => "X"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='0') then -- "1"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "X" => "X"
                                elsif (cam_array(addr)(i)='0' and x_array(addr)(i)='1') then -- "X"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "U" => "0"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='1') then -- "U"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '0';
                                end if;
                            elsif (pattern(i) xor wrx_int(i)) = '1' then
                                -- "0" => "X"
                                if (cam_array(addr)(i)='0' and x_array(addr)(i)='0') then -- "0"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "1" => "1"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='0') then -- "1"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '0';
                                -- "X" => "X"
                                elsif (cam_array(addr)(i)='0' and x_array(addr)(i)='1') then -- "X"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "U" => "1"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='1') then -- "U"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '0';
                                end if;
                            end if;
                        end loop;
                        end if;
                    else -- 2 Cycle write
                        ------------------- 
                        -- 2 CYCLE WRITE -- 
                        ------------------- 
                        ----------------- 
                        -- WRITE_ZEROS -- 
                        ----------------- 
                        if write0_done = true then
                        for i in 0 to width-1 loop
                            if pattern(i) = '0' then
                                -- "0" => "0"
                                if (cam_array(addr)(i)='0' and x_array(addr)(i)='0') then -- "0"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '0';
                                -- "1" => "X"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='0') then -- "1"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "X" => "X"
                                elsif (cam_array(addr)(i)='0' and x_array(addr)(i)='1') then -- "X"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "U" => "0"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='1') then -- "U"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '0';
                                end if;
                            elsif pattern(i) = '1' then
                                -- "0" => "X"
                                if (cam_array(addr)(i)='0' and x_array(addr)(i)='0') then -- "0"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "1" => "1"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='0') then -- "1"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '0';
                                -- "X" => "X"
                                elsif (cam_array(addr)(i)='0' and x_array(addr)(i)='1') then -- "X"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '1';
                                -- "U" => "1"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='1') then -- "U"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '0';
                                end if;
                            end if;
                        end loop;
                        end if;
                        ----------------
                        -- WRITE_ONES --
                        ----------------
                        if write1_done = true then
                        for i in 0 to width-1 loop
                            if pattern(i) = '0' then
                                -- "0" => "0"
                                if (cam_array(addr)(i)='0' and x_array(addr)(i)='0') then -- "0"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '0';
                                -- "1" => "U"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='0') then -- "1"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '1';
                                -- "X" => "0"
                                elsif (cam_array(addr)(i)='0' and x_array(addr)(i)='1') then -- "X"
                                    cam_array_tmp(addr)(i) := '0';
                                    x_array_tmp(addr)(i) := '0';
                                -- "U" => "U"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='1') then -- "U"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '1';
                                end if;
                            elsif pattern(i) = '1' then
                                -- "0" => "U"
                                if (cam_array(addr)(i)='0' and x_array(addr)(i)='0') then -- "0"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '1';
                                -- "1" => "1"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='0') then -- "1"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '0';
                                -- "X" => "1"
                                elsif (cam_array(addr)(i)='0' and x_array(addr)(i)='1') then -- "X"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '0';
                                -- "U" => "U"
                                elsif (cam_array(addr)(i)='1' and x_array(addr)(i)='1') then -- "U"
                                    cam_array_tmp(addr)(i) := '1';
                                    x_array_tmp(addr)(i) := '1';
                                end if;
                            end if;
                        end loop;
                        end if;
                    end if; -- wrxused_int
                else -- if wrdelete = '1' then
                    -------------------- 
                    -- 2 CYCLE DELETE -- 
                    -------------------- 
                    -- Delete is a 2-cycle write
                    ----------------
                    -- WRITE_ONES --
                    ----------------
                    if write0_done = true then
                        for i in 0 to width-1 loop
                            cam_array_tmp(addr)(i) := '1';
                        end loop;
                    end if;
                    -------------
                    -- WRITE_X --
                    -------------
                    if write1_done = true then
                        for i in 0 to width-1 loop
                            x_array_tmp(addr)(i) := '1';
                        end loop;
                    end if;
                end if; -- wrdelete

                cam_array <= cam_array_tmp;
                x_array <= x_array_tmp;

                --------------------------------------
                -- FAST MULTIPLE: READ DURING WRITE --
                --------------------------------------
                -- Now we need to update mbits, mcount during the write.
                if match_mode = "FAST_MULTIPLE" then
                    mfound_int <= '0';
                    maddress_int <= (others => '1');
                    count := 0;
                    mbits_tmp := (others => '0');
                    if (writex_done = true) and (wrxused_int = '1') then
                        waddr_fm_2: for i in 0 to numwords-1 loop
                            wword_fm_2: for j in 0 to width-1 loop
                                if (((x_array_tmp(i)(j) = '0') and (cam_array_tmp(i)(j) = (pattern(j) xor wrx_int(j)))) or 
                                    ((x_array_tmp(i)(j) = '1') and (cam_array_tmp(i)(j) = '0'))) then
                                    if j = width-1 then 
                                        mbits_tmp(i) := '1';
                                        count := count + 1;
                                    end if;
                                else 
                                    exit wword_fm_2;
                                end if;
                            end loop wword_fm_2;
                        end loop waddr_fm_2;
                    else
                        waddr_fm_3: for i in 0 to numwords-1 loop
                            wword_fm_3: for j in 0 to width-1 loop
                                if (((x_array_tmp(i)(j) = '0') and (cam_array_tmp(i)(j) = pattern(j))) or 
                                    ((x_array_tmp(i)(j) = '1') and (cam_array_tmp(i)(j) = '0'))) then
                                    if j = width-1 then 
                                        mbits_tmp(i) := '1';
                                        count := count + 1;
                                    end if;
                                else 
                                    exit wword_fm_3;
                                end if;
                            end loop wword_fm_3;
                        end loop waddr_fm_3;
                    end if;
                    mcount_int <= ieee.std_logic_arith.conv_std_logic_vector(count, widthad);
                    mbits_int <= mbits_tmp;
                end if; -- end of FAST MULTIPLE

                ---------------------------------
                -- MULTIPLE: READ DURING WRITE --
                ---------------------------------
                -- THIS IMPLEMENTATION IS INACCURATE
                if match_mode = "MULTIPLE" then
                    mfound_int <= '0';
                    maddress_int <= (others => '1');
                    mbits_tmp := (others => '0');
                    if (writex_done = true) and (wrxused_int = '1') then
                        mcount_int <= (others => '0');
                        first_read_in_write <= false;
                    else
                        if first_read_in_write = false then
                        first_read_in_write <= true;
                        -- Read even addresses but they appear on the odd locations
                        -- of mbits.
                        count := 0;
                        waddr_mm_2: for i in 0 to numwords-1 loop
                            if ( (i mod 2) = 0 ) then
                                if (mbits_int(i) = '1') then -- counting previous even address matches
                                    count := count + 1;
                                end if;
                            wword_mm_2: for j in 0 to width-1 loop
                                if (((x_array_tmp(i)(j) = '0') and (cam_array_tmp(i)(j) = pattern(j))) or 
                                    ((x_array_tmp(i)(j) = '1') and (cam_array_tmp(i)(j) = '0'))) then
                                    if j = width-1 then 
                                        mbits_tmp(i+1) := '1';
                                        count := count + 1;
                                    end if;
                                else 
                                    exit wword_mm_2;
                                end if;
                            end loop wword_mm_2;
                            end if;
                        end loop waddr_mm_2;
                        else
                        first_read_in_write <= false;
                        --  Read odd addresses. 
                        count := 0;
                        waddr_mm_3: for i in numwords-1 downto 0 loop
                                if (i mod 2) = 1 then
                                mbits_tmp(i-1) := mbits_tmp(i);
                            else
                            wword_mm_3: for j in 0 to width-1 loop
                                if (((x_array_tmp(i)(j) = '0') and (cam_array_tmp(i)(j) = pattern(j))) or 
                                    ((x_array_tmp(i)(j) = '1') and (cam_array_tmp(i)(j) = '0'))) then
                                    if j = width-1 then 
                                        mbits_tmp(i) := '1';
                                        count := count + 1;
                                    end if;
                                else 
                                    exit wword_mm_3;
                                end if;
                            end loop wword_mm_3;
                            end if;
                        end loop waddr_mm_3;
                        end if;
                        mcount_int <= ieee.std_logic_arith.conv_std_logic_vector(count, widthad);
                        mbits_int <= mbits_tmp;
                    end if;
                end if; -- end of MULTIPLE
            
                ------------------------------
                -- SINGLE: READ DURING WRITE --
                ------------------------------
                if match_mode = "SINGLE" then
                    mbits_tmp := (others => '0');
                    index := 0;
                    count := 0;
                    if (writex_done = true) and (wrxused_int = '1') then
                        waddr_sm_2: for i in 0 to numwords-1 loop
                            wword_sm_2: for j in 0 to width-1 loop
                                if (((x_array_tmp(i)(j) = '0') and (cam_array_tmp(i)(j) = (pattern(j) xor wrx_int(j)))) or 
                                    ((x_array_tmp(i)(j) = '1') and (cam_array_tmp(i)(j) = '0'))) then
                                    if j = width-1 then 
                                        mbits_tmp(i) := '1';
                                        index := i;
                                        count := 1;
                                        exit waddr_sm_2;
                                    end if;
                                else 
                                    exit wword_sm_2;
                                end if;
                            end loop wword_sm_2;
                        end loop waddr_sm_2;
                    else
                        waddr_sm_3: for i in 0 to numwords-1 loop
                            wword_sm_3: for j in 0 to width-1 loop
                                if (((x_array_tmp(i)(j) = '0') and (cam_array_tmp(i)(j) = pattern(j))) or 
                                    ((x_array_tmp(i)(j) = '1') and (cam_array_tmp(i)(j) = '0'))) then
                                    if j = width-1 then 
                                        mbits_tmp(i) := '1';
                                        index := i;
                                        count := 1;
                                        exit waddr_sm_3;
                                    end if;
                                else 
                                    exit wword_sm_3;
                                end if;
                            end loop wword_sm_3;
                        end loop waddr_sm_3;
                    end if;
                    mcount_int <= ieee.std_logic_arith.conv_std_logic_vector(count, widthad);
                    mbits_int <= mbits_tmp;
                    if count = 0 then
                        mfound_int <= '0';
                        maddress_int <= (others => '0');
                    else
                        mfound_int <= '1';
                        maddress_int <= ieee.std_logic_arith.conv_std_logic_vector(index, widthad);
                    end if;
                end if; -- end of SINGLE
                end if; -- end of Write
            end if; -- end of wren_rgd check
            end if; -- end of pattern change
        end if;  -- end of inclock event
    end process read_write;
    
    outputreg: process (outaclr_int, outclock_int)
    begin
        if output_reg = "OUTCLOCK" or output_reg = "INCLOCK" then
            if outaclr_int = '1' then
                if output_aclr = "ON" then 
                    maddress_rgd <= (others => '0');
                    mbits_rgd <= (others => '0');
                    mfound_rgd <= '0';
                    mcount_rgd <= (others => '0');
                end if;
            else
                if outclock_int'event and outclock_int = '1' and outclocken = '1' then
                    mbits_rgd <= mbits_int;
                    mcount_rgd <= mcount_int;
                    mfound_rgd <= mfound_int;
                    maddress_rgd <= maddress_int;
                end if;
            end if;
        end if;
    end process outputreg;

    write_busy_control: process(wren_rgd, wraddress_rgd, write_start_rgd) 
    begin
        if wren_rgd'event and wren_rgd = '0' then 
            wrbusy_int <= '0';
        elsif wren_rgd'event and wren_rgd = '1' then 
            wrbusy_int <= '1';
        elsif wraddress_rgd'event and wren_rgd = '1' then
            wrbusy_int <= '1';
        elsif write_start_rgd'event and write_start_rgd = '1' then
            wrbusy_int <= '0';
          elsif write_start_rgd'event and write_start_rgd = '0' and wren_rgd = '1' then
            wrbusy_int <= '1';
        end if;
    end process write_busy_control;

    write_control: process(write0_done, write1_done, writex_done, wrbusy_int)
    begin
        if wrbusy_int'event and wrbusy_int = '0' then 
            write0 <= false;
        end if;
        if wrbusy_int'event and wrbusy_int = '1' then
            write0 <= true;
            write1 <= false;
            writex <= false;
        else
            if write0_done'event and write0_done = true then
                write1 <= true;
                if (wrxused_int = '1') and (wrx_reg /= "UNUSED") and (wrx_aclr /= "UNUSED") then
                    write0 <= false;
                end if;
                else
                if write1_done'event and write1_done = true then
                    if (wrxused_int = '1') and (wrx_reg /= "UNUSED") and (wrx_aclr /= "UNUSED") then
                        writex <= true;
                    else 
                        writex <= false;
                    end if;
                    write1 <= false;
                else
                    if writex_done'event and writex_done = true then
                        write0 <= false;
                        write1 <= false;
                        writex <= false;
                    end if;
                end if;
            end if;
        end if;
    end process write_control;

    read_control: process(mstart_rgd1, mstart_rgd2, mnext, mstart_used)
    begin
        if mstart_used'event then
            -- 1st toggle of mstart
            get_next_match <= false;
        else
            if mstart_rgd1'event and mstart_rgd1 = '1' then
                if match_mode = "SINGLE" or match_mode = "FAST_MULTIPLE" then
                    rdbusy_int <= '0';
                else
                    rdbusy_int <= '1';  -- must be "MULTIPLE" mode
                end if;
            elsif mstart_rgd2'event and mstart_rgd2 = '1' then
                rdbusy_int <= '0'; 
            end if;
            if mnext'event  and mnext = '1' and get_first_match = true then
                get_next_match <= true;
            elsif mnext'event and mnext = '0' then
                get_next_match <= false;
            end if;
        end if;
    end process read_control;
end;



----------------------------------------------------------------------------
-- altclklock
----------------------------------------------------------------------------
--
-- Restrictions: 
--   1. NORMAL operation mode only 
--   2. Zero delay outputs
--
library ieee;
use ieee.std_logic_1164.all;

entity altclklock is
    generic
      ( inclock_period          : natural := 10000;
        inclock_settings        : string := "UNUSED";
        valid_lock_cycles       : natural := 5;
        invalid_lock_cycles     : natural := 5;
        valid_lock_multiplier   : natural := 1;
        invalid_lock_multiplier : natural := 1;
        operation_mode          : string := "NORMAL";
        clock0_boost            : natural := 1;
        clock0_divide           : natural := 1;
        clock1_boost            : natural := 1;
        clock1_divide           : natural := 1;
        clock2_boost            : natural := 1;
        clock2_divide           : natural := 1;
        clock_ext_boost         : natural := 1;
        clock_ext_divide        : natural := 1;
        clock0_settings         : string := "UNUSED";
        clock1_settings         : string := "UNUSED";
        clock2_settings         : string := "UNUSED";
        clock_ext_settings      : string := "UNUSED";
        outclock_phase_shift    : natural := 0;
        clock0_time_delay       : string := "0";
        clock1_time_delay       : string := "0";
        clock2_time_delay       : string := "0";
        clock_ext_time_delay    : string := "0";
        intended_device_family  : string := "APEX20KE" );
    port
      ( inclock   : in std_logic;
        inclocken : in std_logic := '1';
        fbin      : in std_logic := '1';
        clock0    : out std_logic;
        clock1    : out std_logic;
        clock2    : out std_logic;
        clock_ext : out std_logic;
        locked    : out std_logic );

    function time_delay ( s : string ) return TIME is
	variable len : integer := s'length;
	variable outclock_phase_shift_adj : integer := 0;
	variable sign : integer := 1;
	variable digit : integer;
	begin
        for i in 1 to len loop
			case s(i) is
				when '-' =>
                                        if i = 1 then
					    sign := -1;
                                        else
 				       	    ASSERT FALSE
					    REPORT "Illegal Character "&  s(i) & "in string parameter! "
					    SEVERITY ERROR;
                                        end if;
				when '0' =>
					digit := 0;
				when '1' =>
					digit := 1;
				when '2' =>
					digit := 2;
				when '3' =>
					digit := 3;
				when '4' =>
					digit := 4;
				when '5' =>
					digit := 5;
				when '6' =>
					digit := 6;
				when '7' =>
					digit := 7;
				when '8' =>
					digit := 8;
				when '9' =>
					digit := 9;
				when others =>
					ASSERT FALSE
					REPORT "Illegal Character "&  s(i) & "in string parameter! "
					SEVERITY ERROR;
			end case;
			outclock_phase_shift_adj := outclock_phase_shift_adj * 10 + digit;
	end loop;
        outclock_phase_shift_adj := outclock_phase_shift + sign*outclock_phase_shift_adj;
        while (outclock_phase_shift_adj < 0) loop
            outclock_phase_shift_adj := outclock_phase_shift_adj + inclock_period;
        end loop;
        while (outclock_phase_shift_adj >= inclock_period) loop
            outclock_phase_shift_adj := outclock_phase_shift_adj - inclock_period;
        end loop;
	return  outclock_phase_shift_adj * 1 ps;
    end;
end altclklock;

architecture behavior of altclklock is

signal pll0_half_period : TIME;
signal pll1_half_period : TIME;
signal pll2_half_period : TIME;
signal pll_ext_half_period : TIME;
signal new_clock0 : std_logic;
signal new_clock1 : std_logic;
signal new_clock2 : std_logic;
signal new_clock_ext : std_logic;
signal start_new_clock0 : std_logic;
signal start_new_clock1 : std_logic;
signal start_new_clock2 : std_logic;
signal start_new_clock_ext : std_logic;
signal phase_delay0 : TIME;
signal phase_delay1 : TIME;
signal phase_delay2 : TIME;
signal phase_delay_ext : TIME;
signal locked_int : std_logic := '0';
signal highcycle, lowcycle: time := 0 ps;
signal check_lock : std_logic := '0';

begin

    lock: process(inclock, inclocken, check_lock)    
    variable valid_inclock_edge_count       : integer := 0;
    variable invalid_inclock_edge_count     : integer := 0;
    variable inclock_started          : boolean := false;
    variable check_lock_time          : TIME;
    begin
    
        if locked_int = '0' then
            if inclock'event then
                locked <= '0';
            end if;
            check_lock_time := real(real(inclock_period)/2.0) * 1 ps;

            pll0_half_period <= real(real(real(clock0_divide)* real(inclock_period))/(2.0*real(clock0_boost))) * 1 ps;
            pll1_half_period <= real(real(real(clock1_divide)* real(inclock_period))/(2.0*real(clock1_boost))) * 1 ps;
            pll2_half_period <= real(real(real(clock2_divide)* real(inclock_period))/(2.0*real(clock2_boost))) * 1 ps;
            pll_ext_half_period <= real(real(real(clock_ext_divide)* real(inclock_period))/(2.0*real(clock_ext_boost))) * 1 ps;
      
            phase_delay0 <= time_delay(clock0_time_delay) + pll0_half_period;
            phase_delay1 <= time_delay(clock1_time_delay) + pll1_half_period;
            phase_delay2 <=  time_delay(clock2_time_delay) + pll2_half_period;
            phase_delay_ext <= time_delay(clock_ext_time_delay) + pll_ext_half_period;
    
            if ((inclock = '0') and ((clock0_boost/clock0_divide) mod 2 = 0) and (clock0_boost>clock0_divide)) then
                start_new_clock0 <= NOT inclock;
            else
                start_new_clock0 <= inclock;
            end if;
            if ((inclock = '0') and ((clock1_boost/clock1_divide) mod 2 = 0) and (clock1_boost>clock1_divide)) then
                start_new_clock1 <= NOT inclock;
            else
                start_new_clock1 <= inclock;
            end if;
            if intended_device_family = "MERCURY" then
                if ((inclock = '0') and ((clock2_boost/clock2_divide) mod 2 = 0) and (clock2_boost>clock2_divide)) then
                    start_new_clock2 <= NOT inclock;
                else
                    start_new_clock2 <= inclock;
                end if;
                if ((inclock = '0') and ((clock_ext_boost/clock_ext_divide) mod 2 = 0) and (clock_ext_boost>clock_ext_divide)) then
                    start_new_clock_ext <= NOT inclock;
                else
                    start_new_clock_ext <= inclock;
                end if;
            end if;
        end if;
          
        if inclocken = '0' then
            valid_inclock_edge_count := 0;
            invalid_inclock_edge_count := 0;
            locked_int <= '0';
            locked <= '0';
            inclock_started := false;
        elsif inclock'event then -- any inclock edge
            if locked_int = '1' then
                check_lock <= NOT check_lock after check_lock_time;
            end if;
            if inclock_started = false then
                if inclock = '1' then
                    highcycle <= NOW;
                    inclock_started := true;
                    valid_inclock_edge_count := 1;
                    invalid_inclock_edge_count := 0;
                elsif inclock = '0' then
                    lowcycle <= NOW;
                    inclock_started := true;
                    valid_inclock_edge_count := 0;
                    invalid_inclock_edge_count := 0;
                end if;
            elsif inclock = '1' then
                if ((NOW - lowcycle)*2 /= (1 ps * inclock_period)) then
                    invalid_inclock_edge_count := invalid_inclock_edge_count + 1;
                    valid_inclock_edge_count := 1;
                    ASSERT FALSE
                    REPORT "Duty cycle violation"
                    SEVERITY ERROR; 
                else
                    valid_inclock_edge_count := valid_inclock_edge_count + 1;
                    invalid_inclock_edge_count := 0;
                end if;
                highcycle <= NOW;
            elsif inclock = '0' then
                if ((NOW - highcycle)*2 /= (1 ps * inclock_period)) then
                    invalid_inclock_edge_count := invalid_inclock_edge_count + 1;
                    valid_inclock_edge_count := 1;
                    ASSERT FALSE
                    REPORT "Duty cycle violation"
                    SEVERITY ERROR; 
                else
                    valid_inclock_edge_count := valid_inclock_edge_count + 1;
                    invalid_inclock_edge_count := 0;
                end if;
                lowcycle <= NOW;
            end if;
            if (valid_inclock_edge_count >= valid_lock_cycles) and (NOW > 0 ps) then
                locked_int <= '1';
                locked <= '1';
                valid_inclock_edge_count := 0;
            else
                if (invalid_inclock_edge_count >= invalid_lock_cycles) and 
                    (invalid_inclock_edge_count > 0) and (NOW > 0 ps) then
                    locked_int <= '0';
                    locked <= '0';
                    invalid_inclock_edge_count := 0;
                end if;
            end if;
        else
            if check_lock'event and (locked_int = '1') then
                invalid_inclock_edge_count := invalid_inclock_edge_count + 1;
                if (invalid_inclock_edge_count >= invalid_lock_cycles) and 
                    (invalid_inclock_edge_count > 0) and (NOW > 0 ps) then
                    locked_int <= '0';
                    locked <= '0';
                    ASSERT FALSE
                    REPORT "altclklock out of lock."
                    SEVERITY WARNING; 
                else
                    check_lock <= NOT check_lock after check_lock_time;
                end if;
            end if;
        end if; -- inclocken
    end process;

    gen_clock0: process(new_clock0,locked_int)
    variable first_cycle: boolean := true;
    begin
        if locked_int = '1' then
            if first_cycle = true then
                clock0 <= start_new_clock0;
                new_clock0 <= not start_new_clock0 after phase_delay0;
            else
                clock0 <= new_clock0; 
                new_clock0 <= not new_clock0 after pll0_half_period;
            end if;
            first_cycle := false;
        else
            first_cycle := true;
            new_clock0 <= start_new_clock0;
        end if;
    end process;

    gen_clock1: process(new_clock1,locked_int)
    variable first_cycle: boolean := true;
    begin
        if locked_int = '1' then
            if first_cycle = true then
                clock1 <= start_new_clock1;
                new_clock1 <= not start_new_clock1 after phase_delay1;
            else
                clock1 <= new_clock1; 
                new_clock1 <= not new_clock1 after pll1_half_period;
            end if;
            first_cycle := false;
        else
            first_cycle := true;
            new_clock1 <= start_new_clock1;
        end if;
    end process;

    gen_clock2: process(new_clock2,locked_int)
    variable first_cycle: boolean := true;
    begin
        if intended_device_family = "MERCURY" then
            if locked_int = '1' then
                if first_cycle = true then
                    clock2 <= start_new_clock2;
                    new_clock2 <= not start_new_clock2 after phase_delay2;
                else
                    clock2 <= new_clock2; 
                    new_clock2 <= not new_clock2 after pll2_half_period;
                end if;
                first_cycle := false;
            else
                first_cycle := true;
                new_clock2 <= start_new_clock2;
            end if;
        end if;
    end process;

    gen_clock_ext: process(new_clock_ext,locked_int)
    variable first_cycle: boolean := true;
    begin
        if intended_device_family = "MERCURY" then
            if locked_int = '1' then
                if first_cycle = true then
                    clock_ext <= start_new_clock_ext;
                    new_clock_ext <= not start_new_clock_ext after phase_delay_ext;
                else
                    clock_ext <= new_clock_ext; 
                    new_clock_ext <= not new_clock_ext after pll_ext_half_period;
                end if;
                first_cycle := false;
            else
                first_cycle := true;
                new_clock_ext <= start_new_clock_ext;
            end if;
        end if;
    end process;

end behavior;


----------------------------------------------------------------------------
-- lvds receiver megafunction
----------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity altlvds_rx is
    generic
      ( number_of_channels     : natural;
        deserialization_factor : natural;
        registered_output      : string := "ON";
        inclock_period         : natural;
        clock_setting          : string := "UNUSED";
        intended_device_family : string := "APEX20KE");
    port
      ( rx_in           : in std_logic_vector(number_of_channels-1 downto 0);
        rx_inclock      : in std_logic;
        rx_deskew       : in std_logic := '0';
        rx_pll_enable   : in std_logic := '1';
        rx_out          : out std_logic_vector(deserialization_factor*number_of_channels -1 downto 0);
        rx_outclock     : out std_logic;
        rx_locked       : out std_logic );
end altlvds_rx;

architecture behavior of altlvds_rx is

type channel_cnt is array (number_of_channels-1 downto 0) of integer;

signal rx_out_rgd : std_logic_vector(deserialization_factor*number_of_channels -1 downto 0) := (others => '0');
signal rx_hold_rgd : std_logic_vector(deserialization_factor*number_of_channels -1 downto 0) := (others => '0');
signal rx_out_int : std_logic_vector(deserialization_factor*number_of_channels -1 downto 0);
signal data_out : std_logic_vector(deserialization_factor*number_of_channels -1 downto 0);
signal rx_clock0_int : std_logic;
signal rx_clock1_int : std_logic;
signal rx_pll_clk0 : std_logic;
signal rx_pll_clk1 : std_logic;
signal apex20ke_locked_int: std_logic;
signal apex20ke_pll_clk0: std_logic; 
signal apex20ke_pll_clk1: std_logic; 
signal mercury_locked_int: std_logic;
signal mercury_pll_clk0: std_logic; 
signal mercury_pll_clk1: std_logic; 
signal rx_mercury_slow_clock : std_logic;
signal rx_locked_int : std_logic;
signal deskew_done: std_logic_vector(number_of_channels-1 downto 0) := (others => '1');
signal calibrate: std_logic_vector(number_of_channels-1 downto 0) := (others => '0');
signal apex20ke_en: std_logic;
signal mercury_en: std_logic;
signal first_load : std_logic := '0';

component altclklock
    generic
      ( inclock_period       : natural := 10000;
        clock0_boost         : natural := 1;
        clock1_boost         : natural := 1;
        valid_lock_cycles    : natural := 1;
        intended_device_family  : string := "APEX20KE" );
    port
      ( inclock   : in std_logic;
        inclocken : in std_logic;
        clock0    : out std_logic;
        clock1    : out std_logic;
        locked    : out std_logic );
end component;

begin

    rx_out <= rx_out_rgd when registered_output = "ON" else rx_out_int;
    rx_out_int <= rx_hold_rgd when (deserialization_factor > 2 and deserialization_factor < 7) else data_out;
    rx_clock0_int <= rx_pll_clk0 when deserialization_factor > 1 else rx_inclock;
    rx_clock1_int <= rx_pll_clk1 when deserialization_factor > 1 else rx_inclock;
    rx_outclock <= rx_clock1_int;
    rx_locked <= rx_locked_int when deserialization_factor > 1 else '1';
    rx_pll_clk0 <= mercury_pll_clk0 when intended_device_family = "MERCURY" else apex20ke_pll_clk0;
    rx_pll_clk1 <= rx_mercury_slow_clock when intended_device_family = "MERCURY" else apex20ke_pll_clk1;
    rx_locked_int <= mercury_locked_int when intended_device_family = "MERCURY" else apex20ke_locked_int;
    apex20ke_en <= rx_pll_enable when ( intended_device_family = "APEX20KE" or intended_device_family = "APEX20KC" or
                                intended_device_family = "EXCALIBUR_ARM" or intended_device_family = "EXCALIBUR_MIPS") else '0';
    mercury_en <= rx_pll_enable when intended_device_family = "MERCURY" else '0';

    U0: altclklock -- APEX20KE PLL
            generic map
              ( inclock_period => inclock_period,
                clock0_boost => deserialization_factor, clock1_boost => 1,
                valid_lock_cycles => 5,
                intended_device_family => intended_device_family)
            port map
              ( inclock => rx_inclock, inclocken => apex20ke_en,
                clock0 => apex20ke_pll_clk0, clock1 => apex20ke_pll_clk1,
                locked => apex20ke_locked_int );
    U1: altclklock -- MERCURY PLL
            generic map
              ( inclock_period => inclock_period,
                clock0_boost => deserialization_factor, clock1_boost => 1,
                valid_lock_cycles => 3,
                intended_device_family => intended_device_family)
            port map
              ( inclock => rx_inclock, inclocken => mercury_en,
                clock0 => mercury_pll_clk0, clock1 => mercury_pll_clk1,
                locked => mercury_locked_int );

    msg: process  
    begin
        if (intended_device_family = "APEX20KE" or intended_device_family = "APEX20KC" or
             intended_device_family = "EXCALIBUR_ARM" or intended_device_family = "EXCALIBUR_MIPS") and
             (deserialization_factor /= 4) and (deserialization_factor /= 7) and (deserialization_factor /= 8) then
                ASSERT FALSE
                REPORT "APEX20KE does not support the specified deserialization factor!"
                SEVERITY ERROR;
        elsif (intended_device_family = "MERCURY") and
              (((deserialization_factor > 12) and (deserialization_factor /= 14)
                and (deserialization_factor /= 16) and (deserialization_factor /= 18)
                and (deserialization_factor /= 20)) or (deserialization_factor<3)) then
                ASSERT FALSE
                REPORT "MERCURY does not support the specified deserialization factor!"
                SEVERITY ERROR;
        end if;
        wait;
    end process;

    hssi_clkout: process (rx_clock0_int, mercury_pll_clk1)
    variable posedge_count: integer := 0;
    begin
        if deserialization_factor rem 2 = 0 then
            rx_mercury_slow_clock <= mercury_pll_clk1;
        else
            if mercury_pll_clk1'event and mercury_pll_clk1 = '1' then
                posedge_count := 0;
                rx_mercury_slow_clock <= mercury_pll_clk1;
            end if;
            if rx_clock0_int'event and rx_clock0_int = '1' then
                posedge_count := posedge_count+1;
            end if;
            if rx_clock0_int'event and (rx_clock0_int = '1') and (posedge_count=(deserialization_factor+1)/2+1) then
                rx_mercury_slow_clock <= NOT rx_mercury_slow_clock;
            end if;
        end if;
    end process;

    load_data: process(rx_clock0_int, rx_clock1_int, rx_deskew)
    variable edge_count: integer := 0;
    variable rxin_cnt: integer := 0;
    variable count: channel_cnt := (others => 0);
    variable sample: integer;
    variable start_data : integer := 0;
    variable pattern : std_logic_vector(deserialization_factor*number_of_channels -1 downto 0);
    variable data_int : std_logic_vector(deserialization_factor*number_of_channels -1 downto 0);
    begin
        if deserialization_factor > 1 then
            -- At start up deskew is done due to inability to detect unconnected
            -- rx_deskew pin.
            if (rx_deskew'event and rx_deskew = '1' and ( intended_device_family = "APEX20KE" or
                intended_device_family = "APEX20KC" or intended_device_family = "EXCALIBUR_ARM" or
                intended_device_family = "EXCALIBUR_MIPS") ) then
                deskew_done <= (others => '0');
                calibrate <= (others => '1');
            end if;
            if rx_clock1_int'event and rx_clock1_int = '1' then
                if rx_deskew = '0' then
                    calibrate <= (others => '0');
                end if;
                edge_count := 0;
                -- Deskewing is only for APEX20KE LVDS mode.
                if (deserialization_factor = 8)  then
                    for i in 0 to number_of_channels-1 loop
                        if calibrate(i) = '1' then
                            if (pattern(((deserialization_factor*(i+1))-1) downto deserialization_factor*i) = "00111100") then
                                count(i) := count(i) + 1;
                            else
                                count(i) := 0;
                            end if;
                            if count(i) >= 3 and rx_deskew = '0' then
                                deskew_done(i) <= '1' after ((inclock_period/deserialization_factor)*2 ps);
                            end if;
                        end if;
                    end loop;
                elsif (deserialization_factor= 7) then
                    for i in 0 to number_of_channels-1 loop
                        if calibrate(i) = '1' then
                            if (pattern((deserialization_factor*(i+1)-1) downto deserialization_factor*i) = "0011100") then
                                count(i) := count(i) + 1;
                            else
                                count(i) := 0;
                            end if;
                            if count(i) >= 3 and rx_deskew = '0' then
                                deskew_done(i) <= '1';
                            end if;
                        end if;
                    end loop;
                elsif (deserialization_factor= 4) then
                    for i in 0 to number_of_channels-1 loop
                        if calibrate(i) = '1' then
                            if (pattern(((deserialization_factor*(i+1))-1) downto deserialization_factor*i) = "1100") then
                                count(i) := count(i) + 1;
                            else
                                count(i) := 0;
                            end if;
                            if count(i) >= 3 and rx_deskew = '0' then
                                deskew_done(i) <= '1';
                            end if;
                        end if;
                    end loop;
                else
                    deskew_done <= (others => '1');
                end if;
            end if;
            if rx_clock0_int'event and rx_clock0_int = '0' then
                edge_count := edge_count + 1;
                if edge_count = 3 then
                    data_out <= data_int;
                    start_data := 1;
                    rxin_cnt := 0;
                end if;
                if start_data = 1 then
                    sample := rxin_cnt rem deserialization_factor;
                    rxin_cnt := rxin_cnt + 1;
                    for i in 0 to number_of_channels -1 loop
                        if deskew_done(i) = '1' then
                            -- Data gets shifted into MSB first.
                            data_int(((i+1)*deserialization_factor)-sample-1) := rx_in(i);
                        else
                            pattern(((i+1)*deserialization_factor)-sample-1) := rx_in(i);
                            data_int(((i+1)*deserialization_factor)-sample-1) := 'X';
                        end if;
                    end loop;
                end if;
            end if;
        else
            if rx_clock1_int'event and rx_clock1_int = '1' then
                data_out <= rx_in;
            end if;
       end if;
    end process;

    parallel_reg: process(rx_clock1_int)
    begin
        if deserialization_factor > 1 then
            if rx_clock1_int = '1' then
                rx_out_rgd <= rx_out_int;
            elsif (rx_clock1_int = '0') and ((deserialization_factor > 2) and (deserialization_factor < 7)) then
                    rx_hold_rgd <= data_out;
            end if;
        else
            if rx_clock1_int = '1' then
                rx_out_rgd <= rx_in;
            end if;
        end if;
    end process parallel_reg;

end behavior;


----------------------------------------------------------------------------
-- lvds transmitter megafunction 
----------------------------------------------------------------------------
    
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity altlvds_tx is
    generic
      ( number_of_channels     : natural;
        deserialization_factor : natural;
        outclock_divide_by     : natural := 0;
        registered_input       : string := "ON";
        multi_clock            : string := "OFF";
        inclock_period         : natural;
        clock_setting          : string := "UNUSED";
        intended_device_family : string := "APEX20KE");
    port
      ( tx_in           : in std_logic_vector(deserialization_factor*number_of_channels -1 downto 0);
        tx_inclock      : in std_logic;
        sync_inclock    : in std_logic := '0';
        tx_pll_enable   : in std_logic := '1';
        tx_out          : out std_logic_vector(number_of_channels-1 downto 0);
        tx_outclock     : out std_logic;
        tx_coreclock    : out std_logic;
        tx_locked       : out std_logic );
end altlvds_tx;

architecture behavior of altlvds_tx is

signal tx_hold_rgd : std_logic_vector(deserialization_factor*number_of_channels -1 downto 0) := (others => '0');
signal tx_rgd : std_logic_vector(deserialization_factor*number_of_channels -1 downto 0) := (others => '0');
signal tx_in_int, data_int : std_logic_vector(deserialization_factor*number_of_channels -1 downto 0);
signal tx_clock0_int: std_logic;
signal tx_clock1_int: std_logic;
signal tx_pll_clk0: std_logic; 
signal tx_pll_clk1: std_logic; 
signal tx_pll_clk2: std_logic; 
signal apex20ke_locked_int: std_logic;
signal apex20ke_pll_clk0: std_logic; 
signal apex20ke_pll_clk1: std_logic; 
signal mercury_locked_int: std_logic;
signal mercury_pll_clk0: std_logic; 
signal mercury_pll_clk1: std_logic; 
signal tx_mercury_core_clock : std_logic;
signal tx_rgd_clk: std_logic; 
signal tx_locked_int: std_logic; 
signal apex20ke_en: std_logic;
signal mercury_en: std_logic;

component altclklock
    generic
      ( inclock_period       : natural := 10000;
        clock0_boost         : natural := 1;
        clock1_boost         : natural := 1;
        clock2_boost         : natural := 1;
        clock2_divide        : natural := 1;
        valid_lock_cycles    : natural := 5;
        intended_device_family  : string := "APEX20KE" );
    port
      ( inclock   : in std_logic;
        inclocken : in std_logic;
        clock0    : out std_logic;
        clock1    : out std_logic;
        clock2    : out std_logic;
        locked    : out std_logic );
end component;

begin

    tx_in_int  <= tx_rgd when registered_input = "ON" else tx_in;
    tx_clock0_int <= tx_pll_clk0 when deserialization_factor > 1 else tx_inclock;
    tx_clock1_int <= tx_pll_clk1 when deserialization_factor > 1 else tx_inclock;
    tx_rgd_clk <= sync_inclock when multi_clock = "ON" else tx_inclock;
    tx_outclock <= tx_pll_clk2 when intended_device_family = "MERCURY" else tx_clock1_int;
    tx_coreclock <= tx_mercury_core_clock when (((deserialization_factor rem 2)/=0) and (intended_device_family = "MERCURY")) else tx_clock1_int;
    tx_locked <= tx_locked_int when deserialization_factor > 1 else '1';
    tx_pll_clk0 <= mercury_pll_clk0 when intended_device_family = "MERCURY" else apex20ke_pll_clk0;
    tx_pll_clk1 <= mercury_pll_clk1 when intended_device_family = "MERCURY" else apex20ke_pll_clk1;
    tx_locked_int <= mercury_locked_int when intended_device_family = "MERCURY" else apex20ke_locked_int;
    apex20ke_en <= tx_pll_enable when ( intended_device_family = "APEX20KE" or intended_device_family = "APEX20KC" or
                              intended_device_family = "EXCALIBUR_ARM" or intended_device_family = "EXCALIBUR_MIPS") else '0';
    mercury_en <= tx_pll_enable when intended_device_family = "MERCURY" else '0';

    U0: altclklock -- APEX20KE PLL
            generic map
              ( inclock_period => inclock_period,
                clock0_boost => deserialization_factor, clock1_boost => 1,
                valid_lock_cycles => 5,
                intended_device_family => intended_device_family)
            port map
              ( inclock => tx_inclock, inclocken => apex20ke_en,
                clock0 => apex20ke_pll_clk0, clock1 => apex20ke_pll_clk1,
                locked => apex20ke_locked_int );
    U1: altclklock -- MERCURY PLL
            generic map
              ( inclock_period => inclock_period,
                clock0_boost => deserialization_factor, clock1_boost => 1,
                clock2_boost => deserialization_factor, clock2_divide => outclock_divide_by,
                valid_lock_cycles => 3,
                intended_device_family => intended_device_family)
            port map
              ( inclock => tx_inclock, inclocken => mercury_en,
                clock0 => mercury_pll_clk0, clock1 => mercury_pll_clk1,
                clock2 => tx_pll_clk2, locked => mercury_locked_int );

    msg: process 
    begin
        if (intended_device_family = "APEX20KE" or intended_device_family = "APEX20KC" or
             intended_device_family = "EXCALIBUR_ARM" or intended_device_family = "EXCALIBUR_MIPS") and
             (deserialization_factor /= 4) and (deserialization_factor /= 7) and (deserialization_factor /= 8) then
                ASSERT FALSE
                REPORT "APEX20KE does not support the specified deserialization factor!"
                SEVERITY ERROR;
        elsif (intended_device_family = "MERCURY") and
              (((deserialization_factor > 12) and (deserialization_factor /= 14)
                and (deserialization_factor /= 16) and (deserialization_factor /= 18)
                and (deserialization_factor /= 20)) or (deserialization_factor<3)) then
                ASSERT FALSE
                REPORT "MERCURY does not support the specified deserialization factor!"
                SEVERITY ERROR;
        end if;
        wait;
    end process;

    serialize: process(tx_clock0_int, tx_clock1_int)
    variable posedge_count: integer := 0;
    variable negedge_count: integer := 0;
    variable shift_data : std_logic := '0';
    variable count: integer := 0;
    variable sample: integer;
    variable tx_in2: std_logic_vector(deserialization_factor*number_of_channels -1 downto 0);
    begin
        if deserialization_factor > 1 then
            if tx_clock1_int'event and tx_clock1_int = '1' then
                posedge_count := 0;
                negedge_count := 0;
            end if;
            if (tx_clock0_int'event and tx_clock0_int = '0') then
                negedge_count := negedge_count + 1;
                if negedge_count = 3 then
                    if ((deserialization_factor < 3) or (deserialization_factor > 6)) then
                        data_int <= tx_hold_rgd; 
                    else 
                        data_int <= tx_in_int;
                    end if;
                end if;
            end if;
            if (tx_clock0_int'event and tx_clock0_int = '1') then
                posedge_count := posedge_count + 1;
                if posedge_count = 3 then
                    tx_in2 := data_int; -- register the incoming data on the third falling edge
                    count := 0;
                    shift_data := '1'; -- third rising edge
                end if;
                if shift_data = '1' then
                    count := count + 1;
                    for i in 0 to number_of_channels-1 loop
                        -- Data in MSB gets shifted out first.
                        tx_out(i) <= tx_in2((i+1)*deserialization_factor - count);
                    end loop;
                end if;
            end if;
            -- Update asymmetrical outclock for MERCURY for odd deserial
            -- factors.
            if deserialization_factor rem 2 /= 0 then
                if tx_clock1_int'event and tx_clock1_int = '1' then
                    tx_mercury_core_clock <= tx_clock1_int;
                end if;
                if tx_clock0_int'event and (tx_clock0_int = '1') and (posedge_count=(deserialization_factor+1)/2+1) then
                    tx_mercury_core_clock <= NOT tx_mercury_core_clock;
                end if;
            end if;
        else
            if tx_clock1_int'event and tx_clock1_int = '1' then
                tx_out <= tx_in;
            end if;
        end if;
    end process;

    sync: process(tx_rgd_clk)
    begin
        if deserialization_factor > 1 then
            if (tx_rgd_clk = '0') and  ((deserialization_factor < 3) or (deserialization_factor > 6)) then
                tx_hold_rgd <= tx_in_int;
            elsif tx_rgd_clk = '1' then
                tx_rgd <= tx_in;
            end if;
        end if;
    end process sync;

end behavior;


----------------------------------------------------------------------------
-- altdpram megafunction
----------------------------------------------------------------------------
    
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use std.textio.all;

entity altdpram is
    generic
      ( width                  : natural;
        widthad                : natural;
        numwords               : natural := 0;
        lpm_file               : string := "UNUSED";
        lpm_hint               : string := "USE_EAB=ON";
        indata_reg             : string := "UNREGISTERED";
        indata_aclr            : string := "OFF";
        wraddress_reg          : string := "UNREGISTERED";
        wraddress_aclr         : string := "OFF";
        wrcontrol_reg          : string := "UNREGISTERED";
        wrcontrol_aclr         : string := "OFF";
        rdaddress_reg          : string := "UNREGISTERED";
        rdaddress_aclr         : string := "OFF";
        rdcontrol_reg          : string := "UNREGISTERED";
        rdcontrol_aclr         : string := "OFF";
        outdata_reg            : string := "UNREGISTERED";
        outdata_aclr           : string := "OFF";
        intended_device_family : string := "APEX20KE");
    port
      ( wren       : in std_logic := '0';
        data       : in std_logic_vector(width-1 downto 0);
        wraddress  : in std_logic_vector(widthad-1 downto 0);
        inclock    : in std_logic := '0';
        inclocken  : in std_logic := '1';
        rden       : in std_logic := '1';
        rdaddress  : in std_logic_vector(widthad-1 downto 0);
        outclock   : in std_logic := '0';
        outclocken : in std_logic := '1';
        aclr       : in std_logic := '0';
        q          : out std_logic_vector(width-1 downto 0) );

	function int_to_str( value : integer ) return string is
	variable ivalue,index : integer;
	variable digit : integer;
    variable line_no: string(8 downto 1) := "        ";  
	begin
		ivalue := value;
		index := 1;
		while (ivalue > 0) loop
			digit := ivalue MOD 10;
			ivalue := ivalue/10;
			case digit is
				when 0 =>
					line_no(index) := '0';
				when 1 =>
					line_no(index) := '1';
				when 2 =>
					line_no(index) := '2';
				when 3 =>
					line_no(index) := '3';
				when 4 =>
					line_no(index) := '4';
				when 5 =>
					line_no(index) := '5';
				when 6 =>
					line_no(index) := '6';
				when 7 =>
					line_no(index) := '7';
				when 8 =>
					line_no(index) := '8';
				when 9 =>
					line_no(index) := '9';
				when others =>
					ASSERT FALSE
					REPORT "Illegal number!"
					SEVERITY ERROR;
			end case;
			index := index + 1;
		end loop;
		return line_no;
	end;

	function hex_str_to_int( str : string ) return integer is
	variable len : integer := str'length;
	variable ivalue : integer := 0;
	variable digit : integer;
	begin
		for i in len downto 1 loop
			case str(i) is
				when '0' =>
					digit := 0;
				when '1' =>
					digit := 1;
				when '2' =>
					digit := 2;
				when '3' =>
					digit := 3;
				when '4' =>
					digit := 4;
				when '5' =>
					digit := 5;
				when '6' =>
					digit := 6;
				when '7' =>
					digit := 7;
				when '8' =>
					digit := 8;
				when '9' =>
					digit := 9;
				when 'A' =>
					digit := 10;
				when 'a' =>
					digit := 10;
				when 'B' =>
					digit := 11;
				when 'b' =>
					digit := 11;
				when 'C' =>
					digit := 12;
				when 'c' =>
					digit := 12;
				when 'D' =>
					digit := 13;
				when 'd' =>
					digit := 13;
				when 'E' =>
					digit := 14;
				when 'e' =>
					digit := 14;
				when 'F' =>
					digit := 15;
				when 'f' =>
					digit := 15;
				when others =>
					ASSERT FALSE
					REPORT "Illegal character "&  str(i) & "in Intel Hex File! "
					SEVERITY ERROR;
			end case;
			ivalue := ivalue * 16 + digit;
		end loop;
		return ivalue;
	end;

	procedure Shrink_line(L : inout LINE; pos : in integer) is
	subtype nstring is string(1 to pos);
	variable stmp : nstring;
	begin
		if pos >= 1 then
			read(l, stmp);
		end if;
	end;

end altdpram;

architecture behavior of altdpram is

type alt_memory is array((2**WIDTHAD)-1 downto 0) of std_logic_vector(WIDTH-1 downto 0);

signal idata_tmp, idata_reg : std_logic_vector(WIDTH-1 downto 0) := (OTHERS => '0');
signal idata_hi, idata_lo : std_logic_vector(WIDTH-1 downto 0) := (OTHERS => '0');
signal iq_tmp, iq_reg : std_logic_vector(WIDTH-1 downto 0) := (OTHERS => '0');
signal irdaddress_tmp, irdaddress_reg : std_logic_vector(WIDTHAD-1 downto 0) := (OTHERS => '0');
signal iwraddress_tmp, iwraddress_reg : std_logic_vector(WIDTHAD-1 downto 0) := (OTHERS => '0');
signal iwraddress_hi, iwraddress_lo : std_logic_vector(WIDTHAD-1 downto 0) := (OTHERS => '0');
signal iwren_tmp, iwren_reg : std_logic := '0';
signal iwren_hi, iwren_lo : std_logic := '0';
signal irden_tmp, irden_reg : std_logic := '0';
signal write_at_low_clock : boolean := false;
signal rden_low_output_0 : boolean := false;

begin
    initial: process (inclock, outclock)
    variable init : boolean := false;
    begin
        if (not init) then
            if (lpm_hint = "USE_EAB=ON") then
                if (wrcontrol_reg = "INCLOCK") then
                    write_at_low_clock <= true;
                end if;
                if (intended_device_family = "APEX20K") then
                    rden_low_output_0 <= true;
                end if;
            end if;
            init := true;
        end if;
    end process;

    sync: process(data, idata_reg, rden, irden_reg, rdaddress, irdaddress_reg,
                  wren, iwren_reg, wraddress, iwraddress_reg, iq_tmp, iq_reg,
                  aclr)
	begin
        if (rdaddress_reg = "INCLOCK" or rdaddress_reg = "OUTCLOCK") then
            irdaddress_tmp <= irdaddress_reg;
        elsif (rdaddress_reg = "UNREGISTERED") then
            irdaddress_tmp <= rdaddress;
        else
            ASSERT FALSE
            REPORT "Illegal RDADDRESS_REG property value for ALTDPRAM!"
            SEVERITY ERROR;
		end if;
        if (rdcontrol_reg = "INCLOCK" or rdcontrol_reg = "OUTCLOCK") then
            irden_tmp <= irden_reg;
        elsif (rdcontrol_reg = "UNREGISTERED") then
            irden_tmp <= rden;
        else
            ASSERT FALSE
            REPORT "Illegal RDCONTROL_REG property value for ALTDPRAM!"
            SEVERITY ERROR;
		end if;

        if (wraddress_reg = "INCLOCK") then
            iwraddress_tmp <= iwraddress_reg;
        elsif (wraddress_reg = "UNREGISTERED") then
            iwraddress_tmp <= wraddress;
        else
            ASSERT FALSE
            REPORT "Illegal WRADDRESS_REG property value for ALTDPRAM!"
            SEVERITY ERROR;
		end if;
        if (wrcontrol_reg = "INCLOCK") then
            iwren_tmp <= iwren_reg; 
        elsif (wrcontrol_reg = "UNREGISTERED") then
            iwren_tmp <= wren;
        else
            ASSERT FALSE
            REPORT "Illegal WRCONTROL_REG property value for ALTDPRAM!"
            SEVERITY ERROR;
		end if;

        if (indata_reg = "INCLOCK") then
            idata_tmp <= idata_reg;
        elsif (indata_reg = "UNREGISTERED") then
            idata_tmp <= data;
        else
            ASSERT FALSE
            REPORT "Illegal INDATA_REG property value for ALTDPRAM!"
            SEVERITY ERROR;
		end if;
        if (outdata_reg = "OUTCLOCK") then
            q <= iq_reg;
        elsif (outdata_reg = "UNREGISTERED") then
            q <= iq_tmp;
        else
            ASSERT FALSE
            REPORT "Illegal OUTDATA_REG property value for ALTDPRAM!"
            SEVERITY ERROR;
		end if;

        if (aclr = '1') then
            if(indata_aclr = "ON") then
                idata_tmp <= (OTHERS => '0');
            end if;
            if(wraddress_aclr = "ON") then
                iwraddress_tmp <= (OTHERS => '0');
            end if;
            if(wrcontrol_aclr = "ON") then
                iwren_tmp <= '0';
            end if;
            if(rdaddress_aclr = "ON") then
                irdaddress_tmp <= (OTHERS => '0');
            end if;
            if(rdcontrol_aclr = "ON") then
                irden_tmp <= '0';
            end if;
            if(outdata_aclr = "ON") then
                q <= (OTHERS => '0');
            end if;
        end if;
	end process;

    sync2: process(idata_hi, idata_lo, iwraddress_hi, iwraddress_lo,
                   iwren_hi, iwren_lo)
    begin
        if (write_at_low_clock) then
            idata_reg <= idata_lo;
            iwren_reg <= iwren_lo;
            iwraddress_reg <= iwraddress_lo;
        else
            idata_reg <= idata_hi;
            iwren_reg <= iwren_hi;
            iwraddress_reg <= iwraddress_hi;
        end if;
    end process;

    registers: process (inclock, outclock)
	begin

        -- WRITE REGS --
        if (aclr = '1' and indata_aclr = "ON") then
            idata_hi <= (OTHERS => '0');
            idata_lo <= (OTHERS => '0');
        elsif inclock'event and inclock = '1' and inclocken = '1' then
            idata_hi <= data;
        elsif inclock'event and inclock = '0' then
            idata_lo <= idata_hi;
        end if;
        if (aclr = '1' and wraddress_aclr = "ON") then
            iwraddress_hi <= (OTHERS => '0');
            iwraddress_lo <= (OTHERS => '0');
        elsif inclock'event and inclock = '1' and inclocken = '1' then
            iwraddress_hi <= wraddress;
        elsif inclock'event and inclock = '0' then
            iwraddress_lo <= iwraddress_hi;
        end if;
        if (aclr = '1' and wrcontrol_aclr = "ON") then
            iwren_hi <= '0';
            iwren_lo <= '0';
        elsif inclock'event and inclock = '1' and inclocken = '1' then
            iwren_hi <= wren;
        elsif inclock'event and inclock = '0' then
            iwren_lo <= iwren_hi;
        end if;

        -- READ REGS --
        if (aclr = '1' and outdata_aclr = "ON") then
            iq_reg <= (OTHERS => '0');
        elsif outclock'event and outclock = '1' and outclocken = '1' then
            iq_reg <= iq_tmp;
        end if;
        if (rdaddress_reg = "INCLOCK") then
            if (aclr = '1' and rdaddress_aclr = "ON") then
                irdaddress_reg <= (OTHERS => '0');
            elsif inclock'event and inclock = '1' and inclocken = '1' then
                irdaddress_reg <= rdaddress;
            end if;
        end if;
        if (rdcontrol_reg = "INCLOCK") then
            if (aclr = '1' and rdcontrol_aclr = "ON") then
                irden_reg <= '0';
            elsif inclock'event and inclock = '1' and inclocken = '1' then
                irden_reg <= rden; 
            end if;
        end if;
        if (rdaddress_reg = "OUTCLOCK") then
            if (aclr = '1' and rdaddress_aclr = "ON") then
                irdaddress_reg <= (OTHERS => '0');
            elsif outclock'event and outclock = '1' and outclocken = '1' then
                irdaddress_reg <= rdaddress;
            end if;
        end if;
        if (rdcontrol_reg = "OUTCLOCK") then
            if (aclr = '1' and rdcontrol_aclr = "ON") then
                irden_reg <= '0';
            elsif outclock'event and outclock = '1' and outclocken = '1' then
                irden_reg <= rden; 
            end if;
        end if;
	end process;

    memory: process(idata_tmp, iwren_tmp, irden_tmp, irdaddress_tmp, iwraddress_tmp)
    variable mem_data : alt_memory;
    variable mem_data_word : std_logic_vector(width-1 downto 0);
    variable mem_init : boolean := false;
    variable i, j, k, n, m, lineno : integer := 0;
    variable buf : line;
    variable booval : boolean;
    FILE unused_file : TEXT IS OUT "UNUSED";
    FILE mem_data_file : TEXT IS IN lpm_file;
    variable base, byte, rec_type, datain, addr, checksum: string(2 downto 1);
    variable startadd: string(4 downto 1);
    variable ibase : integer := 0;
    variable ibyte : integer := 0;
    variable istartadd : integer := 0;
    variable check_sum_vec, check_sum_vec_tmp : std_logic_vector(7 downto 0);

    --debug
    --variable ln : line;
	begin
		-- INITIALIZE --
		if NOT(mem_init) then
			-- INITIALIZE TO 0 --
			for i in mem_data'LOW to mem_data'HIGH loop
				mem_data(i) := (OTHERS => '0');
			end loop;

            if (lpm_file = "UNUSED") then
				ASSERT FALSE
				REPORT "Initialization file not found!"
				SEVERITY WARNING;
			else
				WHILE NOT ENDFILE(mem_data_file) loop
					booval := true;
					READLINE(mem_data_file, buf);
					lineno := lineno + 1;
					check_sum_vec := (OTHERS => '0');
					if (buf(buf'LOW) = ':') then
						i := 1;
						shrink_line(buf, i);
						READ(L=>buf, VALUE=>byte, good=>booval);
						if not (booval) then
							ASSERT FALSE
							REPORT "[Line "& int_to_str(lineno) & "]:Illegal Intel Hex Format!"
							SEVERITY ERROR;
						end if;
						ibyte := hex_str_to_int(byte);
						check_sum_vec := unsigned(check_sum_vec) + unsigned(CONV_STD_LOGIC_VECTOR(ibyte, 8));
						READ(L=>buf, VALUE=>startadd, good=>booval);
						if not (booval) then
							ASSERT FALSE
							REPORT "[Line "& int_to_str(lineno) & "]:Illegal Intel Hex Format! "
							SEVERITY ERROR;
						end if;
						istartadd := hex_str_to_int(startadd);
						addr(2) := startadd(4);
						addr(1) := startadd(3);
						check_sum_vec := unsigned(check_sum_vec) + unsigned(CONV_STD_LOGIC_VECTOR(hex_str_to_int(addr), 8));
						addr(2) := startadd(2);
						addr(1) := startadd(1);
						check_sum_vec := unsigned(check_sum_vec) + unsigned(CONV_STD_LOGIC_VECTOR(hex_str_to_int(addr), 8));
						READ(L=>buf, VALUE=>rec_type, good=>booval);
						if not (booval) then
							ASSERT FALSE
							REPORT "[Line "& int_to_str(lineno) & "]:Illegal Intel Hex Format! "
							SEVERITY ERROR;
						end if;
						check_sum_vec := unsigned(check_sum_vec) + unsigned(CONV_STD_LOGIC_VECTOR(hex_str_to_int(rec_type), 8));
					else
						ASSERT FALSE
						REPORT "[Line "& int_to_str(lineno) & "]:Illegal Intel Hex Format! "
						SEVERITY ERROR;
					end if;
					case rec_type is
						when "00"=>     -- Data record
							i := 0;
                                                        k := (WIDTH + 7) / 8;  -- # of bytes per entry
							while (i < ibyte) loop
                                                                mem_data_word := (others => '0');
                                                                n := (k - 1)*8;
                                                                m := width - 1;
								for j in 1 to k loop
									READ(L=>buf, VALUE=>datain,good=>booval); -- read in data a byte (2 hex chars) at a time.
									if not (booval) then
										ASSERT FALSE
										REPORT "[Line "& int_to_str(lineno) & "]:Illegal Intel Hex Format! "
										SEVERITY ERROR;
									end if;
									check_sum_vec := unsigned(check_sum_vec) + unsigned(CONV_STD_LOGIC_VECTOR(hex_str_to_int(datain), 8));
                                                                        mem_data_word(m downto n) := CONV_STD_LOGIC_VECTOR(hex_str_to_int(datain), m-n+1);
                                                                        m := n - 1;
                                                                        n := n - 8;
								end loop;
								i := i + k;
                                                                mem_data(ibase + istartadd) := mem_data_word;
								istartadd := istartadd + 1;
							end loop;
						when "01"=>
							exit;
						when "02"=>
							ibase := 0;
							if (ibyte /= 2) then
								ASSERT FALSE
								REPORT "[Line "& int_to_str(lineno) & "]:Illegal Intel Hex Format for record type 02! "
								SEVERITY ERROR;
							end if;
							for i in 0 to (ibyte-1) loop
								READ(L=>buf, VALUE=>base,good=>booval);
								ibase := ibase * 256 + hex_str_to_int(base);
								if not (booval) then
									ASSERT FALSE
									REPORT "[Line "& int_to_str(lineno) & "]:Illegal Intel Hex Format! "
									SEVERITY ERROR;
								end if;
								check_sum_vec := unsigned(check_sum_vec) + unsigned(CONV_STD_LOGIC_VECTOR(hex_str_to_int(base), 8));
							end loop;
							ibase := ibase * 16;
						when OTHERS =>
							ASSERT FALSE
							REPORT "[Line "& int_to_str(lineno) & "]:Illegal record type in Intel Hex File! "
							SEVERITY ERROR;
					end case;
					READ(L=>buf, VALUE=>checksum,good=>booval);
					if not (booval) then
						ASSERT FALSE
						REPORT "[Line "& int_to_str(lineno) & "]:Checksum is missing! "
						SEVERITY ERROR;
					end if;

					check_sum_vec := unsigned(not (check_sum_vec)) + 1 ;
					check_sum_vec_tmp := CONV_STD_LOGIC_VECTOR(hex_str_to_int(checksum),8);

					if (unsigned(check_sum_vec) /= unsigned(check_sum_vec_tmp)) then
						ASSERT FALSE
						REPORT "[Line "& int_to_str(lineno) & "]:Incorrect checksum!"
						SEVERITY ERROR;
					end if;
				end loop;
			end if;
			mem_init := TRUE;

        else -- already initialized

            -- MEMORY FUNCTION --
            if iwren_tmp = '1' then
                mem_data (ieee.std_logic_unsigned.conv_integer(iwraddress_tmp)) := idata_tmp;

            --debug
            --write(ln, (now/1000 ns),right,4);
            --write(ln, string'(" us> write ")); 
            --for i in width-1 downto 0 loop
            --    if (idata_tmp(i) = '0') then write(ln, string'("0"));
            --    elsif (idata_tmp(i) = '1') then write(ln, string'("1"));
            --    else  write(ln, string'("?"));
            --    end if;
            --end loop;
            --write(ln, string'(" @ ")); 
            --for i in widthad-1 downto 0 loop
            --    if (iwraddress_tmp(i) = '0') then write(ln, string'("0"));
            --    elsif (iwraddress_tmp(i) = '1') then write(ln, string'("1"));
            --    else  write(ln, string'("?"));
            --    end if;
            --end loop;
            --writeline(output, ln);
            --end-debug

            end if;

            if irden_tmp = '1' then
                iq_tmp <= mem_data(ieee.std_logic_unsigned.conv_integer(irdaddress_tmp));

                --debug
                --write(ln, (now/1000 ns),right,4);
                --write(ln, string'(" us> read ")); 
                --for i in width-1 downto 0 loop
                --    if (iq_tmp(i) = '0') then write(ln, string'("0"));
                --    elsif (iq_tmp(i) = '1') then write(ln, string'("1"));
                --    else  write(ln, string'("?"));
                --    end if;
                --end loop;
                --write(ln, string'(" @ ")); 
                --for i in widthad-1 downto 0 loop
                --    if (irdaddress_tmp(i) = '0') then write(ln, string'("0"));
                --    elsif (irdaddress_tmp(i) = '1') then write(ln, string'("1"));
                --    else  write(ln, string'("?"));
                --    end if;
                --end loop;
                --writeline(output, ln);
                --end-debug

            elsif rden_low_output_0 then
                iq_tmp <= (OTHERS => '0');
            end if;
        end if; -- if NOT(mem_init)

	end process;

end behavior;


----------------------------------------------------------------------------
-- altqpram megafunction
----------------------------------------------------------------------------
    
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use std.textio.all;

entity altqpram is
    generic
      ( operation_mode            : string := "QUAD_PORT";

        width_write_a             : natural := 1;
        widthad_write_a           : natural := 1;
        numwords_write_a          : natural := 2;  -- default = 2^widthad_write_a
        indata_reg_a              : string := "INCLOCK_A";
        indata_aclr_a             : string := "INACLR_A";
        wrcontrol_wraddress_reg_a : string := "INCLOCK_A";
        wrcontrol_aclr_a          : string := "INACLR_A";
        wraddress_aclr_a          : string := "INACLR_A";

        width_write_b             : natural := 1;  -- default = width_write_a
        widthad_write_b           : natural := 1;  -- default = widthad_write_a
        numwords_write_b          : natural := 2;  -- default = 2^widthad_write_b
        indata_reg_b              : string := "INCLOCK_B";
        indata_aclr_b             : string := "INACLR_B";
        wrcontrol_wraddress_reg_b : string := "INCLOCK_B";
        wrcontrol_aclr_b          : string := "INACLR_B";
        wraddress_aclr_b          : string := "INACLR_B";

        width_read_a              : natural := 1;
        widthad_read_a            : natural := 1;
        numwords_read_a           : natural := 2;  -- default = 2^widthad_read_a
        rdcontrol_reg_a           : string := "OUTCLOCK_A";
        rdcontrol_aclr_a          : string := "OUTACLR_A";
        rdaddress_reg_a           : string := "OUTCLOCK_A";
        rdaddress_aclr_a          : string := "OUTACLR_A";
        outdata_reg_a             : string := "UNREGISTERED";
        outdata_aclr_a            : string := "OUTACLR_A";

        width_read_b              : natural := 1;  -- default = width_read_a
        widthad_read_b            : natural := 1;  -- default = widthad_read_a
        numwords_read_b           : natural := 2;  -- default = 2^widthad_read_b
        rdcontrol_reg_b           : string := "OUTCLOCK_B";
        rdcontrol_aclr_b          : string := "OUTACLR_B";
        rdaddress_reg_b           : string := "OUTCLOCK_B";
        rdaddress_aclr_b          : string := "OUTACLR_B";
        outdata_reg_b             : string := "UNREGISTERED";
        outdata_aclr_b            : string := "OUTACLR_B";

        init_file                 : string := "UNUSED";
        lpm_hint                  : string := "UNUSED" );

    port
      ( wren_a       : in std_logic := '0';
        wren_b       : in std_logic := '0';
        data_a       : in std_logic_vector(width_write_a-1 downto 0) := (OTHERS => '0');
        data_b       : in std_logic_vector(width_write_b-1 downto 0) := (OTHERS => '0');
        wraddress_a  : in std_logic_vector(widthad_write_a-1 downto 0) := (OTHERS => '0');
        wraddress_b  : in std_logic_vector(widthad_write_b-1 downto 0) := (OTHERS => '0');
        inclock_a    : in std_logic := '1';
        inclock_b    : in std_logic := '1';
        inclocken_a  : in std_logic := '1';
        inclocken_b  : in std_logic := '1';
        rden_a       : in std_logic := '1';
        rden_b       : in std_logic := '1';
        rdaddress_a  : in std_logic_vector(widthad_read_a-1 downto 0) := (OTHERS => '0');
        rdaddress_b  : in std_logic_vector(widthad_read_b-1 downto 0) := (OTHERS => '0');
        outclock_a   : in std_logic := '1';
        outclock_b   : in std_logic := '1';
        outclocken_a : in std_logic := '1';
        outclocken_b : in std_logic := '1';
        inaclr_a     : in std_logic := '0';
        inaclr_b     : in std_logic := '0';
        outaclr_a    : in std_logic := '0';
        outaclr_b    : in std_logic := '0';
        q_a          : out std_logic_vector(width_read_a-1 downto 0);
        q_b          : out std_logic_vector(width_read_b-1 downto 0) );

	function int_to_str( value : integer ) return string is
	variable ivalue,index : integer;
	variable digit : integer;
	variable line_no: string(8 downto 1) := "        ";  
	begin
		ivalue := value;
		index := 1;
		while (ivalue > 0) loop
			digit := ivalue MOD 10;
			ivalue := ivalue/10;
			case digit is
				when 0 =>
					line_no(index) := '0';
				when 1 =>
					line_no(index) := '1';
				when 2 =>
					line_no(index) := '2';
				when 3 =>
					line_no(index) := '3';
				when 4 =>
					line_no(index) := '4';
				when 5 =>
					line_no(index) := '5';
				when 6 =>
					line_no(index) := '6';
				when 7 =>
					line_no(index) := '7';
				when 8 =>
					line_no(index) := '8';
				when 9 =>
					line_no(index) := '9';
				when others =>
					ASSERT FALSE
					REPORT "Illegal number!"
					SEVERITY ERROR;
			end case;
			index := index + 1;
		end loop;
		return line_no;
	end;

	function hex_str_to_int( str : string ) return integer is
	variable len : integer := str'length;
	variable ivalue : integer := 0;
	variable digit : integer;
	begin
		for i in len downto 1 loop
			case str(i) is
				when '0' =>
					digit := 0;
				when '1' =>
					digit := 1;
				when '2' =>
					digit := 2;
				when '3' =>
					digit := 3;
				when '4' =>
					digit := 4;
				when '5' =>
					digit := 5;
				when '6' =>
					digit := 6;
				when '7' =>
					digit := 7;
				when '8' =>
					digit := 8;
				when '9' =>
					digit := 9;
				when 'A' =>
					digit := 10;
				when 'a' =>
					digit := 10;
				when 'B' =>
					digit := 11;
				when 'b' =>
					digit := 11;
				when 'C' =>
					digit := 12;
				when 'c' =>
					digit := 12;
				when 'D' =>
					digit := 13;
				when 'd' =>
					digit := 13;
				when 'E' =>
					digit := 14;
				when 'e' =>
					digit := 14;
				when 'F' =>
					digit := 15;
				when 'f' =>
					digit := 15;
				when others =>
					ASSERT FALSE
					REPORT "Illegal character "&  str(i) & "in Intel Hex File! "
					SEVERITY ERROR;
			end case;
			ivalue := ivalue * 16 + digit;
		end loop;
		return ivalue;
	end;

	procedure Shrink_line(L : inout LINE; pos : in integer) is
	subtype nstring is string(1 to pos);
	variable stmp : nstring;
	begin
		if pos >= 1 then
			read(l, stmp);
		end if;
    end;

end altqpram;

architecture behavior of altqpram is

type alt_memory is array((2**WIDTHAD_READ_A)-1 downto 0) of std_logic_vector(WIDTH_READ_A-1 downto 0);
type alt_memory_w is array((2**WIDTHAD_WRITE_A)-1 downto 0) of std_logic_vector(WIDTH_WRITE_A-1 downto 0);

signal idata_tmp_a, idata_reg_a : std_logic_vector(WIDTH_WRITE_A-1 downto 0) := (OTHERS => '0');
signal idata_tmp_b, idata_reg_b : std_logic_vector(WIDTH_WRITE_B-1 downto 0) := (OTHERS => '0');
signal idata_hi_a, idata_lo_a : std_logic_vector(WIDTH_WRITE_A-1 downto 0) := (OTHERS => '0');
signal idata_hi_b, idata_lo_b : std_logic_vector(WIDTH_WRITE_B-1 downto 0) := (OTHERS => '0');
signal iq_tmp_a, iq_reg_a : std_logic_vector(WIDTH_READ_A-1 downto 0) := (OTHERS => '0');
signal iq_tmp_b, iq_reg_b : std_logic_vector(WIDTH_READ_B-1 downto 0) := (OTHERS => '0');
signal irdaddress_tmp_a, irdaddress_reg_a : std_logic_vector(WIDTHAD_READ_A-1 downto 0) := (OTHERS => '0');
signal irdaddress_tmp_b, irdaddress_reg_b : std_logic_vector(WIDTHAD_READ_B-1 downto 0) := (OTHERS => '0');
signal iwraddress_tmp_a, iwraddress_reg_a : std_logic_vector(WIDTHAD_WRITE_A-1 downto 0) := (OTHERS => '0');
signal iwraddress_tmp_b, iwraddress_reg_b : std_logic_vector(WIDTHAD_WRITE_B-1 downto 0) := (OTHERS => '0');
signal iwraddress_hi_a, iwraddress_lo_a : std_logic_vector(WIDTHAD_WRITE_A-1 downto 0) := (OTHERS => '0');
signal iwraddress_hi_b, iwraddress_lo_b : std_logic_vector(WIDTHAD_WRITE_B-1 downto 0) := (OTHERS => '0');
signal iwren_tmp_a, iwren_reg_a : std_logic := '0';
signal iwren_tmp_b, iwren_reg_b : std_logic := '0';
signal iwren_hi_a, iwren_lo_a : std_logic := '0';
signal iwren_hi_b, iwren_lo_b : std_logic := '0';
signal irden_tmp_a, irden_reg_a : std_logic := '0';
signal irden_tmp_b, irden_reg_b : std_logic := '0';
signal i_indata_aclr_a, i_outdata_aclr_a : std_logic := '0';
signal i_wrcontrol_aclr_a, i_wraddress_aclr_a : std_logic := '0';
signal i_rdcontrol_aclr_a, i_rdaddress_aclr_a : std_logic := '0';
signal i_indata_aclr_b, i_outdata_aclr_b : std_logic := '0';
signal i_wrcontrol_aclr_b, i_wraddress_aclr_b : std_logic := '0';
signal i_rdcontrol_aclr_b, i_rdaddress_aclr_b : std_logic := '0';
signal inumwords_write_a : natural := numwords_write_a;
signal inumwords_write_b : natural := numwords_write_b;
signal inumwords_read_a : natural := numwords_read_a;
signal inumwords_read_b : natural := numwords_read_b;
signal write_at_low_clock_a, write_at_low_clock_b : boolean := false;
signal om : natural := 0;   -- operation mode
signal mem_init : boolean := false;
signal aclr_updated : std_logic := '0';

begin

    -----------
    -- ACLRs --
    -----------

    aclrs: process(inaclr_a, outaclr_a, inaclr_b, outaclr_b)
    begin

        -- ACLR_A --

        i_indata_aclr_a <= '0';
        i_wrcontrol_aclr_a <= '0';
        i_wraddress_aclr_a <= '0';
        i_outdata_aclr_a <= '0';
        i_rdcontrol_aclr_a <= '0';
        i_rdaddress_aclr_a <= '0';
    
        if (inaclr_a = '1') then
            if (indata_aclr_a = "INACLR_A" and
                indata_reg_a /= "UNREGISTERED")
            then
                i_indata_aclr_a <= '1';
            end if;
            if (wrcontrol_aclr_a = "INACLR_A" and
                wrcontrol_wraddress_reg_a /= "UNREGISTERED")
            then
                i_wrcontrol_aclr_a <= '1';
            end if;
            if (wraddress_aclr_a = "INACLR_A" and
                wrcontrol_wraddress_reg_a /= "UNREGISTERED")
            then
                i_wraddress_aclr_a <= '1';
            end if;
            if (outdata_aclr_a = "INACLR_A" and
                outdata_reg_a /= "UNREGISTERED")
            then
                i_outdata_aclr_a <= '1';
            end if;
            if (rdcontrol_aclr_a = "INACLR_A" and
                rdcontrol_reg_a /= "UNREGISTERED")
            then
                i_rdcontrol_aclr_a <= '1';
            end if;
            if (rdaddress_aclr_a = "INACLR_A" and
                rdaddress_reg_a /= "UNREGISTERED")
            then
                i_rdaddress_aclr_a <= '1';
            end if;
        end if;

        if (outaclr_a = '1') then
            if (outdata_aclr_a = "OUTACLR_A" and
                outdata_reg_a /= "UNREGISTERED")
            then
                i_outdata_aclr_a <= '1';
            end if;
            if (rdcontrol_aclr_a = "OUTACLR_A" and
                rdcontrol_reg_a /= "UNREGISTERED")
            then
                i_rdcontrol_aclr_a <= '1';
            end if;
            if (rdaddress_aclr_a = "OUTACLR_A" and
                rdaddress_reg_a /= "UNREGISTERED")
            then
                i_rdaddress_aclr_a <= '1';
            end if;
        end if;

        -- ACLR_B --

        i_indata_aclr_b <= '0';
        i_wrcontrol_aclr_b <= '0';
        i_wraddress_aclr_b <= '0';
        i_outdata_aclr_b <= '0';
        i_rdcontrol_aclr_b <= '0';
        i_rdaddress_aclr_b <= '0';
    
        if (inaclr_b = '1') then
            if (indata_aclr_b = "INACLR_B" and
                indata_reg_b /= "UNREGISTERED")
            then
                i_indata_aclr_b <= '1';
            end if;
            if (wrcontrol_aclr_b = "INACLR_B" and
                wrcontrol_wraddress_reg_b /= "UNREGISTERED")
            then
                i_wrcontrol_aclr_b <= '1';
            end if;
            if (wraddress_aclr_b = "INACLR_B" and
                wrcontrol_wraddress_reg_b /= "UNREGISTERED")
            then
                i_wraddress_aclr_b <= '1';
            end if;
            if (outdata_aclr_b = "INACLR_B" and
                outdata_reg_b /= "UNREGISTERED")
            then
                i_outdata_aclr_b <= '1';
            end if;
            if (rdcontrol_aclr_b = "INACLR_B" and
                rdcontrol_reg_b /= "UNREGISTERED")
            then
                i_rdcontrol_aclr_b <= '1';
            end if;
            if (rdaddress_aclr_b = "INACLR_B" and
                rdaddress_reg_b /= "UNREGISTERED")
            then
                i_rdaddress_aclr_b <= '1';
            end if;
        end if;

        if (outaclr_b = '1') then
            if (outdata_aclr_b = "OUTACLR_B" and
                outdata_reg_b /= "UNREGISTERED")
            then
                i_outdata_aclr_b <= '1';
            end if;
            if (rdcontrol_aclr_b = "OUTACLR_B" and
                rdcontrol_reg_b /= "UNREGISTERED")
            then
                i_rdcontrol_aclr_b <= '1';
            end if;
            if (rdaddress_aclr_b = "OUTACLR_B" and
                rdaddress_reg_b /= "UNREGISTERED")
            then
                i_rdaddress_aclr_b <= '1';
            end if;
        end if;
        aclr_updated <= not aclr_updated;
    end process;


    ----------
    -- SYNC --
    ----------

    sync: process(data_a, data_b, idata_reg_a, idata_reg_b,
                  rden_a, rden_b, irden_reg_a, irden_reg_b,
                  rdaddress_a, rdaddress_b, irdaddress_reg_a, irdaddress_reg_b,
                  wren_a, wren_b, iwren_reg_a, iwren_reg_b,
                  wraddress_a, wraddress_b, iwraddress_reg_a, iwraddress_reg_b,
                  iq_tmp_a, iq_tmp_b, iq_reg_a, iq_reg_b,
                  aclr_updated)
	begin
        if (not inaclr_a'event and not outaclr_a'event and
            not inaclr_b'event and not outaclr_b'event)
        then
            if (i_rdaddress_aclr_a = '1') then
                irdaddress_tmp_a <= (OTHERS => '0');
            elsif (rdaddress_reg_a = "UNREGISTERED") then
                irdaddress_tmp_a <= rdaddress_a;
            else
                irdaddress_tmp_a <= irdaddress_reg_a;
            end if;
    
            if (i_rdaddress_aclr_b = '1') then
                irdaddress_tmp_b <= (OTHERS => '0');
            elsif (rdaddress_reg_b = "UNREGISTERED") then
                irdaddress_tmp_b <= rdaddress_b;
            else
                irdaddress_tmp_b <= irdaddress_reg_b;
            end if;
    
            if (i_rdcontrol_aclr_a = '1') then
                irden_tmp_a <= '0';
            elsif (rdcontrol_reg_a = "UNREGISTERED") then
                irden_tmp_a <= rden_a;
            else
                irden_tmp_a <= irden_reg_a;
            end if;
    
            if (i_rdcontrol_aclr_b = '1') then
                irden_tmp_b <= '0';
            elsif (rdcontrol_reg_b = "UNREGISTERED") then
                irden_tmp_b <= rden_b;
            else
                irden_tmp_b <= irden_reg_b;
            end if;
    
            if (i_wraddress_aclr_a = '1') then
                iwraddress_tmp_a <= (OTHERS => '0');
            elsif (wrcontrol_wraddress_reg_a = "UNREGISTERED") then
                iwraddress_tmp_a <= wraddress_a;
            else
                iwraddress_tmp_a <= iwraddress_reg_a;
            end if;
    
            if (i_wraddress_aclr_b = '1') then
                iwraddress_tmp_b <= (OTHERS => '0');
            elsif (wrcontrol_wraddress_reg_b = "UNREGISTERED") then
                iwraddress_tmp_b <= wraddress_b;
            else
                iwraddress_tmp_b <= iwraddress_reg_b;
            end if;
    
            if (i_wrcontrol_aclr_a = '1') then
                iwren_tmp_a <= '0';
            elsif (wrcontrol_wraddress_reg_a = "UNREGISTERED") then
                iwren_tmp_a <= wren_a;
            else
                iwren_tmp_a <= iwren_reg_a; 
            end if;
    
            if (i_wrcontrol_aclr_b = '1') then
                iwren_tmp_b <= '0';
            elsif (wrcontrol_wraddress_reg_b = "UNREGISTERED") then
                iwren_tmp_b <= wren_b;
            else
                iwren_tmp_b <= iwren_reg_b; 
            end if;
    
            if (i_indata_aclr_a = '1') then
                idata_tmp_a <= (OTHERS => '0');
            elsif (indata_reg_a = "UNREGISTERED") then
                idata_tmp_a <= data_a;
            else
                idata_tmp_a <= idata_reg_a;
            end if;
    
            if (i_indata_aclr_b = '1') then
                idata_tmp_b <= (OTHERS => '0');
            elsif (indata_reg_b = "UNREGISTERED") then
                idata_tmp_b <= data_b;
            else
                idata_tmp_b <= idata_reg_b;
            end if;
    
            if (om mod 6 = 0 or i_outdata_aclr_a = '1') then
                q_a <= (OTHERS => '0');
            elsif (outdata_reg_a = "UNREGISTERED") then
                q_a <= iq_tmp_a;
            else
                q_a <= iq_reg_a;
            end if;
    
            if (om mod 5 = 0 or i_outdata_aclr_b = '1') then
                q_b <= (OTHERS => '0');
            elsif (outdata_reg_b = "UNREGISTERED") then
                q_b <= iq_tmp_b;
            else
                q_b <= iq_reg_b;
            end if;
        end if;
	end process;

    sync_a: process(idata_hi_a, idata_lo_a, iwraddress_hi_a, iwraddress_lo_a,
                    iwren_hi_a, iwren_lo_a,
                    i_wraddress_aclr_a, i_wrcontrol_aclr_a, i_indata_aclr_a)
    begin
        if (i_indata_aclr_a = '1') then
            idata_reg_a <= (OTHERS => '0');
        elsif (write_at_low_clock_a) then
            idata_reg_a <= idata_lo_a;
        else
            idata_reg_a <= idata_hi_a;
        end if;

        if (i_wrcontrol_aclr_a = '1') then
            iwren_reg_a <= '0';
        elsif (write_at_low_clock_a) then
            iwren_reg_a <= iwren_lo_a;
        else
            iwren_reg_a <= iwren_hi_a;
        end if;

        if (i_wraddress_aclr_a = '1') then
            iwraddress_reg_a <= (OTHERS => '0');
        else
            iwraddress_reg_a <= iwraddress_hi_a;
        end if;
    end process;

    sync_b: process(idata_hi_b, idata_lo_b, iwraddress_hi_b, iwraddress_lo_b,
                    iwren_hi_b, iwren_lo_b,
                    i_wraddress_aclr_b, i_wrcontrol_aclr_b, i_indata_aclr_b)
    begin
        if (i_indata_aclr_b = '1') then
            idata_reg_b <= (OTHERS => '0');
        elsif (write_at_low_clock_b) then
            idata_reg_b <= idata_lo_b;
        else
            idata_reg_b <= idata_hi_b;
        end if;

        if (i_wrcontrol_aclr_b = '1') then
            iwren_reg_b <= '0';
        elsif (write_at_low_clock_b) then
            iwren_reg_b <= iwren_lo_b;
        else
            iwren_reg_b <= iwren_hi_b;
        end if;

        if (i_wraddress_aclr_b = '1') then
            iwraddress_reg_b <= (OTHERS => '0');
        else
            iwraddress_reg_b <= iwraddress_hi_b;
        end if;
    end process;


    ------------
    -- Clocks --
    ------------

    input_reg_a: process (inclock_a, outclock_a)
	begin
        if (inclock_a'event) then
            if (i_indata_aclr_a = '1') then
                idata_hi_a <= (OTHERS => '0');
                idata_lo_a <= (OTHERS => '0');
            elsif inclock_a = '1' and inclocken_a = '1' then
                idata_hi_a <= data_a;
            elsif inclock_a = '0' then
                idata_lo_a <= idata_hi_a;
            end if;
            if (i_wraddress_aclr_a = '1') then
                iwraddress_hi_a <= (OTHERS => '0');
                iwraddress_lo_a <= (OTHERS => '0');
            elsif inclock_a = '1' and inclocken_a = '1' then
                iwraddress_hi_a <= wraddress_a;
            elsif inclock_a = '0' then
                iwraddress_lo_a <= iwraddress_hi_a;
            end if;
            if (i_wrcontrol_aclr_a = '1') then
                iwren_hi_a <= '0';
                iwren_lo_a <= '0';
            elsif inclock_a = '1' and inclocken_a = '1' then
                iwren_hi_a <= wren_a;
            elsif inclock_a = '0' then
                iwren_lo_a <= iwren_hi_a;
            end if;
    
            if (outdata_reg_a = "INCLOCK_A") then
                if (i_outdata_aclr_a = '1') then
                    iq_reg_a <= (OTHERS => '0');
                elsif inclock_a = '1' and inclocken_a = '1' then
                    iq_reg_a <= iq_tmp_a;
                end if;
            end if;
            if (rdaddress_reg_a = "INCLOCK_A") then
                if (i_rdaddress_aclr_a = '1') then
                    irdaddress_reg_a <= (OTHERS => '0');
                elsif inclock_a = '1' and inclocken_a = '1' then
                    irdaddress_reg_a <= rdaddress_a;
                end if;
            end if;
            if (rdcontrol_reg_a = "INCLOCK_A") then
                if (i_rdcontrol_aclr_a = '1') then
                    irden_reg_a <= '0';
                elsif inclock_a = '1' and inclocken_a = '1' then
                    irden_reg_a <= rden_a;
                end if;
            end if;
        end if;

        if (outclock_a'event) then
            if (outdata_reg_a = "OUTCLOCK_A") then
                if (i_outdata_aclr_a = '1') then
                    iq_reg_a <= (OTHERS => '0');
                elsif outclock_a = '1' and outclocken_a = '1' then
                    iq_reg_a <= iq_tmp_a;
                end if;
            end if;
            if (rdaddress_reg_a = "OUTCLOCK_A") then
                if (i_rdaddress_aclr_a = '1') then
                    irdaddress_reg_a <= (OTHERS => '0');
                elsif outclock_a = '1' and outclocken_a = '1' then
                    irdaddress_reg_a <= rdaddress_a;
                end if;
            end if;
            if (rdcontrol_reg_a = "OUTCLOCK_A") then
                if (i_rdcontrol_aclr_a = '1') then
                    irden_reg_a <= '0';
                elsif outclock_a = '1' and outclocken_a = '1' then
                    irden_reg_a <= rden_a;
                end if;
            end if;
        end if;
	end process;

    input_reg_b: process (inclock_b, outclock_b)
	begin
        if (inclock_b'event) then
            if (i_indata_aclr_b = '1') then
                idata_hi_b <= (OTHERS => '0');
                idata_lo_b <= (OTHERS => '0');
            elsif inclock_b = '1' and inclocken_b = '1' then
                idata_hi_b <= data_b;
            elsif inclock_b = '0' then
                idata_lo_b <= idata_hi_b;
            end if;
            if (i_wraddress_aclr_b = '1') then
                iwraddress_hi_b <= (OTHERS => '0');
                iwraddress_lo_b <= (OTHERS => '0');
            elsif inclock_b = '1' and inclocken_b = '1' then
                iwraddress_hi_b <= wraddress_b;
            elsif inclock_b = '0' then
                iwraddress_lo_b <= iwraddress_hi_b;
            end if;
            if (i_wrcontrol_aclr_b = '1') then
                iwren_hi_b <= '0';
                iwren_lo_b <= '0';
            elsif inclock_b = '1' and inclocken_b = '1' then
                iwren_hi_b <= wren_b;
            elsif inclock_b = '0' then
                iwren_lo_b <= iwren_hi_b;
            end if;
            if (outdata_reg_b = "INCLOCK_B") then
                if (i_outdata_aclr_b = '1') then
                    iq_reg_b <= (OTHERS => '0');
                elsif inclock_b = '1' and inclocken_b = '1' then
                    iq_reg_b <= iq_tmp_b;
                end if;
            end if;
            if (rdaddress_reg_b = "INCLOCK_B") then
                if (i_rdaddress_aclr_b = '1') then
                    irdaddress_reg_b <= (OTHERS => '0');
                elsif inclock_b = '1' and inclocken_b = '1' then
                    irdaddress_reg_b <= rdaddress_b;
                end if;
            end if;
            if (rdcontrol_reg_b = "INCLOCK_B") then
                if (i_rdcontrol_aclr_b = '1') then
                    irden_reg_b <= '0';
                elsif inclock_b = '1' and inclocken_b = '1' then
                    irden_reg_b <= rden_b;
                end if;
            end if;
        end if;

        if (outclock_b'event) then
            if (outdata_reg_b = "OUTCLOCK_B") then
                if (i_outdata_aclr_b = '1') then
                    iq_reg_b <= (OTHERS => '0');
                elsif outclock_b = '1' and outclocken_b = '1' then
                    iq_reg_b <= iq_tmp_b;
                end if;
            end if;
            if (rdaddress_reg_b = "OUTCLOCK_B") then
                if (i_rdaddress_aclr_b = '1') then
                    irdaddress_reg_b <= (OTHERS => '0');
                elsif outclock_b = '1' and outclocken_b = '1' then
                    irdaddress_reg_b <= rdaddress_b;
                end if;
            end if;
            if (rdcontrol_reg_b = "OUTCLOCK_B") then
                if (i_rdcontrol_aclr_b = '1') then
                    irden_reg_b <= '0';
                elsif outclock_b = '1' and outclocken_b = '1' then
                    irden_reg_b <= rden_b;
                end if;
            end if;
        end if;
	end process;


    ------------
    -- Memory --
    ------------

    memory: process(idata_tmp_a, iwren_tmp_a, iwraddress_tmp_a,
                    irden_tmp_a, irdaddress_tmp_a,
                    idata_tmp_b, iwren_tmp_b, iwraddress_tmp_b,
                    irden_tmp_b, irdaddress_tmp_b, mem_init)
    variable mem_data : alt_memory;
    variable mem_data_w : alt_memory_w;
    variable mem_data_word : std_logic_vector(WIDTH_READ_A-1 downto 0);
    variable mem_data_word_w : std_logic_vector(WIDTH_WRITE_A-1 downto 0);
    variable i, j, k, n, m, lineno : integer := 0;
    variable buf : line ;
    variable booval : boolean ;
    FILE unused_file : TEXT IS OUT "UNUSED";
    FILE mem_data_file : TEXT IS IN INIT_FILE;
	variable base, byte, rec_type, datain, addr, checksum: string(2 downto 1);
	variable startadd: string(4 downto 1);
	variable ibase: integer := 0;
	variable ibyte: integer := 0;
	variable istartadd: integer := 0;
	variable check_sum_vec, check_sum_vec_tmp: std_logic_vector(7 downto 0);
    variable init_numwords_write_a : integer := numwords_write_a;
    variable init_numwords_write_b : integer := numwords_write_b;
    variable init_numwords_read_a : integer := numwords_read_a;
    variable init_numwords_read_b : integer := numwords_read_b;
    variable init_om : integer := 0;

	begin
		-- INITIALIZE --
		if NOT(mem_init) then

            -- CHECK FOR OPERATION_MODE --
            --
            -- This is the table for encoding of om and init_om.
            --       << PORT A >>      |  << PORT B >>
            --      RD  RD  WR  WR     | RD  RD  WR  WR
            --      EN ADDR EN ADDR %6 | EN ADDR EN ADDR %5
            -- QP    o   o   o   o   3 |  o   o   o   o   3
            -- BDP           o   o   2 |          o   o   2
            -- DP    o   o   o   o   3 |                  0
            -- SP            o   o   2 |                  0
            -- ROM       o           1 |                  0
            --
            if operation_mode = "QUAD_PORT" then
                init_om := 3;
            elsif operation_mode = "BIDIR_DUAL_PORT" then
                init_om := 2;
            elsif operation_mode = "DUAL_PORT" then
                init_om := 15;
            elsif operation_mode = "SINGLE_PORT" then
                init_om := 20;
            elsif operation_mode = "ROM" then
                init_om := 25;
            else
                ASSERT FALSE
                REPORT "Illegal OPERATION_MODE property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            om <= init_om;

            -- CHECK PARAMETERS (WIDTH_A) --
            if ((width_write_a <= 0) and
                (init_om mod 6 > 1))
            then
                ASSERT FALSE
                REPORT "Illegal WIDTH_WRITE_A property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((widthad_write_a <= 0) and
                (init_om mod 6 > 1))
            then
                ASSERT FALSE
                REPORT "Illegal WIDTHAD_WRITE_A property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((width_read_a <= 0) and
                (init_om mod 6 > 0) and
                (init_om mod 6 /= 2))
            then
                ASSERT FALSE
                REPORT "Illegal WIDTH_READ_A property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((widthad_read_a <= 0) and
                (init_om mod 6 > 0) and
                (init_om mod 6 /= 2))
            then
                ASSERT FALSE
                REPORT "Illegal WIDTHAD_READ_A property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((width_read_a /= width_write_a) and
                (init_om mod 6 = 2))
            then
                ASSERT FALSE
                REPORT "WIDTH_READ_A and WIDTH_WRITE_A property values for ALTQPRAM must equal!"
                SEVERITY ERROR;
            end if;

            -- CHECK PARAMETERS (WIDTH_B) --
            if ((width_write_b <= 0) and
                (init_om mod 5 > 1))
            then
                ASSERT FALSE
                REPORT "Illegal WIDTH_WRITE_B property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((widthad_write_b <= 0) and
                (init_om mod 5 > 1))
            then
                ASSERT FALSE
                REPORT "Illegal WIDTHAD_WRITE_B property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((width_read_b <= 0) and
                (init_om mod 5 > 2))
            then
                ASSERT FALSE
                REPORT "Illegal WIDTH_READ_B property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((widthad_read_b <= 0) and
                (init_om mod 5 > 2))
            then
                ASSERT FALSE
                REPORT "Illegal WIDTHAD_READ_B property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((width_read_b /= width_write_b) and
                (init_om mod 5 = 2))
            then
                ASSERT FALSE
                REPORT "WIDTH_READ_B and WIDTH_WRITE_B property values for ALTQPRAM must equal!"
                SEVERITY ERROR;
            end if;

            -- CHECK PARAMETERS (REG_A) --
            if ((indata_reg_a /= "INCLOCK_A") and
                (indata_reg_a /= "UNREGISTERED") and
                (init_om mod 6 > 0))
            then
                ASSERT FALSE
                REPORT "Illegal INDATA_REG_A property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((wrcontrol_wraddress_reg_a /= "INCLOCK_A") and
                (wrcontrol_wraddress_reg_a /= "UNREGISTERED") and
                (init_om mod 6 > 0))
            then
                ASSERT FALSE
                REPORT "Illegal WRCONTROL_REG_A property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((outdata_reg_a /= "INCLOCK_A") and
                (outdata_reg_a /= "OUTCLOCK_A") and
                (outdata_reg_a /= "UNREGISTERED") and
                (init_om mod 6 > 0))
            then
                ASSERT FALSE
                REPORT "Illegal OUTDATA_REG_A property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((rdcontrol_reg_a /= "INCLOCK_A") and
                (rdcontrol_reg_a /= "OUTCLOCK_A") and
                (rdcontrol_reg_a /= "UNREGISTERED") and
                (init_om mod 6 > 0))
            then
                ASSERT FALSE
                REPORT "Illegal RDCONTROL_REG_A property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((rdaddress_reg_a /= "INCLOCK_A") and
                (rdaddress_reg_a /= "OUTCLOCK_A") and
                (rdaddress_reg_a /= "UNREGISTERED") and
                (init_om mod 6 > 0))
            then
                ASSERT FALSE
                REPORT "Illegal RDADDRESS_REG_A property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;

            -- CHECK PARAMETERS (REG_B) --
            if ((indata_reg_b /= "INCLOCK_B") and
                (indata_reg_b /= "UNREGISTERED") and
                (init_om mod 5 > 0))
            then
                ASSERT FALSE
                REPORT "Illegal INDATA_REG_B property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((wrcontrol_wraddress_reg_b /= "INCLOCK_B") and
                (wrcontrol_wraddress_reg_b /= "UNREGISTERED") and
                (init_om mod 5 > 0))
            then
                ASSERT FALSE
                REPORT "Illegal WRCONTROL_REG_B property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((outdata_reg_b /= "INCLOCK_B") and
                (outdata_reg_b /= "OUTCLOCK_B") and
                (outdata_reg_b /= "UNREGISTERED") and
                (init_om mod 5 > 0))
            then
                ASSERT FALSE
                REPORT "Illegal OUTDATA_REG_B property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((rdcontrol_reg_b /= "INCLOCK_B") and
                (rdcontrol_reg_b /= "OUTCLOCK_B") and
                (rdcontrol_reg_b /= "UNREGISTERED") and
                (init_om mod 5 > 0))
            then
                ASSERT FALSE
                REPORT "Illegal RDCONTROL_REG_B property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((rdaddress_reg_b /= "INCLOCK_B") and
                (rdaddress_reg_b /= "OUTCLOCK_B") and
                (rdaddress_reg_b /= "UNREGISTERED") and
                (init_om mod 5 > 0))
            then
                ASSERT FALSE
                REPORT "Illegal RDADDRESS_REG_B property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;

            -- CHECK PARAMETERS (ACLR_A) --
            if ((indata_aclr_a /= "INACLR_A") and
                (indata_aclr_a /= "NONE"))
            then
                ASSERT FALSE
                REPORT "Illegal INDATA_ACLR_A property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((wrcontrol_aclr_a /= "INACLR_A") and
                (wrcontrol_aclr_a /= "NONE"))
            then
                ASSERT FALSE
                REPORT "Illegal WRCONTROL_ACLR_A property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((wraddress_aclr_a /= "INACLR_A") and
                (wraddress_aclr_a /= "NONE"))
            then
                ASSERT FALSE
                REPORT "Illegal WRADDRESS_ACLR_A property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((outdata_aclr_a /= "INACLR_A") and
                (outdata_aclr_a /= "OUTACLR_A") and
                (outdata_aclr_a /= "NONE"))
            then
                ASSERT FALSE
                REPORT "Illegal OUTDATA_ACLR_A property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((rdcontrol_aclr_a /= "INACLR_A") and
                (rdcontrol_aclr_a /= "OUTACLR_A") and
                (rdcontrol_aclr_a /= "NONE"))
            then
                ASSERT FALSE
                REPORT "Illegal RDCONTROL_ACLR_A property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((rdaddress_aclr_a /= "INACLR_A") and
                (rdaddress_aclr_a /= "OUTACLR_A") and
                (rdaddress_aclr_a /= "NONE"))
            then
                ASSERT FALSE
                REPORT "Illegal RDADDRESS_ACLR_A property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;

            -- CHECK PARAMETERS (ACLR_B) --
            if ((indata_aclr_b /= "INACLR_B") and
                (indata_aclr_b /= "NONE"))
            then
                ASSERT FALSE
                REPORT "Illegal INDATA_ACLR_B property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((wrcontrol_aclr_b /= "INACLR_B") and
                (wrcontrol_aclr_b /= "NONE"))
            then
                ASSERT FALSE
                REPORT "Illegal WRCONTROL_ACLR_B property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((wraddress_aclr_b /= "INACLR_B") and
                (wraddress_aclr_b /= "NONE"))
            then
                ASSERT FALSE
                REPORT "Illegal WRADDRESS_ACLR_B property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((outdata_aclr_b /= "INACLR_B") and
                (outdata_aclr_b /= "OUTACLR_B") and
                (outdata_aclr_b /= "NONE"))
            then
                ASSERT FALSE
                REPORT "Illegal OUTDATA_ACLR_B property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((rdcontrol_aclr_b /= "INACLR_B") and
                (rdcontrol_aclr_b /= "OUTACLR_B") and
                (rdcontrol_aclr_b /= "NONE"))
            then
                ASSERT FALSE
                REPORT "Illegal RDCONTROL_ACLR_B property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if ((rdaddress_aclr_b /= "INACLR_B") and
                (rdaddress_aclr_b /= "OUTACLR_B") and
                (rdaddress_aclr_b /= "NONE"))
            then
                ASSERT FALSE
                REPORT "Illegal RDADDRESS_ACLR_B property value for ALTQPRAM!"
                SEVERITY ERROR;
            end if;

            -- SET DEFAULT VALUES OF NUMWORDS'S --
            if (numwords_write_a = 0) then
                inumwords_write_a <= 2**widthad_write_a;
                init_numwords_write_a := 2**widthad_write_a;
            end if;
            if (numwords_write_b = 0) then
                inumwords_write_b <= 2**widthad_write_b;
                init_numwords_write_b := 2**widthad_write_b;
            end if;
            if (numwords_read_a = 0) then
                inumwords_read_a <= 2**widthad_read_a;
                init_numwords_read_a := 2**widthad_read_a;
            end if;
            if (numwords_read_b = 0) then
                inumwords_read_b <= 2**widthad_read_b;
                init_numwords_read_b := 2**widthad_read_b;
            end if;

            -- CHECK RAM PORT SIZE --
            if ((width_read_a*init_numwords_read_a /= width_write_a*init_numwords_write_a) and
                (init_om mod 6 > 0) and (init_om mod 6 /= 2))
            then
                ASSERT FALSE
                REPORT "Inconsistant RAM size for port A of ALTQPRAM!"
                SEVERITY ERROR;
            end if;
            if (init_om mod 5 > 1) then
                if ((width_read_b*init_numwords_read_b /= width_write_b*init_numwords_write_b)) then
                    ASSERT FALSE
                    REPORT "Inconsistant RAM size for port B of ALTQPRAM!"
                    SEVERITY ERROR;
                end if;
                if ((width_read_a*init_numwords_read_a /= width_read_b*init_numwords_read_b)) then
                    ASSERT FALSE
                    REPORT "Inconsistant RAM size between port A and port B of ALTQPRAM!"
                    SEVERITY ERROR;
                end if;
            end if;

            -- CHECK RAM SIZE RATIO --
            i := width_read_b / width_read_a;
            if (i < 1) then
                i := width_read_a / width_read_b;
            end if;
            j := width_write_b / width_write_a;
            if (j < 1) then
                j := width_write_a / width_write_b;
            end if;
            k := width_write_a / width_read_a;
            if (k < 1) then
                k := width_read_a / width_write_a;
            end if;
            if ((i/=1 and i/=2 and i/=4 and i/=8 and i/=16) or
                (j/=1 and j/=2 and j/=4 and j/=8 and j/=16) or
                (k/=1 and k/=2 and k/=4 and k/=8 and k/=16))
            then
                ASSERT FALSE
                REPORT "Invalid RAM size for port A and/or port B of ALTQPRAM!"
                SEVERITY ERROR;
            end if;

            -- SET MEMORY WRITING BEHAVIOUR --
            if (wrcontrol_wraddress_reg_a /= "UNREGISTERED") then
                write_at_low_clock_a <= true;
            end if;
            if (wrcontrol_wraddress_reg_b /= "UNREGISTERED") then
                write_at_low_clock_b <= true;
            end if;

            -- INITIALIZE MEMORY --
            if (INIT_FILE = "UNUSED" or INIT_FILE = "") then
                if (init_om mod 6 = 1) then         -- if ROM mode
                    ASSERT FALSE
                    REPORT "Initialization file not found!"
                    SEVERITY ERROR;
                elsif (init_om mod 6 = 2) then      -- if SP or BDP mode
                    -- INITIALIZE MEM_DATA_W TO ALL 0 --
                    for i in mem_data_w'LOW to mem_data_w'HIGH loop
                        mem_data_w(i) := (OTHERS => '0');
                    end loop;
                else                                -- if QP or DP mode
                    -- INITIALIZE MEM_DATA TO ALL 0 --
                    for i in mem_data'LOW to mem_data'HIGH loop
                        mem_data(i) := (OTHERS => '0');
                    end loop;
                end if;
            else
				WHILE NOT ENDFILE(mem_data_file) loop
					booval := true;
					READLINE(mem_data_file, buf);
					lineno := lineno + 1;
					check_sum_vec := (OTHERS => '0');
					if (buf(buf'LOW) = ':') then
						i := 1;
						shrink_line(buf, i);
						READ(L=>buf, VALUE=>byte, good=>booval);
						if not (booval) then
							ASSERT FALSE
							REPORT "[Line "& int_to_str(lineno) & "]:Illegal Intel Hex Format!"
							SEVERITY ERROR;
						end if;
						ibyte := hex_str_to_int(byte);
						check_sum_vec := unsigned(check_sum_vec) + unsigned(CONV_STD_LOGIC_VECTOR(ibyte, 8));
						READ(L=>buf, VALUE=>startadd, good=>booval);
						if not (booval) then
							ASSERT FALSE
							REPORT "[Line "& int_to_str(lineno) & "]:Illegal Intel Hex Format! "
							SEVERITY ERROR;
						end if;
						istartadd := hex_str_to_int(startadd);
						addr(2) := startadd(4);
						addr(1) := startadd(3);
						check_sum_vec := unsigned(check_sum_vec) + unsigned(CONV_STD_LOGIC_VECTOR(hex_str_to_int(addr), 8));
						addr(2) := startadd(2);
						addr(1) := startadd(1);
						check_sum_vec := unsigned(check_sum_vec) + unsigned(CONV_STD_LOGIC_VECTOR(hex_str_to_int(addr), 8));
						READ(L=>buf, VALUE=>rec_type, good=>booval);
						if not (booval) then
							ASSERT FALSE
							REPORT "[Line "& int_to_str(lineno) & "]:Illegal Intel Hex Format! "
							SEVERITY ERROR;
						end if;
						check_sum_vec := unsigned(check_sum_vec) + unsigned(CONV_STD_LOGIC_VECTOR(hex_str_to_int(rec_type), 8));
					else
						ASSERT FALSE
						REPORT "[Line "& int_to_str(lineno) & "]:Illegal Intel Hex Format! "
						SEVERITY ERROR;
					end if;
					case rec_type is
						when "00"=>     -- Data record
							i := 0;
                                                        if (init_om mod 6 = 2) then -- if SP or BDP mode
                                                            k := (WIDTH_WRITE_A + 7) / 8;  -- # of bytes per entry
                                                        else                        -- if ROM, QP or DP mode
                                                            k := (WIDTH_READ_A + 7) / 8;  -- # of bytes per entry
                                                        end if;
							while (i < ibyte) loop
                                                                n := (k - 1)*8;
                                                                if (init_om mod 6 = 2) then
                                                                    mem_data_word_w := (others => '0');
                                                                    m := WIDTH_WRITE_A - 1;
                                                                else
                                                                    mem_data_word := (others => '0');
                                                                    m := WIDTH_READ_A - 1;
                                                                end if;
								for j in 1 to k loop
									READ(L=>buf, VALUE=>datain,good=>booval); -- read in data a byte (2 hex chars) at a time.
									if not (booval) then
										ASSERT FALSE
										REPORT "[Line "& int_to_str(lineno) & "]:Illegal Intel Hex Format! "
										SEVERITY ERROR;
									end if;
									check_sum_vec := unsigned(check_sum_vec) + unsigned(CONV_STD_LOGIC_VECTOR(hex_str_to_int(datain), 8));
                                                                        if (init_om mod 6 = 2) then -- if SP or BDP mode
                                                                            mem_data_word_w(m downto n) := CONV_STD_LOGIC_VECTOR(hex_str_to_int(datain), m-n+1);
                                                                        else                        -- if ROM, QP or DP mode
                                                                            mem_data_word(m downto n) := CONV_STD_LOGIC_VECTOR(hex_str_to_int(datain), m-n+1);
                                                                        end if;
                                                                        m := n - 1;
                                                                        n := n - 8;
								end loop;
								i := i + k;
                                                                if (init_om mod 6 = 2) then -- if SP or BDP mode
                                                                    mem_data_w(ibase + istartadd) := mem_data_word_w;
                                                                else                        -- if ROM, QP or DP mode
                                                                    mem_data(ibase + istartadd) := mem_data_word;
                                                                end if;
								istartadd := istartadd + 1;
							end loop;
						when "01"=>
							exit;
						when "02"=>
							ibase := 0;
							if (ibyte /= 2) then
								ASSERT FALSE
								REPORT "[Line "& int_to_str(lineno) & "]:Illegal Intel Hex Format for record type 02! "
								SEVERITY ERROR;
							end if;
							for i in 0 to (ibyte-1) loop
								READ(L=>buf, VALUE=>base,good=>booval);
								ibase := ibase * 256 + hex_str_to_int(base);
								if not (booval) then
									ASSERT FALSE
									REPORT "[Line "& int_to_str(lineno) & "]:Illegal Intel Hex Format! "
									SEVERITY ERROR;
								end if;
								check_sum_vec := unsigned(check_sum_vec) + unsigned(CONV_STD_LOGIC_VECTOR(hex_str_to_int(base), 8));
							end loop;
							ibase := ibase * 16;
						when OTHERS =>
							ASSERT FALSE
							REPORT "[Line "& int_to_str(lineno) & "]:Illegal record type in Intel Hex File! "
							SEVERITY ERROR;
					end case;
                    READ(L=>buf, VALUE=>checksum, good=>booval);
					if not (booval) then
						ASSERT FALSE
						REPORT "[Line "& int_to_str(lineno) & "]:Checksum is missing! "
						SEVERITY ERROR;
					end if;

                    check_sum_vec := unsigned(not (check_sum_vec)) + 1;
					check_sum_vec_tmp := CONV_STD_LOGIC_VECTOR(hex_str_to_int(checksum),8);

					if (unsigned(check_sum_vec) /= unsigned(check_sum_vec_tmp)) then
						ASSERT FALSE
						REPORT "[Line "& int_to_str(lineno) & "]:Incorrect checksum!"
						SEVERITY ERROR;
					end if;
				end loop;
			end if;
            mem_init <= TRUE;

        else -- already initialized

            ---------------------
            -- MEMORY FUNCTION --
            ---------------------
            if (iwren_tmp_a = '1' and
                om mod 6 > 1) then                  -- not ROM mode

                if (om mod 6 = 2) then              -- SP or BDP mode
                    j := ieee.std_logic_unsigned.conv_integer(iwraddress_tmp_a);
                    mem_data_w(j) := idata_tmp_a;
                else                                -- QP or DP mode
                    j := ieee.std_logic_unsigned.conv_integer(iwraddress_tmp_a) * width_write_a;
                    for i in 0 to width_write_a-1 loop
                        mem_data((j+i)/width_read_a)((j+i) mod width_read_a) := idata_tmp_a(i);
                    end loop;
                end if;
            end if;

            if (iwren_tmp_b = '1' and
                om mod 5 > 0) then                  -- QP or BDP mode
                j := ieee.std_logic_unsigned.conv_integer(iwraddress_tmp_b) * width_write_b;

                if (om mod 5 = 2) then              -- BDP mode
                    for i in 0 to width_write_b-1 loop
                        mem_data_w((j+i)/width_write_a)((j+i) mod width_write_a) := idata_tmp_b(i);
                    end loop;
                else                                -- QP mode
                    for i in 0 to width_write_b-1 loop
                        mem_data((j+i)/width_read_a)((j+i) mod width_read_a) := idata_tmp_b(i);
                    end loop;
                end if;
            end if;

            if (om mod 6 = 3) then                  -- QP or DP mode
                if irden_tmp_a = '1' then
                    j := ieee.std_logic_unsigned.conv_integer(irdaddress_tmp_a);
                    iq_tmp_a <= mem_data(j);
                end if;
            elsif (om mod 6 = 2) then               -- BDP or SP mode
                j := ieee.std_logic_unsigned.conv_integer(iwraddress_tmp_a);
                iq_tmp_a <= mem_data_w(j);
            elsif (om mod 6 = 1) then               -- ROM mode
                j := ieee.std_logic_unsigned.conv_integer(irdaddress_tmp_a);
                iq_tmp_a <= mem_data(j);
            end if;

            if (om mod 5 = 3) then                  -- QP mode
                if irden_tmp_b = '1' then
                    j := ieee.std_logic_unsigned.conv_integer(irdaddress_tmp_b) * width_read_b;
                    for i in 0 to width_read_b-1 loop
                        iq_tmp_b(i) <= mem_data((j+i)/width_read_a)((j+i) mod width_read_a);
                    end loop;
                end if;
            elsif (om mod 5 = 2) then               -- BDP mode
                j := ieee.std_logic_unsigned.conv_integer(iwraddress_tmp_b) * width_write_b;
                for i in 0 to width_write_b-1 loop
                    iq_tmp_b(i) <= mem_data_w((j+i)/width_write_a)((j+i) mod width_write_a);
                end loop;
            end if;

        end if; -- if NOT(mem_init)
	end process;

end behavior;


----------------------------------------------------------------------------
-- scfifo megafunction
----------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity SCFIFO is
    generic
      ( lpm_width               : natural;
        lpm_widthu              : natural;
        lpm_numwords            : natural;
        lpm_showahead           : string := "OFF";
        lpm_hint                : string := "USE_EAB=ON";
        almost_full_value       : natural := 0;
        almost_empty_value      : natural := 0;
        overflow_checking       : string := "ON";
        underflow_checking      : string := "ON";
        allow_rwcycle_when_full : string := "OFF";
        -- parameters that should be stored in lpm_hint
        use_eab                 : string := "ON");
    port
      ( data         : in std_logic_vector(lpm_width-1 downto 0);
        clock        : in std_logic;
        wrreq        : in std_logic;
        rdreq        : in std_logic;
        aclr         : in std_logic := '0';
        sclr         : in std_logic := '0';
        full         : out std_logic;
        almost_full  : out std_logic;
        empty        : out std_logic;
        almost_empty : out std_logic;
        q            : out std_logic_vector(lpm_width-1 downto 0);
        usedw        : out std_logic_vector(lpm_widthu-1 downto 0)
     );
end SCFIFO; 

architecture behavior of SCFIFO is

type lpm_memory is array (lpm_numwords-1 downto 0) of std_logic_vector(lpm_width-1 downto 0);

signal tmp_q : std_logic_vector(lpm_width-1 downto 0) := (OTHERS => '0');
signal read_id, write_id, count_id : integer := 0;
signal empty_flag : std_logic := '1';
signal full_flag : std_logic := '0';
constant ZEROS : std_logic_vector(lpm_width-1 downto 0) := (OTHERS => '0');

begin

	process (clock, aclr)
	variable mem_data : lpm_memory := (OTHERS => ZEROS);
    variable valid_rreq, valid_wreq : boolean;
    variable init : boolean := false;
	begin
        if (not init) then
            if (LPM_SHOWAHEAD /= "ON" and LPM_SHOWAHEAD /= "OFF") then
                ASSERT FALSE
                REPORT "Illegal LPM_SHOWAHEAD property value for SCFIFO!"
                SEVERITY ERROR;
            end if;
            if (UNDERFLOW_CHECKING /= "ON" and UNDERFLOW_CHECKING /= "OFF") then
                ASSERT FALSE
                REPORT "Illegal UNDERFLOW_CHECKING property value for SCFIFO!"
                SEVERITY ERROR;
            end if;
            if (OVERFLOW_CHECKING /= "ON" and OVERFLOW_CHECKING /= "OFF") then
                ASSERT FALSE
                REPORT "Illegal OVERFLOW_CHECKING property value for SCFIFO!"
                SEVERITY ERROR;
            end if;
            if (ALLOW_RWCYCLE_WHEN_FULL /= "ON" and ALLOW_RWCYCLE_WHEN_FULL /= "OFF") then
                ASSERT FALSE
                REPORT "Illegal ALLOW_RWCYCLE_WHEN_FULL property value for SCFIFO!"
                SEVERITY ERROR;
            end if;
            init := true;
        end if; -- not init

		if (aclr = '1') then
			tmp_q <= ZEROS;
			full_flag <= '0';
			empty_flag <= '1';
			read_id <= 0;
			write_id <= 0;
			count_id <= 0;
			if (lpm_showahead = "ON") then
				tmp_q <= mem_data(0);
			end if;
		elsif (clock'event and clock = '1') then
			if (sclr = '1') then
				tmp_q <= mem_data(read_id);
				full_flag <= '0';
				empty_flag <= '1';
				read_id <= 0;
				write_id <= 0;
				count_id <= 0;
				if (lpm_showahead = "ON") then
					tmp_q <= mem_data(0);
				end if;
			else
                valid_rreq := rdreq = '1' and (empty_flag = '0' or underflow_checking = "OFF");
                valid_wreq := wrreq = '1' and (full_flag = '0' or overflow_checking = "OFF" or
                                               (rdreq = '1' and allow_rwcycle_when_full = "ON"));

				----- IF BOTH READ AND WRITE -----
                if (valid_wreq and valid_rreq) then

					mem_data(write_id) := data;
					if (write_id >= lpm_numwords-1) then
						write_id <= 0;
					else
						write_id <= write_id + 1;
					end if;

					tmp_q <= mem_data(read_id);
					if (read_id >= lpm_numwords-1) then
						read_id <= 0;
						if (lpm_showahead = "ON") then
							tmp_q <= mem_data(0);
						end if;
					else
						read_id <= read_id + 1;
						if (lpm_showahead = "ON") then
							tmp_q <= mem_data(read_id+1);
						end if;
					end if;

				----- IF WRITE (ONLY) -----
                elsif (valid_wreq) then

					mem_data(write_id) := data;
					if (lpm_showahead = "ON") then
						tmp_q <= mem_data(read_id);
					end if;
					count_id <= count_id + 1;
					empty_flag <= '0';
					if (count_id >= lpm_numwords-1) then
						full_flag <= '1';
						count_id <= lpm_numwords;
					end if;
					if (write_id >= lpm_numwords-1) then
						write_id <= 0;
					else
						write_id <= write_id + 1;
					end if;

				----- IF READ (ONLY) -----
                elsif (valid_rreq) then

					tmp_q <= mem_data(read_id);
					count_id <= count_id - 1;
					full_flag <= '0';
					if (count_id <= 1) then
						empty_flag <= '1';
						count_id <= 0;
					end if;
					if (read_id >= lpm_numwords-1) then
						read_id <= 0;
						if (lpm_showahead = "ON") then
							tmp_q <= mem_data(0);
						end if;
					else
						read_id <= read_id + 1;
						if (lpm_showahead = "ON") then
							tmp_q <= mem_data(read_id+1);
						end if;
					end if;
				end if;  -- if WRITE and/or READ
			end if;  -- if sclr = '1'
		end if;  -- if aclr = '1'
	end process;

    process (count_id)
    begin
        if (count_id >= almost_full_value) then
            almost_full <= '1';
        else
            almost_full <= '0';
        end if;
        if (count_id < almost_empty_value) then
            almost_empty <= '1';
        else
            almost_empty <= '0';
        end if;
    end process;

	q <= tmp_q;
	full <= full_flag;
	empty <= empty_flag;
	usedw <= conv_std_logic_vector(count_id, lpm_widthu);

end behavior;


----------------------------------------------------------------------------
-- dcfifo_dffpipe (used by dcfifo)
----------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity DCFIFO_DFFPIPE is
    generic (LPM_DELAY : natural);
    port (D     : in integer;
          Q     : out integer;
          CLOCK : in std_logic;
          ACLR  : in std_logic := '0');
end DCFIFO_DFFPIPE;

architecture behavior of DCFIFO_DFFPIPE is
type delaypipe is array (LPM_DELAY downto 0) of integer;

begin

    process (clock, aclr, d)
    variable intpipe : delaypipe := (OTHERS => 0);
    variable delay : integer := LPM_DELAY-1;
    variable init : boolean := false;
    begin
        if (LPM_DELAY = 0) then
            if (aclr = '1' or not init) then
                q <= 0;
                init := true;
            else
                q <= d;
            end if;
        else
            if (aclr = '1' or not init) then
                for i in LPM_DELAY downto 0 loop
                    intpipe(i) := 0;
                end loop;
                init := true;
                q <= 0;
            end if;
            if (clock'event and clock = '1' and NOW > 0 ns) then
                if (delay > 0) then
                    for i in delay downto 1 loop
                        intpipe(i) := intpipe(i-1);
                    end loop;
                end if;
                intpipe(0) := d;
                q <= intpipe(delay);
            end if;
        end if;
    end process;

end behavior;

----------------------------------------------------------------------------
-- dcfifo_fefifo (used by dcfifo_sync and dcfifo_async)
----------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity DCFIFO_FEFIFO is
    generic (LPM_WIDTHAD  : natural;
             LPM_NUMWORDS : natural;
             UNDERFLOW_CHECKING : string := "ON";
             OVERFLOW_CHECKING : string := "ON";
             LPM_MODE     : string );
    port (USEDW_IN : in std_logic_vector(LPM_WIDTHAD-1 downto 0);
          WREQ     : in std_logic := 'Z';
          RREQ     : in std_logic := 'Z';
          EMPTY    : out std_logic;
          FULL     : out std_logic;
          CLOCK    : in std_logic;
          ACLR     : in std_logic := '0');
end DCFIFO_FEFIFO;

architecture behavior of DCFIFO_FEFIFO is
signal usedw : std_logic_vector(LPM_WIDTHAD-1 downto 0);
signal sm_empty : std_logic_vector(1 downto 0) := "00";
signal lrreq : std_logic := '0'; -- DFF;
signal i_empty : std_logic := '1';
signal i_full : std_logic := '0';
signal valid_rreq : std_logic;

begin

    -- Initialization
    process (clock, aclr)
    variable init : boolean := false;
    begin
        if (not init) then
            if (LPM_MODE /= "READ" and LPM_MODE /= "WRITE") then
                ASSERT FALSE
                REPORT "Illegal LPM_MODE property value for DCFIFO_FEFIFO!"
                SEVERITY ERROR;
            end if;
            if (UNDERFLOW_CHECKING /= "ON" and UNDERFLOW_CHECKING /= "OFF") then
                ASSERT FALSE
                REPORT "Illegal UNDERFLOW_CHECKING property value for DCFIFO_FEFIFO!"
                SEVERITY ERROR;
            end if;
            if (OVERFLOW_CHECKING /= "ON" and OVERFLOW_CHECKING /= "OFF") then
                ASSERT FALSE
                REPORT "Illegal OVERFLOW_CHECKING property value for DCFIFO_FEFIFO!"
                SEVERITY ERROR;
            end if;
            init := true;
        end if; -- not init
    end process;

    valid_rreq <= rreq when underflow_checking = "OFF" else
                  rreq and not i_empty;

    process (clock, aclr)
    begin
        if (aclr = '1') then
            lrreq <= '0';
        elsif (clock'event and clock = '1' and NOW > 0 ns) then
            lrreq <= valid_rreq;
        end if;
    end process;

    process (clock, aclr)
    variable almost_full : integer := 0;
    begin
        if (aclr = '1') then
            i_full <= '0';
        elsif (clock'event and clock = '1' and NOW > 0 ns) then
            if (lpm_numwords >= 3) then
                almost_full := lpm_numwords-3;
            end if;
            if (unsigned(usedw) >= almost_full) then
                i_full <= '1';
            else
                i_full <= '0';
            end if;
        end if;
    end process;

    process (clock, aclr)
    variable local_sm_empty : std_logic_vector(1 downto 0) := "00";
    variable usedw_is_1 : boolean;
    begin
        local_sm_empty := sm_empty;
        if (aclr = '1') then
            local_sm_empty := "00";
        elsif (clock'event and clock = '1' and NOW > 0 ns) then
            if (lpm_mode = "READ") then
                case sm_empty is
                    when "00" =>                    -- state_empty
                        if (usedw /= 0) then
                            local_sm_empty := "01";
                        end if;
                    when "01" =>                    -- state_non_empty
                        usedw_is_1 := (usedw = 1 and lrreq = '0') or (usedw = 2 and lrreq = '1');
                        if (rreq = '1' and usedw_is_1) then
                            local_sm_empty := "10";
                        end if;
                    when "10" =>                    -- state_emptywait
                        if (usedw > 1) then
                            local_sm_empty := "01";
                        else
                            local_sm_empty := "00";
                        end if;
                    when others =>
                        -- INTERNAL ERROR
                end case;
            elsif (lpm_mode = "WRITE") then
                case sm_empty is
                    when "00" =>                    -- state_empty
                        if (wreq = '1') then
                            local_sm_empty := "01";
                        end if;
                    when "01" =>                    -- state_one
                        if (wreq = '0') then
                            local_sm_empty := "11";
                        end if;
                    when "11" =>                    -- state_non_empty
                        if (wreq = '1') then
                            local_sm_empty := "01";
                        elsif (usedw = 0) then
                            local_sm_empty := "00";
                        end if;
                    when others =>
                        -- INTERNAL ERROR
                end case;
            end if;
        end if;
        sm_empty <= local_sm_empty;
        i_empty <= not local_sm_empty(0);
    end process;

    usedw <= usedw_in;
    empty <= i_empty;
    full <= i_full;

end behavior;


----------------------------------------------------------------------------
-- dcfifo_async (used by dcfifo)
----------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity DCFIFO_ASYNC is
    generic
      ( lpm_width               : natural;
        lpm_widthu              : natural;
        lpm_numwords            : natural;
        lpm_showahead           : string := "OFF";
        lpm_hint                : string := "USE_EAB=ON";
        overflow_checking       : string := "ON";
        underflow_checking      : string := "ON";
        delay_rdusedw           : natural := 1;
        delay_wrusedw           : natural := 1;
        rdsync_delaypipe        : natural := 3;
        wrsync_delaypipe        : natural := 3;
        -- parameters that should be stored in lpm_hint
        use_eab                 : string := "ON";
        clocks_are_synchronized : string := "FALSE");
    port
      ( data    : in std_logic_vector(lpm_width-1 downto 0);
        rdclk   : in std_logic;
        wrclk   : in std_logic;
        wrreq   : in std_logic;
        rdreq   : in std_logic;
        aclr    : in std_logic := '0';
        rdfull  : out std_logic;
        wrfull  : out std_logic;
        wrempty : out std_logic;
        rdempty : out std_logic;
        q       : out std_logic_vector(lpm_width-1 downto 0);
        rdusedw : out std_logic_vector(lpm_widthu-1 downto 0);
        wrusedw : out std_logic_vector(lpm_widthu-1 downto 0));
end DCFIFO_ASYNC; 

architecture behavior of DCFIFO_ASYNC is

type lpm_memory is array (2**lpm_widthu-1 downto 0) of std_logic_vector(lpm_width-1 downto 0);

signal i_q : std_logic_vector(lpm_width-1 downto 0) := (OTHERS => '0');
signal i_rdptr, i_wrptr, i_rdptrrg, i_wrdelaycycle : integer := 0;
signal i_ws_nbrp, i_rs_nbwp, i_ws_dbrp, i_rs_dbwp : integer := 0;
signal i_wr_udwn, i_rd_udwn, i_wr_dbuw, i_rd_dbuw : integer := 0;
signal i_rdempty, i_wrempty : std_logic := '1';
signal i_rdfull, i_wrfull : std_logic := '0';
signal i_rdusedw, i_wrusedw : integer := 0;
signal i_rden, i_wren, i_rdenclock : std_logic := '0';
signal slv_wr_dbuw, slv_rd_dbuw : std_logic_vector(lpm_widthu-1 downto 0);

signal i_data_tmp, i_data_reg : std_logic_vector(lpm_width-1 downto 0);
signal i_q_tmp, i_q_reg : std_logic_vector(lpm_width-1 downto 0) := (OTHERS => '0');
signal i_rdptr_tmp, i_wrptr_tmp, i_wrptr_reg : integer := 0;
signal i_wren_tmp, i_wren_reg : std_logic := '0';

constant ZEROS : std_logic_vector(lpm_width-1 downto 0) := (OTHERS => '0');
constant GRAY_DELAYPIPE : integer := 1;
constant WRUSEDW_DELAYPIPE : integer := 1;  -- delayed usedw to compute empty/full
constant RDUSEDW_DELAYPIPE : integer := 1;  -- delayed usedw to compute empty/full

component DCFIFO_FEFIFO
    generic (LPM_WIDTHAD : natural;
             LPM_NUMWORDS : natural;
             UNDERFLOW_CHECKING : string := "ON";
             OVERFLOW_CHECKING : string := "ON";
             LPM_MODE : string);
    port (USEDW_IN : in std_logic_vector(LPM_WIDTHAD-1 downto 0);
          WREQ : in std_logic := 'Z';
          RREQ : in std_logic := 'Z';
          EMPTY : out std_logic;
          FULL : out std_logic;
          CLOCK : in std_logic;
          ACLR : in std_logic := '0');
end component;

component DCFIFO_DFFPIPE
    generic (LPM_DELAY : natural);
    port (D : in integer;
          Q : out integer;
          CLOCK : in std_logic;
          ACLR : in std_logic := '0');
end component;

begin

    -- Initialization
    process (wrclk, rdclk, aclr)
    variable init : boolean := false;
    begin
        if (not init) then
            if (LPM_SHOWAHEAD /= "ON" and LPM_SHOWAHEAD /= "OFF") then
                ASSERT FALSE
                REPORT "Illegal LPM_SHOWAHEAD property value for DCFIFO!"
                SEVERITY ERROR;
            end if;
            if (UNDERFLOW_CHECKING /= "ON" and UNDERFLOW_CHECKING /= "OFF") then
                ASSERT FALSE
                REPORT "Illegal UNDERFLOW_CHECKING property value for DCFIFO!"
                SEVERITY ERROR;
            end if;
            if (OVERFLOW_CHECKING /= "ON" and OVERFLOW_CHECKING /= "OFF") then
                ASSERT FALSE
                REPORT "Illegal OVERFLOW_CHECKING property value for DCFIFO!"
                SEVERITY ERROR;
            end if;
            init := true;
        end if; -- not init
    end process;


    ----------
    -- FIFOram
    ----------

    i_rden <= rdreq when underflow_checking = "OFF" else
              rdreq and not i_rdempty;
    i_wren <= wrreq when overflow_checking = "OFF" else
              wrreq and not i_wrfull;

    FIFOram_sync: process (i_data_reg, i_q_tmp, i_q_reg, aclr,
                           i_rdptr, i_wren_reg, i_wrptr_reg)
    begin
        if (aclr = '1') then
            i_wrptr_tmp <= 0;
            i_rdptr_tmp <= 0;
            i_wren_tmp <= '0';
            i_data_tmp <= (OTHERS => '0');
            if (LPM_SHOWAHEAD = "ON") then
                i_q <= i_q_tmp;
            else
                i_q <= (OTHERS => '0');
            end if;
        else
            i_wrptr_tmp <= i_wrptr_reg;
            i_rdptr_tmp <= i_rdptr;
            i_wren_tmp <= i_wren_reg;
            i_data_tmp <= i_data_reg;
            if (LPM_SHOWAHEAD = "ON") then
                i_q <= i_q_tmp;
            else
                i_q <= i_q_reg;
            end if;
        end if;
    end process;

    FIFOram_wrclk: process (wrclk, aclr)
    begin
        if (aclr = '1') then
            i_data_reg <= (OTHERS => '0');
            i_wrptr_reg <= 0;
            i_wren_reg <= '0';
        elsif (wrclk'event and wrclk = '1' and NOW > 0 ns) then
            i_data_reg <= data;
            i_wrptr_reg <= i_wrptr;
            i_wren_reg <= i_wren;
        end if;
    end process;

    FIFOram_rdclk: process (rdclk, aclr)
    begin
        if (aclr = '1') then
            i_q_reg <= (OTHERS => '0');
        elsif (rdclk'event and rdclk = '1' and i_rden = '1' and NOW > 0 ns) then
            i_q_reg <= i_q_tmp;
        end if;
    end process;

    FIFOram_memory: process (i_data_tmp, i_wren_tmp, i_wrptr_tmp, i_rdptr_tmp, wrclk)
    variable mem_data : lpm_memory := (OTHERS => ZEROS);
    variable init : boolean := false;
    begin
        if (not init) then
            for i in lpm_numwords-1 downto 0 loop
                mem_data(i) := ZEROS;
            end loop;
            init := true;
        end if;
        if wrclk'event and i_wren_tmp='1' and
            ((wrclk='1' and USE_EAB="OFF") or
             (wrclk='0' and USE_EAB="ON")) then
            mem_data(i_wrptr_tmp) := i_data_tmp;
        end if;
        i_q_tmp <= mem_data(i_rdptr_tmp);
    end process;


    -----------
    -- Counters
    -----------

    rdptr: process (rdclk, aclr)
    begin
        if (aclr = '1') then
            i_rdptr <= 0;
        elsif (rdclk'event and rdclk = '1' and i_rden = '1' and NOW > 0 ns) then
            if (i_rdptr < 2**lpm_widthu-1) then
                i_rdptr <= i_rdptr + 1;
            else
                i_rdptr <= 0;
            end if;
        end if;
    end process;

    wrptr: process (wrclk, aclr)
    begin
        if (aclr = '1') then
            i_wrptr <= 0;
        elsif (wrclk'event and wrclk = '1' and i_wren = '1' and NOW > 0 ns) then
            if (i_wrptr < 2**lpm_widthu-1) then
                i_wrptr <= i_wrptr + 1;
            else
                i_wrptr <= 0;
            end if;
        end if;
    end process;


    ---------------------
    -- Delays & DFF Pipes
    ---------------------

    process (rdclk)
    begin
        if (rdclk = '0') then
            i_rdenclock <= '0';
        elsif (rdclk = '1' and i_rden = '1') then
            i_rdenclock <= '1';
        end if;
    end process;

    RDPTR_D:    DCFIFO_DFFPIPE
                    generic map (LPM_DELAY => 0)
                    port map (D => i_rdptr, Q => i_rdptrrg,
                              CLOCK => i_rdenclock, ACLR => aclr);

    WRPTR_D:    DCFIFO_DFFPIPE
                    generic map (LPM_DELAY => 1)
                    port map (D => i_wrptr, Q => i_wrdelaycycle,
                              CLOCK => wrclk, ACLR => aclr);

    WS_NBRP:    DCFIFO_DFFPIPE
                    generic map (LPM_DELAY => WRSYNC_DELAYPIPE)
                    port map (D => i_rdptrrg, Q => i_ws_nbrp,
                              CLOCK => wrclk, ACLR => aclr);

    RS_NBWP:    DCFIFO_DFFPIPE
                    generic map (LPM_DELAY => RDSYNC_DELAYPIPE)
                    port map (D => i_wrdelaycycle, Q => i_rs_nbwp,
                              CLOCK => rdclk, ACLR => aclr);

    WS_DBRP:    DCFIFO_DFFPIPE
                    generic map (LPM_DELAY => GRAY_DELAYPIPE)
                    port map (D => i_ws_nbrp, Q => i_ws_dbrp,
                              CLOCK => wrclk, ACLR => aclr);

    RS_DBWP:    DCFIFO_DFFPIPE
                    generic map (LPM_DELAY => GRAY_DELAYPIPE)
                    port map (D => i_rs_nbwp, Q => i_rs_dbwp,
                              CLOCK => rdclk, ACLR => aclr);

    process (i_wrptr, i_ws_dbrp)
    begin
        i_wr_udwn <= i_wrptr - i_ws_dbrp;
    end process;
            
    process (i_rdptr, i_rs_dbwp)
    begin
        i_rd_udwn <= i_rs_dbwp - i_rdptr;
    end process;
            
    WR_USEDW:   DCFIFO_DFFPIPE
                    generic map (LPM_DELAY => DELAY_WRUSEDW)
                    port map (D => i_wr_udwn, Q => i_wrusedw,
                              CLOCK => wrclk, ACLR => aclr);

    RD_USEDW:   DCFIFO_DFFPIPE
                    generic map (LPM_DELAY => DELAY_RDUSEDW)
                    port map (D => i_rd_udwn, Q => i_rdusedw,
                              CLOCK => rdclk, ACLR => aclr);

    WR_DBUW:    DCFIFO_DFFPIPE
                    generic map (LPM_DELAY => WRUSEDW_DELAYPIPE)
                    port map (D => i_wr_udwn, Q => i_wr_dbuw,
                              CLOCK => wrclk, ACLR => aclr);

    RD_DBUW:    DCFIFO_DFFPIPE
                    generic map (LPM_DELAY => RDUSEDW_DELAYPIPE)
                    port map (D => i_rd_udwn, Q => i_rd_dbuw,
                              CLOCK => rdclk, ACLR => aclr);


    -------------
    -- Full/Empty
    -------------

    slv_wr_dbuw <= conv_std_logic_vector(i_wr_dbuw, LPM_WIDTHU);
    slv_rd_dbuw <= conv_std_logic_vector(i_rd_dbuw, LPM_WIDTHU);

    WR_FE:  DCFIFO_FEFIFO
                generic map (LPM_WIDTHAD => LPM_WIDTHU,
                             LPM_NUMWORDS => LPM_NUMWORDS,
                             UNDERFLOW_CHECKING => UNDERFLOW_CHECKING,
                             OVERFLOW_CHECKING => OVERFLOW_CHECKING,
                             LPM_MODE => "WRITE")
                port map (USEDW_IN => slv_wr_dbuw, WREQ => wrreq,
                          CLOCK => wrclk, ACLR => aclr,
                          EMPTY => i_wrempty, FULL => i_wrfull);

    RD_FE:  DCFIFO_FEFIFO
                generic map (LPM_WIDTHAD => LPM_WIDTHU,
                             LPM_NUMWORDS => LPM_NUMWORDS,
                             UNDERFLOW_CHECKING => UNDERFLOW_CHECKING,
                             OVERFLOW_CHECKING => OVERFLOW_CHECKING,
                             LPM_MODE => "READ")
                port map (USEDW_IN => slv_rd_dbuw, RREQ => rdreq,
                          CLOCK => rdclk, ACLR => aclr,
                          EMPTY => i_rdempty, FULL => i_rdfull);

    ----------
    -- Outputs
    ----------

    q <= i_q;
    wrfull <= i_wrfull;
    wrempty <= i_wrempty;
    rdfull <= i_rdfull;
    rdempty <= i_rdempty;
    wrusedw <= conv_std_logic_vector(i_wrusedw, LPM_WIDTHU);
    rdusedw <= conv_std_logic_vector(i_rdusedw, LPM_WIDTHU);

end behavior;


----------------------------------------------------------------------------
-- dcfifo_sync (used by dcfifo)
----------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity DCFIFO_SYNC is
    generic
      ( lpm_width               : natural;
        lpm_widthu              : natural;
        lpm_numwords            : natural;
        lpm_showahead           : string := "OFF";
        overflow_checking       : string := "ON";
        underflow_checking      : string := "ON";
        use_eab                 : string := "ON");
    port
      ( data    : in std_logic_vector(lpm_width-1 downto 0);
        rdclk   : in std_logic;
        wrclk   : in std_logic;
        wrreq   : in std_logic;
        rdreq   : in std_logic;
        aclr    : in std_logic := '0';
        rdfull  : out std_logic;
        wrfull  : out std_logic;
        wrempty : out std_logic;
        rdempty : out std_logic;
        q       : out std_logic_vector(lpm_width-1 downto 0);
        rdusedw : out std_logic_vector(lpm_widthu-1 downto 0);
        wrusedw : out std_logic_vector(lpm_widthu-1 downto 0));
end DCFIFO_SYNC;

architecture behavior of DCFIFO_SYNC is

type lpm_memory is array (2**lpm_widthu-1 downto 0) of std_logic_vector(lpm_width-1 downto 0);

signal i_q : std_logic_vector(lpm_width-1 downto 0) := (OTHERS => '0');
signal i_rdptr, i_wrptr : integer := 0;
signal i_rdptr_s, i_wrptr_r, i_wrptr_s : integer := 0;
signal i_rdempty, i_wrempty : std_logic := '1';
signal i_rdfull, i_wrfull : std_logic := '0';
signal i_rdusedw, i_wrusedw : integer := 0;
signal i_rden, i_wren : std_logic := '0';
signal i_cnt_mod : integer;

signal i_data_tmp, i_data_reg : std_logic_vector(lpm_width-1 downto 0);
signal i_q_tmp, i_q_reg : std_logic_vector(lpm_width-1 downto 0) := (OTHERS => '0');
signal i_rdptr_tmp, i_wrptr_tmp, i_wrptr_reg : integer := 0;
signal i_wren_tmp, i_wren_reg : std_logic := '0';

constant ZEROS : std_logic_vector(lpm_width-1 downto 0) := (OTHERS => '0');
constant GRAY_DELAYPIPE : integer := 1;
constant WRUSEDW_DELAYPIPE : integer := 1;  -- delayed usedw to compute empty/full
constant RDUSEDW_DELAYPIPE : integer := 1;  -- delayed usedw to compute empty/full

component DCFIFO_FEFIFO
    generic (LPM_WIDTHAD : natural;
             LPM_NUMWORDS : natural;
             UNDERFLOW_CHECKING : string := "ON";
             OVERFLOW_CHECKING : string := "ON";
             LPM_MODE : string);
    port (USEDW_IN : in std_logic_vector(LPM_WIDTHAD-1 downto 0);
          WREQ : in std_logic := 'Z';
          RREQ : in std_logic := 'Z';
          EMPTY : out std_logic;
          FULL : out std_logic;
          CLOCK : in std_logic;
          ACLR : in std_logic := '0');
end component;

component DCFIFO_DFFPIPE
    generic (LPM_DELAY : natural);
    port (D : in integer;
          Q : out integer;
          CLOCK : in std_logic;
          ACLR : in std_logic := '0');
end component;

begin

    -- Initialization
    process (wrclk, rdclk, aclr)
    variable init : boolean := false;
    begin
        if (not init) then
            if (LPM_SHOWAHEAD /= "ON" and LPM_SHOWAHEAD /= "OFF") then
                ASSERT FALSE
                REPORT "Illegal LPM_SHOWAHEAD property value for DCFIFO!"
                SEVERITY ERROR;
            end if;
            if (UNDERFLOW_CHECKING /= "ON" and UNDERFLOW_CHECKING /= "OFF") then
                ASSERT FALSE
                REPORT "Illegal UNDERFLOW_CHECKING property value for DCFIFO!"
                SEVERITY ERROR;
            end if;
            if (OVERFLOW_CHECKING /= "ON" and OVERFLOW_CHECKING /= "OFF") then
                ASSERT FALSE
                REPORT "Illegal OVERFLOW_CHECKING property value for DCFIFO!"
                SEVERITY ERROR;
            end if;
            if (LPM_NUMWORDS > 2**LPM_WIDTHU) then
                ASSERT FALSE
                REPORT "LPM_NUMWORDS must be less than or equal to 2**LPM_WIDTHU!"
                SEVERITY ERROR;
            end if;

            if lpm_numwords = 2**lpm_widthu then
                i_cnt_mod <= 2**(lpm_widthu+1);
            else
                i_cnt_mod <= 2**lpm_widthu;
            end if;

            init := true;
        end if; -- not init
    end process;


    ----------
    -- FIFOram
    ----------

    i_rden <= rdreq when (underflow_checking = "OFF") else
              rdreq and not i_rdempty;
    i_wren <= wrreq when (overflow_checking = "OFF") else
              wrreq and not i_wrfull;

    FIFOram_sync: process (i_data_reg, i_q_tmp, i_q_reg, aclr,
                           i_rdptr, i_wren_reg, i_wrptr_reg)
    begin
        if (aclr = '1') then
            i_wrptr_tmp <= 0;
            i_rdptr_tmp <= 0;
            i_wren_tmp <= '0';
            i_data_tmp <= (OTHERS => '0');
            if (LPM_SHOWAHEAD = "ON") then
                i_q <= i_q_tmp;
            else
                i_q <= (OTHERS => '0');
            end if;
        else
            i_wrptr_tmp <= i_wrptr_reg;
            i_rdptr_tmp <= i_rdptr;
            i_wren_tmp <= i_wren_reg;
            i_data_tmp <= i_data_reg;
            if (LPM_SHOWAHEAD = "ON") then
                i_q <= i_q_tmp;
            else
                i_q <= i_q_reg;
            end if;
        end if;
    end process;

    FIFOram_wrclk: process (wrclk, aclr)
    begin
        if (aclr = '1') then
            i_data_reg <= (OTHERS => '0');
            i_wrptr_reg <= 0;
            i_wren_reg <= '0';
        elsif (wrclk'event and wrclk = '1' and NOW > 0 ns) then
            i_data_reg <= data;
            i_wrptr_reg <= i_wrptr;
            i_wren_reg <= i_wren;
        end if;
    end process;

    FIFOram_rdclk: process (rdclk, aclr)
    begin
        if (aclr = '1') then
            i_q_reg <= (OTHERS => '0');
        elsif (rdclk'event and rdclk = '1' and i_rden = '1' and NOW > 0 ns) then
            i_q_reg <= i_q_tmp;
        end if;
    end process;

    FIFOram_memory: process (i_data_tmp, i_wren_tmp, i_wrptr_tmp, i_rdptr_tmp, wrclk)
    variable mem_data : lpm_memory := (OTHERS => ZEROS);
    variable init : boolean := false;
    begin
        if (not init) then
            for i in lpm_numwords-1 downto 0 loop
                mem_data(i) := ZEROS;
            end loop;
            init := true;
        end if;
        if wrclk'event and i_wren_tmp='1' and NOW > 0 ns and
            ((wrclk='1' and USE_EAB="OFF") or
             (wrclk='0' and USE_EAB="ON")) then
            mem_data(i_wrptr_tmp mod (2**lpm_widthu)) := i_data_tmp;
        end if;
        i_q_tmp <= mem_data(i_rdptr_tmp mod (2**lpm_widthu));
    end process;


    -----------
    -- Counters
    -----------

    rdptr: process (rdclk, aclr)
    begin
        if (aclr = '1') then
            i_rdptr <= 0;
        elsif (rdclk'event and rdclk = '1' and i_rden = '1' and NOW > 0 ns) then
            if (i_rdptr < i_cnt_mod-1) then
                i_rdptr <= i_rdptr + 1;
            else
                i_rdptr <= 0;
            end if;
        end if;
    end process;

    wrptr: process (wrclk, aclr)
    begin
        if (aclr = '1') then
            i_wrptr <= 0;
        elsif (wrclk'event and wrclk = '1' and i_wren = '1' and NOW > 0 ns) then
            if (i_wrptr < i_cnt_mod-1) then
                i_wrptr <= i_wrptr + 1;
            else
                i_wrptr <= 0;
            end if;
        end if;
    end process;


    ---------
    -- Delays
    ---------

    RDPTR_D:    DCFIFO_DFFPIPE
                    generic map (LPM_DELAY => 1)
                    port map (D => i_rdptr, Q => i_rdptr_s,
                              CLOCK => wrclk, ACLR => aclr);

    WRPTR_D:    DCFIFO_DFFPIPE
                    generic map (LPM_DELAY => 1)
                    port map (D => i_wrptr, Q => i_wrptr_r,
                              CLOCK => wrclk, ACLR => aclr);

    WRPTR_E:    DCFIFO_DFFPIPE
                    generic map (LPM_DELAY => 1)
                    port map (D => i_wrptr_r, Q => i_wrptr_s,
                              CLOCK => rdclk, ACLR => aclr);


    -------------------
    -- Usedw/Full/Empty
    -------------------

    process (i_wrptr, i_rdptr_s)
    begin        
        i_wrusedw <= (i_wrptr - i_rdptr_s) mod i_cnt_mod;
    end process;
            
    process (i_rdptr, i_wrptr_s)
    begin
        i_rdusedw <= (i_wrptr_s - i_rdptr) mod i_cnt_mod;
    end process;

    process (i_wrusedw)
    begin
        i_wrfull <= '0';
        i_wrempty <= '0';

        if ((lpm_numwords = 2**lpm_widthu) and (i_wrusedw >= 2**lpm_widthu)) or
           ((lpm_numwords < 2**lpm_widthu) and (i_wrusedw = lpm_numwords)) then
            i_wrfull <= '1';
        end if;
        if (i_wrusedw = 0) then
            i_wrempty <= '1';
        end if;
    end process;

    process (i_rdusedw)
    begin
        i_rdfull <= '0';
        i_rdempty <= '0';

        if ((lpm_numwords = 2**lpm_widthu) and (i_rdusedw >= 2**lpm_widthu)) or
           ((lpm_numwords < 2**lpm_widthu) and (i_rdusedw = lpm_numwords)) then
            i_rdfull <= '1';
        end if;
        if (i_rdusedw = 0) then
            i_rdempty <= '1';
        end if;
    end process;


    ----------
    -- Outputs
    ----------

    q <= i_q;
    wrfull <= i_wrfull;
    wrempty <= i_wrempty;
    rdfull <= i_rdfull;
    rdempty <= i_rdempty;
    wrusedw <= conv_std_logic_vector(i_wrusedw, LPM_WIDTHU);
    rdusedw <= conv_std_logic_vector(i_rdusedw, LPM_WIDTHU);

end behavior;


----------------------------------------------------------------------------
-- dcfifo megafunction
----------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity DCFIFO is
    generic
      ( lpm_width               : natural;
        lpm_widthu              : natural;
        lpm_numwords            : natural;
        lpm_showahead           : string := "OFF";
        lpm_hint                : string := "USE_EAB=ON";
        overflow_checking       : string := "ON";
        underflow_checking      : string := "ON";
        delay_rdusedw           : natural := 1;
        delay_wrusedw           : natural := 1;
        rdsync_delaypipe        : natural := 3;
        wrsync_delaypipe        : natural := 3;
        -- parameters that should be stored in lpm_hint
        use_eab                 : string := "ON";
        clocks_are_synchronized : string := "FALSE");
    port
      ( data    : in std_logic_vector(lpm_width-1 downto 0);
        rdclk   : in std_logic;
        wrclk   : in std_logic;
        wrreq   : in std_logic;
        rdreq   : in std_logic;
        aclr    : in std_logic := '0';
        rdfull  : out std_logic;
        wrfull  : out std_logic;
        wrempty : out std_logic;
        rdempty : out std_logic;
        q       : out std_logic_vector(lpm_width-1 downto 0);
        rdusedw : out std_logic_vector(lpm_widthu-1 downto 0);
        wrusedw : out std_logic_vector(lpm_widthu-1 downto 0));
end DCFIFO; 

architecture behavior of DCFIFO is

signal i_q_s, i_q_a : std_logic_vector(lpm_width-1 downto 0);
signal i_wrusedw_s, i_wrusedw_a : std_logic_vector(lpm_widthu-1 downto 0);
signal i_rdusedw_s, i_rdusedw_a : std_logic_vector(lpm_widthu-1 downto 0);
signal i_wrfull_s, i_wrfull_a, i_rdfull_s, i_rdfull_a : std_logic;
signal i_wrempty_s, i_wrempty_a, i_rdempty_s, i_rdempty_a : std_logic;

component DCFIFO_ASYNC
    generic
      ( lpm_width               : natural;
        lpm_widthu              : natural;
        lpm_numwords            : natural;
        lpm_showahead           : string := "OFF";
        overflow_checking       : string := "ON";
        underflow_checking      : string := "ON";
        delay_rdusedw           : natural := 1;
        delay_wrusedw           : natural := 1;
        rdsync_delaypipe        : natural := 3;
        wrsync_delaypipe        : natural := 3;
        use_eab                 : string := "ON");
    port
      ( data    : in std_logic_vector(lpm_width-1 downto 0);
        rdclk   : in std_logic;
        wrclk   : in std_logic;
        wrreq   : in std_logic;
        rdreq   : in std_logic;
        aclr    : in std_logic := '0';
        rdfull  : out std_logic;
        wrfull  : out std_logic;
        wrempty : out std_logic;
        rdempty : out std_logic;
        q       : out std_logic_vector(lpm_width-1 downto 0);
        rdusedw : out std_logic_vector(lpm_widthu-1 downto 0);
        wrusedw : out std_logic_vector(lpm_widthu-1 downto 0));
end component;

component DCFIFO_SYNC
    generic
      ( lpm_width               : natural;
        lpm_widthu              : natural;
        lpm_numwords            : natural;
        lpm_showahead           : string := "OFF";
        overflow_checking       : string := "ON";
        underflow_checking      : string := "ON";
        use_eab                 : string := "ON");
    port
      ( data    : in std_logic_vector(lpm_width-1 downto 0);
        rdclk   : in std_logic;
        wrclk   : in std_logic;
        wrreq   : in std_logic;
        rdreq   : in std_logic;
        aclr    : in std_logic := '0';
        rdfull  : out std_logic;
        wrfull  : out std_logic;
        wrempty : out std_logic;
        rdempty : out std_logic;
        q       : out std_logic_vector(lpm_width-1 downto 0);
        rdusedw : out std_logic_vector(lpm_widthu-1 downto 0);
        wrusedw : out std_logic_vector(lpm_widthu-1 downto 0));
end component;

begin

    ASYNC:  DCFIFO_ASYNC
                generic map (lpm_width => lpm_width,
                             lpm_widthu => lpm_widthu,
                             lpm_numwords => lpm_numwords,
                             lpm_showahead => lpm_showahead,
                             overflow_checking => overflow_checking,
                             underflow_checking => underflow_checking,
                             delay_rdusedw => delay_rdusedw,
                             delay_wrusedw => delay_wrusedw,
                             rdsync_delaypipe => rdsync_delaypipe,
                             wrsync_delaypipe => wrsync_delaypipe,
                             use_eab => use_eab)
                port map (data => data, rdclk => rdclk, wrclk => wrclk,
                          wrreq => wrreq, rdreq => rdreq, aclr => aclr,
                          rdfull => i_rdfull_a, wrfull => i_wrfull_a,
                          rdempty => i_rdempty_a, wrempty => i_wrempty_a,
                          rdusedw => i_rdusedw_a, wrusedw => i_wrusedw_a,
                          q => i_q_a);

    SYNC:   DCFIFO_SYNC
                generic map (lpm_width => lpm_width,
                             lpm_widthu => lpm_widthu,
                             lpm_numwords => lpm_numwords,
                             lpm_showahead => lpm_showahead,
                             overflow_checking => overflow_checking,
                             underflow_checking => underflow_checking,
                             use_eab => use_eab)
                port map (data => data, rdclk => rdclk, wrclk => wrclk,
                          wrreq => wrreq, rdreq => rdreq, aclr => aclr,
                          rdfull => i_rdfull_s, wrfull => i_wrfull_s,
                          rdempty => i_rdempty_s, wrempty => i_wrempty_s,
                          rdusedw => i_rdusedw_s, wrusedw => i_wrusedw_s,
                          q => i_q_s);

    rdfull <= i_rdfull_a when clocks_are_synchronized = "FALSE" else
              i_rdfull_s;
    wrfull <= i_wrfull_a when clocks_are_synchronized = "FALSE" else
              i_wrfull_s;
    rdempty <= i_rdempty_a when clocks_are_synchronized = "FALSE" else
               i_rdempty_s;
    wrempty <= i_wrempty_a when clocks_are_synchronized = "FALSE" else
               i_wrempty_s;
    rdusedw <= i_rdusedw_a when clocks_are_synchronized = "FALSE" else
               i_rdusedw_s;
    wrusedw <= i_wrusedw_a when clocks_are_synchronized = "FALSE" else
               i_wrusedw_s;
    q <= i_q_a when clocks_are_synchronized = "FALSE" else
         i_q_s;

end behavior;





--
-- Excalibur DPRAM atom.
--

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_textio.all;
use std.textio.all;

entity alt_exc_dpram is
    generic 
      ( width          : integer;
        widthad        : integer;
        depth          : integer;
        ramblock       : integer := 65535;
        operation_mode : string := "SINGLE_PORT";
        output_mode    : string := "REG";
        lpm_file       : string := "NONE");

    port
      ( portaclk : in std_logic := '0';
        portaena : in std_logic := '1';
        portawe : in std_logic := '0';
        portaaddr : in std_logic_vector(widthad-1 downto 0) := (others =>'0');
        portadatain : in std_logic_vector(width-1 downto 0) := (others =>'0');
        portadataout : out std_logic_vector(width-1 downto 0);
        portbclk : in std_logic := '0';
        portbena : in std_logic := '1';
        portbwe : in std_logic := '0';
        portbaddr : in std_logic_vector(widthad-1 downto 0) := (others =>'0');
        portbdatain : in std_logic_vector(width-1 downto 0) := (others =>'0');
        portbdataout : out std_logic_vector(width-1 downto 0));

end alt_exc_dpram;


architecture behaviour of alt_exc_dpram is

	--
	-- Hex Read procedure.
	--
	procedure local_Char2QuadBits(C: Character; 
				RESULT: out Bit_Vector(3 downto 0);
				GOOD: out Boolean;
				ISSUE_ERROR: in Boolean) is
	begin
		case c is
			when '0' => result :=  x"0"; good := TRUE;
			when '1' => result :=  x"1"; good := TRUE;
			when '2' => result :=  x"2"; good := TRUE;
			when '3' => result :=  x"3"; good := TRUE;
			when '4' => result :=  x"4"; good := TRUE;
			when '5' => result :=  x"5"; good := TRUE;
			when '6' => result :=  x"6"; good := TRUE;
			when '7' => result :=  x"7"; good := TRUE;
			when '8' => result :=  x"8"; good := TRUE;
			when '9' => result :=  x"9"; good := TRUE;
			when 'A' => result :=  x"A"; good := TRUE;
			when 'B' => result :=  x"B"; good := TRUE;
			when 'C' => result :=  x"C"; good := TRUE;
			when 'D' => result :=  x"D"; good := TRUE;
			when 'E' => result :=  x"E"; good := TRUE;
			when 'F' => result :=  x"F"; good := TRUE;
 
			when 'a' => result :=  x"A"; good := TRUE;
			when 'b' => result :=  x"B"; good := TRUE;
			when 'c' => result :=  x"C"; good := TRUE;
			when 'd' => result :=  x"D"; good := TRUE;
			when 'e' => result :=  x"E"; good := TRUE;
			when 'f' => result :=  x"F"; good := TRUE;
			when others =>
			   if ISSUE_ERROR then 
				   assert FALSE report
					"HREAD Error: Read a '" & c &
					   "', expected a Hex character (0-F).";
			   end if;
			   good := FALSE;
		end case;
	end;

	procedure HREAD_BV(L:inout LINE; VALUE:out BIT_VECTOR)  is
		variable ok: boolean;
		variable c:  character;
		constant ne: integer := value'length/4;
		variable bv: bit_vector(0 to value'length-1);
		variable s:  string(1 to ne-1);
	begin
		if value'length mod 4 /= 0 then
			assert FALSE report 
				"HREAD_BV Error: Trying to read vector " &
				   "with an odd (non multiple of 4) length";
			return;
		end if;

		loop					-- skip white space
			read(l,c);
			exit when ((c /= ' ') and (c /= CR) and (c /= HT));
		end loop;

		local_Char2QuadBits(c, bv(0 to 3), ok, TRUE);
		if not ok then 
			return;
		end if;

		read(L, s, ok);
		if not ok then
			assert FALSE 
				report "HREAD_bv Error: Failed to read the STRING";
			return;
		end if;

		for i in 1 to ne-1 loop
			local_Char2QuadBits(s(i), bv(4*i to 4*i+3), ok, TRUE);
			if not ok then
				return;
			end if;
		end loop;
		value := bv;
	end HREAD_bv; 

type dpram_memory is array (depth-1 downto 0) of std_logic_vector(width-1 downto 0);


        -------------------------
        function dpram_loadmem return dpram_memory is
            variable result           : dpram_memory := (others=>(others=>'X'));
            file     memory_file      : TEXT is in lpm_file            ;
            variable data_line        : LINE                             ;
            variable memory_bitvector : bit_vector (width-1 downto 0)    ; 
            variable line_counter     : INTEGER := 0                     ; 

        begin
            read_memory : while not ENDFILE(memory_file)
            loop
                if ( line_counter <= depth-1 ) 
                then 
                    READLINE (memory_file, data_line) ;
                    if ( data_line'LENGTH = 0 ) then 
                        next ;
                    elsif ( data_line (1) = '/' )  then 
                        next ;
                    end if ;
                    HREAD_bv (data_line , memory_bitvector ) ;
                    result (line_counter) := To_StdLogicVector (memory_bitvector) ;
                    line_counter := line_counter + 1 ; 
                end if ; 
            end loop ; 
            return result;
        end dpram_loadmem;
        -------------------------

        -------------------------
        function dpram_checkmem return dpram_memory is
            variable result : dpram_memory := (others=>(others=>'X'));
        begin

            if (lpm_file /= "NONE" and lpm_file /= "none") 
            then 
                result := dpram_loadmem ;
            end if ;

            return result;

        end dpram_checkmem;
        -------------------------

signal dpram_content        : dpram_memory := dpram_checkmem ;

signal portadataout_reg   : std_logic_vector(width-1 downto 0);
signal portbdataout_reg   : std_logic_vector(width-1 downto 0);
signal portadataout_reg_out : std_logic_vector(width-1 downto 0);
signal portbdataout_reg_out : std_logic_vector(width-1 downto 0);
signal portadataout_unreg : std_logic_vector(width-1 downto 0);
signal portbdataout_unreg : std_logic_vector(width-1 downto 0);

signal portaclk_ipd       : std_logic;
signal portbclk_ipd       : std_logic;
signal portawe_ipd        : std_logic;
signal portbwe_ipd        : std_logic;
signal portaena_ipd       : std_logic;
signal portbena_ipd       : std_logic;
signal portadatain_ipd    : std_logic_vector(width-1   downto 0);
signal portbdatain_ipd    : std_logic_vector(width-1   downto 0);
signal portaaddr_ipd      : std_logic_vector(widthad-1 downto 0);
signal portbaddr_ipd      : std_logic_vector(widthad-1 downto 0);

signal portadataout_tmp   : std_logic_vector(width-1   downto 0);
signal portbdataout_tmp   : std_logic_vector(width-1   downto 0);



begin

  portaclk_ipd  <= portaclk;
  portawe_ipd   <= portawe;
  portaena_ipd  <= portaena;
  portadatain_ipd  <= portadatain;

  portbclk_ipd  <= portbclk;
  portbwe_ipd   <= portbwe;
  portbena_ipd  <= portbena;

  portadatain_ipd  <= portadatain;
  portbdatain_ipd  <= portbdatain;
    
  portaaddr_ipd  <= portaaddr;
  portbaddr_ipd  <= portbaddr;

  portadataout   <= portadataout_tmp;
  portbdataout   <= portbdataout_tmp;   


CLOCK: process(portaclk_ipd, portbclk_ipd)

  variable portawe_latched : std_ulogic;
  variable portbwe_latched : std_ulogic;

  variable address_A : integer;
  variable address_B : integer;
  variable valid_addr_A    : boolean:=FALSE;
  variable valid_addr_B    : boolean:=FALSE;
  
begin

--  Dual Port Contention  Port A address = Port B address
--
--  +-----------+----------+-------------+-------------+--------------+--------------+---------------------+
--  |  Port A   |  Port B  |  A Data In  |  B Data In  |  A Data Out  |  B Data Out  |     Memory State    |
--  +-----------+----------+-------------+-------------+--------------+--------------+---------------------+
--  |   read    |   read   |     DA      |     DB      |    memory    |    memory    |      no change      |
--  +-----------+----------+-------------+-------------+--------------+--------------+---------------------+
--  |   write   |   read   |     DA      |     DB      |    unknown   |    unknown   |    memory <= DA     |
--  +-----------+----------+-------------+-------------+--------------+--------------+---------------------+
--  |   read    |   write  |     DA      |     DB      |    unknown   |    unknown   |    memory <= DB     |
--  +-----------+----------+-------------+-------------+--------------+--------------+---------------------+
--  |   write   |   write  |     DA      |     DB      |    unknown   |    unknown   |  memory <= unknown  |
--  +-----------+----------+-------------+-------------+--------------+--------------+---------------------+
--
--  Dual Port Contention  Port A address != Port B address
--
--  +-----------+----------+-------------+-------------+--------------+--------------+---------------------+
--  |  Port A   |  Port B  |  A Data In  |  B Data In  |  A Data Out  |  B Data Out  |     Memory State    |
--  +-----------+----------+-------------+-------------+--------------+--------------+---------------------+
--  |   read    |   read   |     DA      |     DB      |  mem[A_addr] |  mem[B_Addr] |      no change      |
--  +-----------+----------+-------------+-------------+--------------+--------------+---------------------+
--  |   write   |   read   |     DA      |     DB      |    unknown   |  mem[B_Addr] |  mem[A_Addr] <= DA  |
--  +-----------+----------+-------------+-------------+--------------+--------------+---------------------+
--  |   read    |   write  |     DA      |     DB      |  mem[A_addr] |    unknown   |  mem[B_Addr] <= DB  |
--  +-----------+----------+-------------+-------------+--------------+--------------+---------------------+
--  |   write   |   write  |     DA      |     DB      |    unknown   |    unknown   |  mem[A_Addr] <= DA  |
--  |           |          |             |             |              |              |  mem[B_Addr] <= DB  |
--  +-----------+----------+-------------+-------------+--------------+--------------+---------------------+
-- 
-- NB: output is always unknown when writing



  if(portaclk_ipd'event and portaclk_ipd='1') then  -- rising edge port a clock
  
    portawe_latched := portawe_ipd;

    valid_addr_A := not Is_X(portaaddr_ipd(widthad-1 downto 0));

    if ( valid_addr_A ) then 

      address_A       := conv_integer(portaaddr_ipd);

         if portawe_latched ='0' 
         then
	     -- reading from A
             if valid_addr_B and address_A = address_B and portbwe_latched = '1' 
             then
                 -- B simultaneously writing to same address (effect of B write to memory handled below)
                 portadataout_reg         <= portadataout_unreg;
                 portadataout_unreg       <= (others => 'X')   ;
             else
                 -- B reading from same address, or reading/writing to different address. 
                 portadataout_reg   <= portadataout_unreg      ;
                 portadataout_unreg <= dpram_content(address_A);
             end if;
         else
             -- writing to A
             if valid_addr_B and address_A = address_B and portawe_latched = '1' and portbwe_latched = '1' 
             then
                 -- A and B simultaneously writing to same address
                 portadataout_reg         <= portadataout_unreg;
                 dpram_content(address_A) <= (others => 'X')   ;
                 portadataout_unreg       <= (others => 'X')   ;
             else
                 -- B reading from same address or reading/writing to different address
                 portadataout_reg         <= portadataout_unreg;
                 dpram_content(address_A) <= portadatain_ipd   ;
                 portadataout_unreg       <= (others => 'X')   ;
             end if;
         end if;

    else 
        portadataout_reg    <= portadataout_unreg;
        address_A           := 0 ; 
        portadataout_unreg  <= (others => 'X')   ;
    end if ; 

  end if ; 
    
  if (portbclk_ipd'event and portbclk_ipd = '1') then  -- rising edge port b clock

    portbwe_latched := portbwe_ipd;

    valid_addr_B := not Is_X(portbaddr_ipd(widthad-1 downto 0));

    if ( valid_addr_B ) then 

       address_B := conv_integer(portbaddr_ipd);
 
         if portbwe_latched ='0' 
         then
	     -- reading from B
             if valid_addr_A and address_B = address_A and portawe_latched = '1' 
             then
                 -- A simultaneously writing to same address (effect of A write to memory handled above)
                 portbdataout_reg         <= portbdataout_unreg;
                 portbdataout_unreg       <= (others => 'X')   ;
             else
                 -- A reading from same address, or reading/writing to different address. 
                 portbdataout_reg   <= portbdataout_unreg      ;
                 portbdataout_unreg <= dpram_content(address_B);
             end if;
         else
             -- writing to B
             if valid_addr_A and address_B = address_A and portbwe_latched = '1' and portawe_latched = '1' 
             then
                 -- B and A simultaneously writing to same address
                 portbdataout_reg         <= portbdataout_unreg;
                 dpram_content(address_B) <= (others => 'X')   ;
                 portbdataout_unreg       <= (others => 'X')   ;
             else
                 -- A reading from same address or reading/writing to different address
                 portbdataout_reg         <= portbdataout_unreg;
                 dpram_content(address_B) <= portbdatain_ipd   ;
                 portbdataout_unreg       <= (others => 'X')   ;
             end if;
         end if;

      else 
        portbdataout_reg   <= portbdataout_unreg;
        address_B          := 0 ; 
        portbdataout_unreg <= (others => 'X')   ;
       end if ; 

      end if;
  end process CLOCK;


  OUTPUT_ENABLE_A : process(portaena_ipd, portadataout_reg)
  begin
      if((output_mode = "REG" or output_mode = "reg") and portaena_ipd = '1') then
          portadataout_reg_out <= portadataout_reg ;  
      end if;
  end process OUTPUT_ENABLE_A;

  OUTPUT_ENABLE_B : process(portbena_ipd, portbdataout_reg)
  begin
      if((output_mode = "REG" or output_mode = "reg") and portbena_ipd = '1') then
          portbdataout_reg_out <= portbdataout_reg ;  
      end if;
  end process OUTPUT_ENABLE_B;


REG_UNREG_SEL_A : process(portadataout_reg_out, portadataout_unreg)
begin
  if(output_mode = "UNREG" or output_mode = "unreg") then
    portadataout_tmp <= portadataout_unreg;
  else
    portadataout_tmp <= portadataout_reg_out;
  end if;
end process REG_UNREG_SEL_A;


REG_UNREG_SEL_B : process(portbdataout_reg_out, portbdataout_unreg)
begin
  if(output_mode = "UNREG" or output_mode = "unreg") then
    portbdataout_tmp <= portbdataout_unreg;
  else
    portbdataout_tmp <= portbdataout_reg_out;
  end if;
end process REG_UNREG_SEL_B;

end behaviour;



--
-- Excalibur UPCORE atom.
--

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_textio.all;
use IEEE.std_logic_unsigned.all;
use std.textio.all;


entity alt_exc_upcore is
    generic
      ( processor      : string := "ARM";
        source         : string := "");

    port
      ( intpld    : in  std_logic_vector(5 downto 0) := (others => '0');
        intuart   : out std_logic;
        inttimer0 : out std_logic;
        inttimer1 : out std_logic;
        intproc0  : out std_logic;
        intproc1  : out std_logic;

        debugrq      : in  std_logic := '0';
        debugext0    : in  std_logic := '0';
        debugext1    : in  std_logic := '0';
        debugiebrkpt : in  std_logic := '0';
        debugdewpt   : in  std_logic := '0';
        debugextin   : in  std_logic_vector(3 downto 0) := (others => '0');
        debugack     : out std_logic;
        debugrng0    : out std_logic;
        debugrng1    : out std_logic;
        debugextout  : out std_logic_vector(3 downto 0);

        slavehclk      : in  std_logic := '0';
        slavehwrite    : in  std_logic := '0';
        slavehreadyi   : in  std_logic := '0';
        slavehselreg   : in  std_logic := '0';
        slavehsel      : in  std_logic := '0';
        slavehmastlock : in  std_logic := '0';
        slavehaddr     : in  std_logic_vector(31 downto 0) := (others => '0');
        slavehwdata    : in  std_logic_vector(31 downto 0) := (others => '0');
        slavehtrans    : in  std_logic_vector(1 downto 0) := (others => '0');
        slavehsize     : in  std_logic_vector(1 downto 0) := (others => '0');
        slavehburst    : in  std_logic_vector(2 downto 0) := (others => '0');
        slavehreadyo   : out std_logic;
        slavebuserrint : out std_logic;
        slavehrdata    : out std_logic_vector(31 downto 0);
        slavehresp     : out std_logic_vector(1 downto 0);

        masterhclk     : in  std_logic := '0';
        masterhrdata   : in  std_logic_vector(31 downto 0) := (others => '0');
        masterhresp    : in  std_logic_vector(1 downto 0) := (others => '0');
        masterhwrite   : out std_logic;
        masterhlock    : out std_logic;
        masterhbusreq  : out std_logic;
        masterhaddr    : out std_logic_vector(31 downto 0);
        masterhwdata   : out std_logic_vector(31 downto 0);
        masterhtrans   : out std_logic_vector(1 downto 0);
        masterhsize    : out std_logic_vector(1 downto 0);
        masterhready   : in  std_logic := '0';
        masterhburst   : out std_logic_vector(2 downto 0);
        masterhgrant   : in  std_logic := '1';

        lockreqdp0   : in  std_logic := '0';
        lockreqdp1   : in  std_logic := '0';
        lockgrantdp0 : out std_logic;
        lockgrantdp1 : out std_logic;

        ebiack  : in  std_logic := '0';
        ebiwen  : out std_logic;
        ebioen  : out std_logic;
        ebiclk  : out std_logic;
        ebibe   : out std_logic_vector(1 downto 0);
        ebicsn  : out std_logic_vector(3 downto 0);
        ebiaddr : out std_logic_vector(24 downto 0);

        ebidq : inout std_logic_vector(15 downto 0) := (others => '0');

        uarttxd  : out   std_logic;
        uartrtsn : out   std_logic;
        uartdtrn : out   std_logic;
        uartctsn : in    std_logic := '0';
        uartdsrn : in    std_logic := '0';
        uartrxd  : in    std_logic := '0';
        uartdcdn : inout std_logic := '0';
        uartrin  : inout std_logic := '0';

        sdramclk  : out std_logic;
        sdramclkn : out std_logic;
        sdramclke : out std_logic;
        sdramwen  : out std_logic;
        sdramcasn : out std_logic;
        sdramrasn : out std_logic;
        sdramdqm  : out std_logic_vector(3 downto 0);
        sdramaddr : out std_logic_vector(14 downto 0);
        sdramcsn  : out std_logic_vector(1 downto 0);

        sdramdq  : inout std_logic_vector(31 downto 0) := (others => '0');
        sdramdqs : inout std_logic_vector(3 downto 0) := (others => '0');

        intextpin     : in  std_logic := '0';
        traceclk      : out std_logic;
        tracesync     : out std_logic;
        tracepipestat : out std_logic_vector(2 downto 0);
        tracepkt      : out std_logic_vector(15 downto 0));

end alt_exc_upcore;


architecture behaviour of alt_exc_upcore is

	--
	-- Hex Read and Write procedures.
	--
	procedure local_Char2QuadBits(C: Character; 
				RESULT: out Bit_Vector(3 downto 0);
				GOOD: out Boolean;
				ISSUE_ERROR: in Boolean) is
	begin
		case c is
			when '0' => result :=  x"0"; good := TRUE;
			when '1' => result :=  x"1"; good := TRUE;
			when '2' => result :=  x"2"; good := TRUE;
			when '3' => result :=  x"3"; good := TRUE;
			when '4' => result :=  x"4"; good := TRUE;
			when '5' => result :=  x"5"; good := TRUE;
			when '6' => result :=  x"6"; good := TRUE;
			when '7' => result :=  x"7"; good := TRUE;
			when '8' => result :=  x"8"; good := TRUE;
			when '9' => result :=  x"9"; good := TRUE;
			when 'A' => result :=  x"A"; good := TRUE;
			when 'B' => result :=  x"B"; good := TRUE;
			when 'C' => result :=  x"C"; good := TRUE;
			when 'D' => result :=  x"D"; good := TRUE;
			when 'E' => result :=  x"E"; good := TRUE;
			when 'F' => result :=  x"F"; good := TRUE;
 
			when 'a' => result :=  x"A"; good := TRUE;
			when 'b' => result :=  x"B"; good := TRUE;
			when 'c' => result :=  x"C"; good := TRUE;
			when 'd' => result :=  x"D"; good := TRUE;
			when 'e' => result :=  x"E"; good := TRUE;
			when 'f' => result :=  x"F"; good := TRUE;
			when others =>
			   if ISSUE_ERROR then 
				   assert FALSE report
					"HREAD Error: Read a '" & c &
					   "', expected a Hex character (0-F).";
			   end if;
			   good := FALSE;
		end case;
	end;

	procedure HREAD_BV(L:inout LINE; VALUE:out BIT_VECTOR)  is
		variable ok: boolean;
		variable c:  character;
		constant ne: integer := value'length/4;
		variable bv: bit_vector(0 to value'length-1);
		variable s:  string(1 to ne-1);
	begin
		if value'length mod 4 /= 0 then
			assert FALSE report 
				"HREAD_BV Error: Trying to read vector " &
				   "with an odd (non multiple of 4) length";
			return;
		end if;

		loop					-- skip white space
			read(l,c);
			exit when ((c /= ' ') and (c /= CR) and (c /= HT));
		end loop;

		local_Char2QuadBits(c, bv(0 to 3), ok, TRUE);
		if not ok then 
			return;
		end if;

		read(L, s, ok);
		if not ok then
			assert FALSE 
				report "HREAD_bv Error: Failed to read the STRING";
			return;
		end if;

		for i in 1 to ne-1 loop
			local_Char2QuadBits(s(i), bv(4*i to 4*i+3), ok, TRUE);
			if not ok then
				return;
			end if;
		end loop;
		value := bv;
	end HREAD_bv; 


     -- functions to match Verilog functions and operators

     -- Bitwise left shift
        function shift_left ( val : std_logic_vector ) return std_logic_vector is
            variable result : std_logic_vector(val'length-1 downto 0);
        begin
            result:=val;
            if (val'length>1) then
                for i in (val'length-1) downto 1 loop
                    result(i):=result(i-1);
                end loop;
            end if;
            result(0) := '0';
            return result;
        end shift_left;
        function shift_left ( val : std_logic_vector; n : integer ) return std_logic_vector is
            variable result : std_logic_vector(val'length-1 downto 0);
        begin
            result:=val;
            for i in 1 to n loop
                result:=shift_left(result);
            end loop;
            return result;
        end shift_left;
	

     -- Unary reduction OR : use ur_OR(foo) as a replacement for Verilog (|foo).
        function ur_OR (val : std_logic_vector ) return std_logic is
            variable result : std_logic ;
        begin
            if (val'length > 0) then
                result := val(val'length-1) ;
                for i in (val'length-2) downto 0 loop
                    result := (result or val(i));
                end loop;
            else
                result := '0';
            end if;
            return result;
        end ur_OR;

     -- Unary reduction XOR : use ur_XOR(foo) as a replacement for Verilog (^foo).
        function ur_XOR (val : std_logic_vector ) return std_logic is
            variable result : std_logic := '0' ;
            variable count  : integer   :=  0  ;
        begin
            if (val'length > 0) then
                for i in (val'length-1) downto 0 loop
                    if (result /= 'X') then
                        if    (val(i) = '1') then count  := count + 1 ;
                        elsif (val(i) = 'X') then result := 'X'  ;
                        end if ; 
                    end if ; 
                end loop;
            else
                result := '0';
            end if;
            if ( result = 'X') then 
                return result ;
            elsif (count > 1 ) then 
                return '0' ;
            else
                return '1' ;
            end if ;
        end ur_XOR;


     -- Components



     -- +---------------+
     -- | AHB Constants |
     -- +---------------+

     -- // number of memory banks   
        constant  NUMBANKS           : integer := 6 ;
	
     -- // respones (HRESP)
        constant  H_OKAY   : std_logic_vector(1 downto 0) := "00" ;
        constant  H_ERROR  : std_logic_vector(1 downto 0) := "01" ;
        constant  H_RETRY  : std_logic_vector(1 downto 0) := "10" ;
        constant  H_SPLIT  : std_logic_vector(1 downto 0) := "11" ;
	
     -- // transaction types (HTRANS)
        constant  H_IDLE   : std_logic_vector(1 downto 0) := "00" ;
        constant  H_BUSY   : std_logic_vector(1 downto 0) := "01" ;
        constant  H_NONSEQ : std_logic_vector(1 downto 0) := "10" ;
        constant  H_SEQ    : std_logic_vector(1 downto 0) := "11" ;
	
     -- // burst mode (HBURST)
        constant  H_SINGLE : std_logic_vector(2 downto 0) := "000";
        constant  H_INCR   : std_logic_vector(2 downto 0) := "001";
        constant  H_WRAP4  : std_logic_vector(2 downto 0) := "010";
        constant  H_INCR4  : std_logic_vector(2 downto 0) := "011";
        constant  H_WRAP8  : std_logic_vector(2 downto 0) := "100";
        constant  H_INCR8  : std_logic_vector(2 downto 0) := "101";
        constant  H_WRAP16 : std_logic_vector(2 downto 0) := "110";
        constant  H_INCR16 : std_logic_vector(2 downto 0) := "111";
	
     -- // transaction sizes (HSIZE 8,16,32 bits -- larger sizes not supported)
        constant  H_BYTE   : std_logic_vector(1 downto 0) := "00" ;
        constant  H_HWORD  : std_logic_vector(1 downto 0) := "01" ;
        constant  H_WORD   : std_logic_vector(1 downto 0) := "10" ;

     -- // maximum number of transmissions   
        constant  NUMTRANS           : integer :=   2048       ; -- was 65535, but may lead to memory allocation problems

     -- // data sub-ranges within transmission
        constant  Trns_b             : integer :=    255       ; 
        --                                           255..254  ; -- spare
        constant  Trns_RESP_b        : integer :=    253       ; -- response
        constant  Trns_RESP_l        : integer :=    252       ;
        constant  Trns_READ_b        : integer :=    251       ; -- read data
        constant  Trns_READ_l        : integer :=    220       ;
        constant  Trns_BUSY          : integer :=    219       ; -- go busy 
        --                                           218..217  ; -- spare
        constant  Trns_NUMSEQBEATS_b : integer :=    216       ; -- number of beats in sequential transaction
        constant  Trns_NUMSEQBEATS_l : integer :=    208       ;
        constant  Trns_STARTADDR_b   : integer :=    207       ; -- start address of transaction
        constant  Trns_STARTADDR_l   : integer :=    176       ; 
        constant  Trns_EXPDATA_b     : integer :=    175       ; -- expected data
        constant  Trns_EXPDATA_l     : integer :=    144       ;
        constant  Trns_TRANSNUM_b    : integer :=    143       ; -- transaction number
        constant  Trns_TRANSNUM_l    : integer :=    128       ; 
        -- ----------------------------------------------------  -- following fields read from command file
        --                                           127..112  ; -- spare
        --                                           111..109  ; -- spare
        constant  Trns_BUSCOMMD      : integer :=    108       ; -- bus command (0 => inactive)
        constant  Trns_ADDR_b        : integer :=    107       ; -- address
        constant  Trns_ADDR_l        : integer :=     76       ;
        --                                            75.. 73  ; -- spare
        constant  Trns_WRITE         : integer :=     72       ; -- write
        constant  Trns_DATA_b        : integer :=     71       ; -- write data / expected read data
        constant  Trns_DATA_l        : integer :=     40       ;
        --                                            39.. 37  ; -- spare
        constant  Trns_LOCK          : integer :=     36       ; -- lock (not implemented)
        --                                            35.. 33  ; -- spare
        constant  Trns_CHKDATA       : integer :=     32       ; -- check expected data (not implemented)
        --                                            31.. 30  ; -- spare
        constant  Trns_TRANSTYPE_b   : integer :=     29       ; -- transaction type
        constant  Trns_TRANSTYPE_l   : integer :=     28       ; 
        --                                            27.. 23  ; -- spare
        constant  Trns_BURSTTYPE_b   : integer :=     22       ; -- burst type
        constant  Trns_BURSTTYPE_l   : integer :=     20       ;
        --                                            19       ; -- spare
        constant  Trns_SIZE_b        : integer :=     18       ; -- size
        constant  Trns_SIZE_l        : integer :=     16       ;
        constant  Trns_RPTCOUNT_b    : integer :=     15       ; -- repeat count
        constant  Trns_RPTCOUNT_l    : integer :=      0       ;

     -- +------------+
     -- | slave port |
     -- +------------+

     -- record of address and control information (latched on address phase)

        signal  startReg  : std_logic_vector(31 downto 0) := ( others => '0') ; --// start address for burst
        signal   addrReg  : std_logic_vector(31 downto 0) := ( others => '0') ;
        signal 	transReg  : std_logic_vector( 1 downto 0) := H_IDLE           ;
        signal   sizeReg  : std_logic_vector( 1 downto 0) := H_WORD           ;
        signal 	writeReg  : std_logic                     := '0'              ;
        signal 	burstReg  : std_logic_vector( 2 downto 0) := H_SINGLE         ;
        signal    selReg  : std_logic                     := '0'              ;
        signal   waitReg  : std_logic_vector( 7 downto 0) := ( others => '0') ;

     -- Implement 6 banks of 256K = (1.5MB of address space)
        
        constant membank_size     : integer := 20480 ; -- full 65535 leads to memory allocation problems

        type upcore_membank       is array (0 to membank_size) of std_logic_vector(31 downto 0);  
        type upcore_bankcfg       is array (0 to 5) of std_logic_vector(79 downto 0);
        type upcore_bankstart_end is array (0 to 5) of std_logic_vector(31 downto 0);
        type upcore_memwait       is array (0 to 5) of std_logic_vector( 7 downto 0);

        constant start_addr_b     : integer := 79   ; -- start address index upper limit
        constant start_addr_l     : integer := 48   ; -- start address index lower limit
        constant end_addr_b       : integer := 47   ; -- end address index upper limit
        constant end_addr_l       : integer := 16   ; -- end address index lower limit
        constant first_acc_wait_b : integer := 15   ; -- wait states on first access index upper limit
        constant first_acc_wait_l : integer :=  8   ; -- wait states on first access index lower limit
        constant cycle_wait_b     : integer :=  7   ; -- wait states per cycle index upper limit
        constant cycle_wait_l     : integer :=  0   ; -- wait states per cycle index lower limit

        -------------------------
        function upcore_loadcfg return upcore_bankcfg is
            file     slavememory_cfg       : TEXT is in "slavememory.cfg.dat"          ;
            variable result                : upcore_bankcfg := (others=>(others=>'0')) ;
            variable memory_cfg_bitvector  : bit_vector (start_addr_b downto 0)        ;
            variable mem_bank_counter      : INTEGER := 0                              ;
            variable cfgline               : LINE                                      ; 
        begin

                read_memory : while (not ENDFILE(slavememory_cfg) and (mem_bank_counter < NUMBANKS))
                loop
                 -- read next data line 
                    READLINE (slavememory_cfg, cfgline) ;
                    if ( cfgline'LENGTH = 0 ) then 
                        next ;
                    elsif ( cfgline (1) = '/' )  then 
                        next ;
                    end if ;
                 -- data is a 20 digit (memory_bitvector'LENGTH/4) HEX string
                    HREAD_bv (cfgline , memory_cfg_bitvector ) ;
                    result   (mem_bank_counter) := To_StdLogicVector ( memory_cfg_bitvector );
                    mem_bank_counter := mem_bank_counter + 1 ;
                end loop; -- read_memory 

            return result;
        end upcore_loadcfg;
        -------------------------

        signal memCfg       : upcore_bankcfg       := upcore_loadcfg                ; -- // slavememory.cfg.dat

        -------------------------
        function upcore_loadbank(bank        : integer        ;
                                 bank_string : string(1 to 17);  
                                 config      : upcore_bankcfg ) return upcore_membank is
            variable result           : upcore_membank := (others=>(others=>'0'));
            file     memory_file      : TEXT is in bank_string           ;
            variable data_line        : LINE                             ;
            variable memory_bitvector : bit_vector (31 downto 0)         ; 
            variable line_counter     : INTEGER := 0                     ; 

        begin
            read_slave_bank : while not ENDFILE(memory_file)
            loop
                READLINE (memory_file, data_line) ;
                if ( data_line'LENGTH = 0 ) then 
                    next ;
                elsif ( data_line (1) = '/' )  then 
                    next ;
                end if ;
                HREAD_bv (data_line , memory_bitvector ) ;
                result (line_counter) := To_StdLogicVector (memory_bitvector) ;
                line_counter := line_counter + 1 ; 
            end loop ; 
            return result;
        end upcore_loadbank;
        -------------------------


        -------------------------
        function upcore_checkbank(bank        : integer         ;
                                  bank_string : string(1 to 17) ) return upcore_membank is
            variable config : upcore_bankcfg  := upcore_loadcfg ;
            variable result : upcore_membank  := (others=>(others=>'0'));
        begin

         -- If end =/= start, read in the memory file (otherwise everything set to zero).

            if (   conv_integer((config(bank)(start_addr_b downto start_addr_l))) /= conv_integer((config(bank)(end_addr_b downto end_addr_l))) ) 
            then 
                result := upcore_loadbank(bank,bank_string,config);
            end if ; -- different start and end address
            return result;

        end upcore_checkbank;
        -------------------------

        -------------------------
        function initialise_memstart return upcore_bankstart_end is
            variable config : upcore_bankcfg := upcore_loadcfg ;
            variable result : upcore_bankstart_end := (others=>(others=>'0'))  ;
        begin 
            result(0) := config(0) (start_addr_b downto start_addr_l);
            result(1) := config(1) (start_addr_b downto start_addr_l);
            result(2) := config(2) (start_addr_b downto start_addr_l);
            result(3) := config(3) (start_addr_b downto start_addr_l);
            result(4) := config(4) (start_addr_b downto start_addr_l);
            result(5) := config(5) (start_addr_b downto start_addr_l);
            return result;
        end initialise_memstart;
        -------------------------

        -------------------------
        function initialise_memend return upcore_bankstart_end is
            variable config : upcore_bankcfg := upcore_loadcfg ;
            variable result : upcore_bankstart_end := (others=>(others=>'0'))  ;
        begin 
            result(0) := config(0) (end_addr_b downto end_addr_l);
            result(1) := config(1) (end_addr_b downto end_addr_l);
            result(2) := config(2) (end_addr_b downto end_addr_l);
            result(3) := config(3) (end_addr_b downto end_addr_l);
            result(4) := config(4) (end_addr_b downto end_addr_l);
            result(5) := config(5) (end_addr_b downto end_addr_l);
            return result;
        end initialise_memend;
        -------------------------
	
        -------------------------
        function initialise_memwaitstart return upcore_memwait is
            variable config : upcore_bankcfg := upcore_loadcfg ;
            variable result : upcore_memwait := (others=>(others=>'0'))  ;
        begin 
            result(0) := config(0) (first_acc_wait_b downto first_acc_wait_l);
            result(1) := config(1) (first_acc_wait_b downto first_acc_wait_l);
            result(2) := config(2) (first_acc_wait_b downto first_acc_wait_l);
            result(3) := config(3) (first_acc_wait_b downto first_acc_wait_l);
            result(4) := config(4) (first_acc_wait_b downto first_acc_wait_l);
            result(5) := config(5) (first_acc_wait_b downto first_acc_wait_l);
            return result;
        end initialise_memwaitstart;
        -------------------------

        -------------------------
        function initialise_memwait return upcore_memwait is
            variable config : upcore_bankcfg := upcore_loadcfg ;
            variable result : upcore_memwait := (others=>(others=>'0'))  ;
        begin 
            result(0) := config(0) (cycle_wait_b downto cycle_wait_l);
            result(1) := config(1) (cycle_wait_b downto cycle_wait_l);
            result(2) := config(2) (cycle_wait_b downto cycle_wait_l);
            result(3) := config(3) (cycle_wait_b downto cycle_wait_l);
            result(4) := config(4) (cycle_wait_b downto cycle_wait_l);
            result(5) := config(5) (cycle_wait_b downto cycle_wait_l);
            return result;
        end initialise_memwait;
        -------------------------

        signal memStart     : upcore_bankstart_end := initialise_memstart                     ;
        signal memEnd       : upcore_bankstart_end := initialise_memend                       ;
        signal memWaitStart : upcore_memwait       := initialise_memwaitstart                 ;
        signal memWait      : upcore_memwait       := initialise_memwait                      ;
        signal memMapA      : upcore_membank       := upcore_checkbank(0,"slavememory.0.dat") ;
        signal memMapB      : upcore_membank       := upcore_checkbank(1,"slavememory.1.dat") ;
        signal memMapC      : upcore_membank       := upcore_checkbank(2,"slavememory.2.dat") ;
        signal memMapD      : upcore_membank       := upcore_checkbank(3,"slavememory.3.dat") ;
        signal memMapE      : upcore_membank       := upcore_checkbank(4,"slavememory.4.dat") ;
        signal memMapF      : upcore_membank       := upcore_checkbank(5,"slavememory.5.dat") ;
	
        signal sel          : std_logic                     := '0'           ;
        signal doWork       : std_logic                     := '0'           ;
        signal doBusyWork   : std_logic                     := '0'           ;
        signal seqTrans     : std_logic                     := '0'           ;

        signal wrapmask     : std_logic_vector(31 downto 0) := (others=>'0') ;
        signal wrapmask_w   : std_logic_vector(31 downto 0) := (others=>'0') ;
        signal seqPlusAddr  : std_logic_vector(31 downto 0) := (others=>'0') ;
        signal seqAddr      : std_logic_vector(31 downto 0) := (others=>'0') ;
        signal startNext    : std_logic_vector(31 downto 0) := (others=>'0') ;
        signal addrNext     : std_logic_vector(31 downto 0) := (others=>'0') ;
        signal transNext    : std_logic_vector( 1 downto 0) := (others=>'0') ;
        signal sizeNext     : std_logic_vector( 1 downto 0) := (others=>'0') ;
        signal burstNext    : std_logic_vector( 2 downto 0) := (others=>'0') ;
        signal writeNext    : std_logic                     := '0'           ;
		
        signal bankA        : std_logic                     := '0'           ;
        signal bankB        : std_logic                     := '0'           ;
        signal bankC        : std_logic                     := '0'           ;
        signal bankD        : std_logic                     := '0'           ;
        signal bankE        : std_logic                     := '0'           ;
        signal bankF        : std_logic                     := '0'           ;
        signal offsetA      : std_logic_vector(31 downto 0) := (others=>'0') ;
        signal offsetB      : std_logic_vector(31 downto 0) := (others=>'0') ;
        signal offsetC      : std_logic_vector(31 downto 0) := (others=>'0') ;
        signal offsetD      : std_logic_vector(31 downto 0) := (others=>'0') ;
        signal offsetE      : std_logic_vector(31 downto 0) := (others=>'0') ;
        signal offsetF      : std_logic_vector(31 downto 0) := (others=>'0') ;
        signal wordA        : std_logic_vector(15 downto 0) := (others=>'0') ;
        signal wordB        : std_logic_vector(15 downto 0) := (others=>'0') ;
        signal wordC        : std_logic_vector(15 downto 0) := (others=>'0') ;
        signal wordD        : std_logic_vector(15 downto 0) := (others=>'0') ;
        signal wordE        : std_logic_vector(15 downto 0) := (others=>'0') ;
        signal wordF        : std_logic_vector(15 downto 0) := (others=>'0') ;
        signal memWord      : std_logic_vector(31 downto 0) := (others=>'0') ;
        signal currentVal   : std_logic_vector(31 downto 0) := (others=>'0') ;
        signal be0          : std_logic                     := '0'           ;
        signal be1          : std_logic                     := '0'           ;
        signal be2          : std_logic                     := '0'           ;
        signal be3          : std_logic                     := '0'           ;
        signal readDataMask : std_logic_vector(31 downto 0) := (others=>'0') ;

     -- +--------------+
     -- | master port  |
     -- +--------------+
	
        type upcore_transStore is array (NUMTRANS downto 1) of std_logic_vector(Trns_TRANSNUM_l-1 downto 0);

        -------------------------
        function upcore_loadtrans return upcore_transStore is
            file     mastercommands        : TEXT is in "mastercommands.dat"              ;
            variable result                : upcore_transStore := (others=>(others=>'0')) ;
            variable commandsline          : LINE                                         ; 
            variable transaction_bitvector : bit_vector (Trns_TRANSNUM_l-1 downto 0)      ;
            variable trans_num_iter        : INTEGER := 1                                 ; 
        begin

                read_commands : while not ENDFILE(mastercommands) 
                loop
                 -- read next data line 
                    READLINE (mastercommands , commandsline) ;
                    if ( commandsline'LENGTH = 0 ) then 
                        next ;
                    elsif ( commandsline (1) = '/' )  then 
                        next ;
                    end if ;
                    HREAD_bv (commandsline , transaction_bitvector ) ;
                    result   (trans_num_iter) := To_StdLogicVector (transaction_bitvector) ;
                    trans_num_iter := trans_num_iter + 1 ; 
                end loop; -- read_commands 

            return result;
        end upcore_loadtrans;
        -------------------------

     -- +-----------------------------------------------------------------+
     -- |  Transaction records                                            |
     -- |                                                                 |
     -- |  The transactor pipeline consists of 4 stages:                  |
     -- |                                                                 |
     -- |  nextTrans    - the next transaction from the store             |
     -- |  controlTrans - the current control/address stage transaction   |
     -- |  dataTrans    - the data stage transaction                      |
     -- |  reportTrans  - the completed stage for reporting               |
     -- |                                                                 |
     -- |  controlTrans is updated from nextTrans when a new transaction  |
     -- |  begins or from dataTrans in the case of split/retry            |
     -- |                                                                 |
     -- +-----------------------------------------------------------------+

        -- dataTrans    <= idleTrans ;  -- fill pipe with null's
        -- controlTrans <= idleTrans ;
        -- reportTrans  <= idleTrans ;                               
        -- nextTrans    <= idleTrans ;
        -- nextTrans(2) <= '1'       ;  -- repeat 4

        subtype trans_vector is std_logic_vector (Trns_b downto 0) ;

        -------------------------
        function initialise_idle return trans_vector is
            variable result   : trans_vector := (others=>'0') ;
        begin 
         -- set up a null transaction record
            result (Trns_TRANSNUM_b  downto Trns_TRANSNUM_l ) := (OTHERS => '1') ; 
            result (Trns_TRANSTYPE_b downto Trns_TRANSTYPE_l) := H_IDLE          ;
            return result;
        end initialise_idle;
        -------------------------

        -------------------------
        function initialise_next return trans_vector is
            variable result   : trans_vector := (others=>'0') ;
        begin 
         -- set up a null transaction record
            result (Trns_TRANSNUM_b  downto Trns_TRANSNUM_l ) := (OTHERS => '1') ; 
            result (Trns_TRANSTYPE_b downto Trns_TRANSTYPE_l) := H_IDLE          ;
         -- repeat 4
            result (2) := '1' ;  
            return result;
        end initialise_next;
        -------------------------


        signal trans_num       : std_logic_vector(15 downto 0)                := (others=>'0')    ; -- limit is 2^16-1 = NUMTRANS
        signal tmp_transaction : std_logic_vector(Trns_TRANSNUM_l-1 downto 0) := (others=>'0')    ;
        signal currTransNum    : std_logic_vector(15 downto 0)                := (others=>'0')    ;
        signal tmp_beats       : std_logic_vector( 8 downto 0)                := (others=>'0')    ;

        signal transactions    : upcore_transStore := upcore_loadtrans ;

        signal idleTrans       : trans_vector      := initialise_idle  ;
        signal controlTrans    : trans_vector      := initialise_idle  ;
        signal dataTrans       : trans_vector      := initialise_idle  ;
        signal reportTrans     : trans_vector      := initialise_idle  ; 
        signal retryTrans      : trans_vector      := initialise_idle  ;
        signal nextTrans       : trans_vector      := initialise_next  ;

     -- +-----------------------------------------+
     -- |  Control signals for master transactor  |
     -- +-----------------------------------------+

        signal reset                : std_logic                     := '1'                       ;
        signal stop                 : std_logic                     := '0'                       ;
        signal continue_after_error : std_logic                     := '1'                       ;
        signal generate_data        : std_logic                     := '0'                       ;
        signal write                : std_logic                                                  ;
        signal start                : std_logic                                                  ;
        signal go_busy              : std_logic                                                  ;
        signal insert_busy          : std_logic_vector( 1 downto 0) := "00"                      ;         
        signal beats                : std_logic_vector( 8 downto 0)                              ;
        signal start_address        : std_logic_vector(31 downto 0)                              ;
        signal data                 : std_logic_vector(31 downto 0)                              ;
        signal burst                : std_logic_vector( 2 downto 0)                              ;
        signal size                 : std_logic_vector( 2 downto 0)                              ;

        signal length               : std_logic_vector( 8 downto 0) := (others=>'0') ;
        signal address_length       : std_logic_vector( 8 downto 0) := (others=>'0') ;

     -- +----------------------------------+
     -- |  Transactor state and responses  |
     -- +----------------------------------+

        signal masterhgrant_in_r           : std_logic                     :=          '0'  ;
        signal break_wrap                  : std_logic                     :=          '0'  ;
        signal original_burst              : std_logic_vector( 2 downto 0) := (others=>'0') ;
        signal busy_states                 : std_logic_vector( 1 downto 0) := (others=>'0') ;
        signal busy_counter                : std_logic_vector( 1 downto 0) := (others=>'0') ;
        signal init_wrap_mask              : std_logic_vector( 9 downto 0) := (others=>'0') ;
        signal wrap_mask                   : std_logic_vector( 9 downto 0) := (others=>'0') ;
        signal masterhaddr_out_r_inc       : std_logic_vector( 7 downto 0) := (others=>'0') ;
        signal init_wrap_boundary_bit      : std_logic_vector( 7 downto 0) := (others=>'0') ;
        signal init_next_masterhaddr_out_r : std_logic_vector(10 downto 0) := (others=>'0') ;
        signal wrap_boundary_bit           : std_logic_vector(10 downto 0) := (others=>'0') ;
        signal next_masterhaddr_out_r      : std_logic_vector( 9 downto 0) := (others=>'0') ;

        signal address_bus_owned           : std_logic                     := '0' ;
        signal data_bus_owned              : std_logic                     := '0' ;
        signal add_go                      : std_logic                     := '0' ;
        signal data_go                     : std_logic                     := '0' ;
        signal reading                     : std_logic                     := '0' ;
        signal writing                     : std_logic                     := '0' ;
        signal first_beat                  : std_logic                     := '0' ;
        signal need_retry                  : std_logic                     := '0' ;
        signal wrap                        : std_logic                     := '0' ;
        signal new_grant                   : std_logic                     := '0' ;
        signal first_masterhtrans_out_r    : std_logic                     := '0' ;
        signal addr_ack                    : std_logic                     := '0' ;
        signal data_ack                    : std_logic                     := '0' ;
        signal add_go_r                    : std_logic                     := '0' ;
        signal replay_wrap                 : std_logic_vector( 2 downto 0) := (others=>'0') ;

     -- output signals

        signal   masterhwrite_out   : std_logic                      :=          '0' ;
        signal   masterhlock_out    : std_logic                      :=          '0' ;
        signal   masterhbusreq_out  : std_logic                      :=          '0' ;
        signal   masterhaddr_out    : std_logic_vector (31 downto 0) := (others=>'0');
        signal   masterhwdata_out   : std_logic_vector (31 downto 0) := (others=>'0');
        signal   masterhtrans_out   : std_logic_vector ( 1 downto 0) := (others=>'0');
        signal   masterhsize_out    : std_logic_vector ( 1 downto 0) := (others=>'0');
        signal   masterhburst_out   : std_logic_vector ( 2 downto 0) := (others=>'0');

        signal   slavehrdata_out    : std_logic_vector (31 downto 0) := (others=>'0');
        signal   slavehreadyo_out   : std_logic                      :=          '0' ;
        signal   slavehresp_out     : std_logic_vector ( 1 downto 0) := (others=>'0');
        signal   slavebuserrint_out : std_logic                      :=          '0' ;

     -- register outputs 
  
        signal   masterhtrans_out_r : std_logic_vector ( 1 downto 0) := (others=>'0');
        signal   masterhaddr_out_r  : std_logic_vector (31 downto 0) := (others=>'0');
        signal   masterhwdata_out_r : std_logic_vector (31 downto 0) := (others=>'0');
        signal   masterhburst_out_r : std_logic_vector ( 2 downto 0) := (others=>'0');
        signal   masterhwrite_out_r : std_logic                      :=          '0' ;
        signal   masterhsize_outl   : std_logic_vector ( 2 downto 0) := (others=>'0'); --  the transactor implements the full 3 bit size field

        signal   slavehreadyo_out_r : std_logic                      :=          '0' ;
        signal   slavehresp_out_r   : std_logic_vector ( 1 downto 0) := (others=>'0');

     -- bus request signals

        signal   single_beat     : std_logic := '0' ;
        signal   last_beat       : std_logic := '0' ;
        signal   retry           : std_logic := '0' ;
        signal   error           : std_logic := '0' ;

     -- bus request states

        constant req_idle        : std_logic_vector(2 downto 0) := "000";
        constant req_first       : std_logic_vector(2 downto 0) := "001";
        constant req_wait        : std_logic_vector(2 downto 0) := "101";
        constant req_masterhold  : std_logic_vector(2 downto 0) := "011";
        constant req_using       : std_logic_vector(2 downto 0) := "010";
        constant req_again       : std_logic_vector(2 downto 0) := "111";

        signal   req_state       : std_logic_vector(2 downto 0) := "000";
        signal   single_beat_r   : std_logic                    := '0'  ;

     -- complete data phase signals 

        signal   trans_end       : std_logic                    := '0'  ;

     -- write data signals 

        signal   addr_offset              : std_logic_vector( 7 downto 0) := (others=>'0');
        signal   masterhwdata_out_r_pipe  : std_logic_vector(31 downto 0) := (others=>'0');
        signal   masterhwdata_out_r_retry : std_logic_vector(31 downto 0) := (others=>'0');

     -- wait state generation

        signal   s_addr_latch  : std_logic                     := '0'          ; --  slave address latched this cycle
        signal   waitStart     : std_logic_vector( 7 downto 0) := (others=>'0');
        signal   waitSeq       : std_logic_vector( 7 downto 0) := (others=>'0');
        signal   waitStartNext : std_logic_vector( 7 downto 0) := (others=>'0');

        file     results_file  : TEXT is out "output.dat" ;

    begin

     -- Note: in processes where signals are assigned to and used at the same simulation time, 
     -- temporary variables have been created to remove non-determinism as far as possible. 

     -- +==================================================================+
     -- | Initialisation :                                                 |
     -- | This process is executed once at the start of run then suspended |
     -- +==================================================================+

     initialisation : process 

     begin 

     -- Unused signals tied off to ground

	      lockgrantdp0  <= '0';
	      lockgrantdp1  <= '0';
	
	      debugack      <= '0';
	      debugrng0     <= '0';
	      debugrng1     <= '0';
	      debugextout   <= ( others => '0') ;

	      intuart       <= '0';
	      inttimer0     <= '0';
	      inttimer1     <= '0';
	      intproc0      <= '0';
	      intproc1      <= '0';

        slavehresp_out_r <= H_OKAY;

        reset <= '1'   ;
        wait for 10 ns ;
        reset <= '1'   ;
        wait for 20 ns ;
        reset <= '0'   ;
     
        wait ; 

     end process initialisation ;


     -- +---------------------------------------------------------------------------------+
     -- | Concurrent Signal Assignments (these will appear as wires in the Verilog model) |
     -- | also see - 'Slave port implementation' and 'burst mode support'                 |
     -- +---------------------------------------------------------------------------------+

        start            <= nextTrans(Trns_BUSCOMMD                               ) ;
        go_busy          <= nextTrans(Trns_BUSY                                   ) ;
        beats            <= nextTrans(Trns_NUMSEQBEATS_b downto Trns_NUMSEQBEATS_l) ;
        burst            <= nextTrans(Trns_BURSTTYPE_b   downto Trns_BURSTTYPE_l  ) ;
        size             <= nextTrans(Trns_SIZE_b        downto Trns_SIZE_l       ) ;
        write            <= nextTrans(Trns_WRITE                                  ) ;
        start_address    <= nextTrans(Trns_STARTADDR_b   downto Trns_STARTADDR_l  ) ;
        data             <= nextTrans(Trns_DATA_b        downto Trns_DATA_l       ) ;        

     -- +----------------------------+
     -- | Output Signal Assignments  |
     -- +----------------------------+

     -- direct output assignments 

        masterhwrite     <= masterhwrite_out   ;
        masterhlock      <= masterhlock_out    ;
        masterhbusreq    <= masterhbusreq_out  ;
        masterhaddr      <= masterhaddr_out    ;
        masterhwdata     <= masterhwdata_out   ;
        masterhtrans     <= masterhtrans_out   ;
        masterhsize      <= masterhsize_out    ;
        masterhburst     <= masterhburst_out   ;

        slavehreadyo     <= slavehreadyo_out   ;
        slavebuserrint   <= slavebuserrint_out ;
        slavehrdata      <= slavehrdata_out    ;
        slavehresp       <= slavehresp_out     ;

     -- registered output assignments 

        masterhtrans_out <= masterhtrans_out_r ;
        masterhaddr_out  <= masterhaddr_out_r  ;
        masterhwdata_out <= masterhwdata_out_r ;
        masterhburst_out <= masterhburst_out_r ;
        masterhtrans_out <= masterhtrans_out_r ;
        masterhwrite_out <= masterhwrite_out_r ;
        masterhsize_out  <= masterhsize_outl (1 downto 0);  -- upCore only uses 2 bits of the full 3 bit size field

        slavehreadyo_out <= slavehreadyo_out_r ;
        slavehresp_out   <= slavehresp_out_r   ;


     -- +===============================================+
     -- | process NEXTTRANSACTION                       |
     -- |                                               |
     -- |   Sets up the next transaction and waits for  |
     -- |   it to be accepted (rising edge of clk)      |
     -- +===============================================+

        nexttransaction : process 

         -- Some signals are used in checks at current simulation time, t,
         -- rather than at t+delta, so create temporary variables. This should
         -- then give the same functionality as the blocking statements in the 
         -- Verilog version of this model.  

            variable temp_nextTrans       : trans_vector                                 ;
            variable temp_tmp_transaction : std_logic_vector(Trns_TRANSNUM_l-1 downto 0) := (others=>'0') ;
            variable temp_trans_num       : std_logic_vector(15                downto 0) := (others=>'0') ;
            variable temp_tmp_beats       : std_logic_vector( 8                downto 0) := (others=>'0') ;

        begin

        while ( conv_integer(trans_num) < NUMTRANS )
        loop 

            temp_trans_num := trans_num ;
            temp_tmp_beats := tmp_beats ;
  
            if (conv_integer(nextTrans(Trns_RPTCOUNT_b downto Trns_RPTCOUNT_l)) = 0 ) then
       
             -- get the next record out of those read from the mastercommands file

                temp_trans_num                                           := temp_trans_num + '1' ; 

             -- set temp_tmp_transaction variable now so it can be used straight away in the assignments and checks below.
                    
                temp_tmp_transaction                                     := transactions(conv_integer(temp_trans_num)) ;
                temp_nextTrans                                           := nextTrans ;
                temp_nextTrans(Trns_EXPDATA_b    downto Trns_EXPDATA_l ) := temp_tmp_transaction (Trns_DATA_b downto Trns_DATA_l); -- copy data to expected transaction data
                temp_nextTrans(Trns_TRANSNUM_b   downto Trns_TRANSNUM_l) := temp_trans_num       ;
                temp_nextTrans(Trns_TRANSNUM_l-1 downto               0) := temp_tmp_transaction ;

             -- check for a BUSY
  
                if (UNSIGNED(temp_tmp_transaction(Trns_TRANSTYPE_b downto Trns_TRANSTYPE_l)) = UNSIGNED(H_BUSY)) then
                    temp_nextTrans(Trns_BUSY) := '1';
                else
                    temp_nextTrans(Trns_BUSY) := '0';
                end if ;
    
             -- compute the number of beats in burst

                if (    (UNSIGNED(temp_nextTrans(Trns_BURSTTYPE_b downto Trns_BURSTTYPE_l)) /= UNSIGNED(H_SINGLE))  
                    and (UNSIGNED(temp_nextTrans(Trns_TRANSTYPE_b downto Trns_TRANSTYPE_l))  = UNSIGNED(H_NONSEQ)) ) then
                    temp_tmp_beats := "000000001";
                    temp_nextTrans(Trns_NUMSEQBEATS_b downto Trns_NUMSEQBEATS_l) := "000000001";
                    temp_tmp_transaction := transactions(conv_integer(temp_trans_num) + conv_integer(temp_tmp_beats)) ;
                    while (    (UNSIGNED(temp_tmp_transaction(Trns_TRANSTYPE_b downto Trns_TRANSTYPE_l)) = UNSIGNED(H_SEQ) )
                            or (UNSIGNED(temp_tmp_transaction(Trns_TRANSTYPE_b downto Trns_TRANSTYPE_l)) = UNSIGNED(H_BUSY)) ) 
                    loop 
                        temp_nextTrans(Trns_NUMSEQBEATS_b downto Trns_NUMSEQBEATS_l) := 
                                                     temp_nextTrans(Trns_NUMSEQBEATS_b downto Trns_NUMSEQBEATS_l) + 
                                                     conv_integer(temp_tmp_transaction(Trns_RPTCOUNT_b downto Trns_RPTCOUNT_l)) + 
                                                     1 ;
                        temp_tmp_beats            := temp_tmp_beats + 1 ;
                        temp_tmp_transaction      := transactions(conv_integer(temp_trans_num) + conv_integer(temp_tmp_beats));
                    end loop ;
                    tmp_beats <= temp_tmp_beats ;
                end if ;
    
             -- update the start address

                if (    (UNSIGNED(temp_nextTrans(Trns_TRANSTYPE_b downto Trns_TRANSTYPE_l)) /= UNSIGNED(H_SEQ) )  
                    and (UNSIGNED(temp_nextTrans(Trns_TRANSTYPE_b downto Trns_TRANSTYPE_l)) /= UNSIGNED(H_BUSY)) ) then
                    temp_nextTrans(Trns_STARTADDR_b downto Trns_STARTADDR_l) := temp_nextTrans(Trns_ADDR_b downto Trns_ADDR_l); -- start address
                end if ;

             -- assign the temporary variables we've been using to the signals they represent
                nextTrans       <= temp_nextTrans       ;
                tmp_transaction <= temp_tmp_transaction ;
                trans_num       <= temp_trans_num       ; 

            else
                nextTrans(Trns_RPTCOUNT_b downto Trns_RPTCOUNT_l) <= nextTrans(Trns_RPTCOUNT_b downto Trns_RPTCOUNT_l)- 1 ;
            end if ;

            -- wait for the current transaction to be accepted (rising edge of clk)
            
            wait on masterhclk until ( masterhclk = '1' ) ;
            while ( not ( addr_ack='1' or data_ack='1' ) and nextTrans(Trns_BUSCOMMD)='1') 
            loop
                wait on masterhclk until ( masterhclk = '1' ) ;
            end loop ; 
 
            -- transactions in buffer

        end loop ; 
   
     end process nexttransaction ;  

     -- +=============================================================+	
     -- | process COMPBURSTLEN                                        |
     -- |                                                             |
     -- |          Compute burst length                               |
     -- |                                                             |
     -- |          add_go_r prevents a newly loaded length being      |
     -- |          decremented by the last data beat of the previous  |
     -- |          transaction.                                       |       
     -- +=============================================================+	

     compburstlen : process ( masterhclk , reset )
  
        variable report_string_80   : string(1 to 80) := (others=>' ') ;
        variable report_string_20   : string(1 to 20) := (others=>' ') ;
        variable report_string_10   : string(1 to 10) := (others=>' ') ;
        variable display_line       : LINE                             ;

     begin

         if (masterhclk'event) then 
             if (masterhready='1') then 
                 add_go_r <= add_go;
             end if ;
         end if ;

         if (    ( masterhclk'event and masterhclk='1') 
              or ( reset'event      and reset='1'     ) ) then

             if (reset='1') then
                 length <= "000000000";
             elsif (add_go='1') then
                 case burst
                 is 
                     when H_SINGLE => length <= "000000001";
                     when H_INCR   => length <=  beats     ;
                     when H_WRAP4  |
                          H_INCR4  => length <= "000000100";
                     when H_WRAP8  |
                          H_INCR8  => length <= "000001000";
                     when H_WRAP16 |
                          H_INCR16 => length <= "000010000";
                     when others   => report_string_80(1 to 21) := "error in burst signal" ;
                                      std.textio.write(display_line , report_string_80);
                                      std.textio.writeline(results_file, display_line );		

                 end case ;
             elsif (     (reading = '1' or writing = '1') 
                     and masterhready='1'
                     and add_go_r /= '1' 
                     and (UNSIGNED(masterhresp)=UNSIGNED(H_OKAY) or UNSIGNED(masterhresp)=UNSIGNED(H_ERROR)) ) then 
                 length <= length - ur_OR(length);
             end if ;

             if (reset='1') then
                 address_length <= "000000000";
             elsif (add_go='1') then
                 case burst
                 is 
                     when H_SINGLE => address_length <= "000000001";
                     when H_INCR   => address_length <=  beats     ;
                     when H_WRAP4  |
                          H_INCR4  => address_length <= "000000100";
                     when H_WRAP8  |
                          H_INCR8  => address_length <= "000001000";
                     when H_WRAP16 |
                          H_INCR16 => address_length <= "000010000";
                     when others   => report_string_80(1 to 21) := "error in burst signal" ;
                                      std.textio.write(display_line , report_string_80);
                                      std.textio.writeline(results_file, display_line );		
                 end case ;
             elsif (    data_bus_owned        = '1' 
                    and masterhready         /= '1'
                    and (UNSIGNED(masterhresp) = UNSIGNED(H_RETRY) or UNSIGNED(masterhresp) = UNSIGNED(H_SPLIT)) ) then 
                 address_length <= address_length + '1' ;
             elsif (    address_bus_owned     = '1' 
                    and masterhready          = '1' 
                    and ur_OR (busy_states)  /= '1'
                    and UNSIGNED(masterhtrans_out_r) /= UNSIGNED(H_IDLE)) then
                 address_length <= address_length - ur_OR (address_length);
             elsif (    address_bus_owned     = '1'
                    and masterhready          = '1'
                    and ur_OR (busy_states)   = '1'
                    and UNSIGNED(masterhtrans_out_r) = UNSIGNED(H_BUSY)
                    and ur_OR (busy_counter) /= '1'  ) then 
                 address_length <= address_length - ur_OR (address_length);
             end if ; 
         end if ; 

     end process compburstlen ;

     -- +-----------------------------------------------------------+
     -- | Slave port implementation : concurrent signal assignments |
     -- +-----------------------------------------------------------+

     -- select signal

        sel        <= slavehsel and slavehreadyi;
	
     -- determine if the transaction includes an operation / a "busy"

        doWork     <= '1' when ( selReg='1' and 
		               ( transReg=conv_integer(H_NONSEQ) or transReg=conv_integer(H_SEQ)) )
                 else '0';

        doBusyWork <= '1' when ( selReg='1' and transReg=conv_integer(H_BUSY) ) 
                 else '0';
	
     -- +--------------------------------------------------+
     -- | BURST MODE SUPPORT                               |
     -- |                                                  |
     -- | If we are in burst mode we'll compute our own    |
     -- | address and control settings based on the spec.  |
     -- |                                                  |
     -- | compute values SEQuential (burst) transfers      |
     -- +--------------------------------------------------+

         seqTrans <= '1' when  selReg='1' 
                        and ( doWork='1' or doBusyWork='1') 
                        and (slavehtrans=conv_integer(H_SEQ) or slavehtrans=conv_integer(H_BUSY)) 
               else '0';

         with burstReg select
             wrapmask  <= (1 downto 0=>'0', others=>'1') when H_WRAP4 
                        , (2 downto 0=>'0', others=>'1') when H_WRAP8 
                        , (2 downto 0=>'0', others=>'1') when H_WRAP16 
                        , (others=>'0')                  when others ;
					
         with sizeReg select
             wrapmask_w <= shift_left(wrapmask, 2) when H_WORD  
                         , shift_left(wrapmask, 1) when H_HWORD 
                         , wrapmask                when others  ;

         with sizeReg select
             seqPlusAddr<= addrReg + 1 when H_BYTE 
                         , addrReg + 2 when H_HWORD 
                         , addrReg + 4 when H_WORD 
                         , addrReg     when others ;
					
         seqAddr <= addrReg when slavehtrans = conv_integer(H_BUSY) 
                              or burstReg    = conv_integer(H_SINGLE) 
               else (startReg and wrapmask_w) or (seqPlusAddr and (not(wrapmask_w)));
			
         -- if this is a sequential transaction only sample HTRANS

        startNext <= startReg when seqTrans='1' else slavehaddr  ;
         addrNext <= seqAddr  when seqTrans='1' else slavehaddr  ;
        transNext <= slavehtrans;
         sizeNext <= sizeReg  when seqTrans='1' else slavehsize  ;
        burstNext <= burstReg when seqTrans='1' else slavehburst ;
        writeNext <= writeReg when seqTrans='1' else slavehwrite ;
	
     -- +==============================================================+	
     -- |                                                              |
     -- | process CTRLLATCH :                                          |
     -- |                                                              |
     -- |        Latch the control data if we are selected             |
     -- |                                                              |
     -- +==============================================================+	

        ctrllatch: process ( slavehclk )
        begin 
            if ( slavehclk'event and slavehclk='1') then

             -- if read is low another device is wait stating its
             -- data phase and hence extending our address phase

                if ( slavehreadyi = '1' ) then
                    selReg <= sel;
                    if ( sel = '1' ) then		-- latch the control data
                        startReg <= startNext    ;
                         addrReg <=  addrNext    ;
                        transReg <= transNext    ;
                         sizeReg <=  sizeNext    ;
                        writeReg <= writeNext    ;
                        burstReg <= burstNext    ;
                    else
                        startReg <= (others=>'0');
                         addrReg <= (others=>'0');
                        transReg <= H_IDLE       ;
                         sizeReg <= H_WORD       ;
                        writeReg <= '0'          ;
                        burstReg <= H_SINGLE     ;
                    end if;
                end if;
            end if;
        end process ctrllatch;
	

        bankA <= '1' when (           conv_integer(addrReg)     >= memStart(0) 
                            and conv_integer(addrReg)     <= memEnd(0) 
                            and conv_integer(memStart(0)) /= memEnd(0) ) 
                     else '0';

        bankB <= '1' when (           conv_integer(addrReg)     >= memStart(1) 
                            and conv_integer(addrReg)     <= memEnd(1) 
                            and conv_integer(memStart(1)) /= memEnd(1) )  
                     else '0';

        bankC <= '1' when (           conv_integer(addrReg)     >= memStart(2) 
                            and conv_integer(addrReg)     <= memEnd(2) 
                            and conv_integer(memStart(2)) /= memEnd(2) ) 
                     else '0';

        bankD <= '1' when (           conv_integer(addrReg)     >= memStart(3) 
                            and conv_integer(addrReg)     <= memEnd(3) 
                            and conv_integer(memStart(3)) /= memEnd(3) ) 
                     else '0';

        bankE <= '1' when (           conv_integer(addrReg)     >= memStart(4) 
                            and conv_integer(addrReg)     <= memEnd(4) 
                            and conv_integer(memStart(4)) /= memEnd(4) )  
                     else '0';

        bankF <= '1' when (           conv_integer(addrReg)     >= memStart(5) 
                            and conv_integer(addrReg)     <= memEnd(5) 
                            and conv_integer(memStart(5)) /= memEnd(5) )  
                     else '0';

	
      -- byte offset into bank                  -- word offset into bank

         offsetA <= addrReg - memStart(0);         
                                                   wordA <= offsetA(17 downto 2);
         offsetB <= addrReg - memStart(1);         
                                                   wordB <= offsetB(17 downto 2);
         offsetC <= addrReg - memStart(2);         
                                                   wordC <= offsetC(17 downto 2);
         offsetD <= addrReg - memStart(3);         
                                                   wordD <= offsetD(17 downto 2);
         offsetE <= addrReg - memStart(4);         
                                                   wordE <= offsetE(17 downto 2);
         offsetF <= addrReg - memStart(5);         
                                                   wordF <= offsetF(17 downto 2);

         -- byte enables

         be0<= '1' when 	( UNSIGNED(sizeReg)=UNSIGNED(H_WORD)  or
                         ( UNSIGNED(sizeReg)=UNSIGNED(H_HWORD) and addrReg(1)='0' ) or
                         ( UNSIGNED(sizeReg)=UNSIGNED(H_BYTE)  and UNSIGNED(addrReg(1 downto 0))=0) )
                  else '0';
         be1<= '1' when 	( UNSIGNED(sizeReg)=UNSIGNED(H_WORD)  or
                         ( UNSIGNED(sizeReg)=UNSIGNED(H_HWORD) and addrReg(1)='0' ) or
                         ( UNSIGNED(sizeReg)=UNSIGNED(H_BYTE)  and UNSIGNED(addrReg(1 downto 0))=1) )
                  else '0';
         be2<= '1' when 	( UNSIGNED(sizeReg)=UNSIGNED(H_WORD)  or
                         ( UNSIGNED(sizeReg)=UNSIGNED(H_HWORD) and addrReg(1)='1' ) or
                         ( UNSIGNED(sizeReg)=UNSIGNED(H_BYTE)  and UNSIGNED(addrReg(1 downto 0))=2) )
                  else '0';
         be3<= '1' when 	( UNSIGNED(sizeReg)=UNSIGNED(H_WORD)  or
                         ( UNSIGNED(sizeReg)=UNSIGNED(H_HWORD) and addrReg(1)='1' ) or
                         ( UNSIGNED(sizeReg)=UNSIGNED(H_BYTE)  and UNSIGNED(addrReg(1 downto 0))=3) )
                  else '0';

         readDataMask( 7 downto  0) <= "11111111"  when ( be0='1' ) else "00000000" ;
         readDataMask(15 downto  8) <= "11111111"  when ( be1='1' ) else "00000000" ;
         readDataMask(23 downto 16) <= "11111111"  when ( be2='1' ) else "00000000" ;
         readDataMask(31 downto 24) <= "11111111"  when ( be3='1' ) else "00000000" ;
			
     -- +=================================+	
     -- | process waitgen                 |
     -- |                                 |
     -- |     wait state generation       |
     -- +=================================+	

        waitstartgen : process (bankA, bankB, bankC, bankD, bankE, bankF )
        begin
            if    (bankA='1') then waitStart <= memWaitStart(0);
            elsif (bankB='1') then waitStart <= memWaitStart(1);
            elsif (bankC='1') then waitStart <= memWaitStart(2);
            elsif (bankD='1') then waitStart <= memWaitStart(3);
            elsif (bankE='1') then waitStart <= memWaitStart(4);
            elsif (bankF='1') then waitStart <= memWaitStart(5);
            end if ;
        end process waitstartgen ; 

        waitseqgen : process (bankA, bankB, bankC, bankD, bankE, bankF )
        begin
            if    (bankA='1') then waitSeq   <= memWait(0);
            elsif (bankB='1') then waitSeq   <= memWait(1);
            elsif (bankC='1') then waitSeq   <= memWait(2);
            elsif (bankD='1') then waitSeq   <= memWait(3);
            elsif (bankE='1') then waitSeq   <= memWait(4);
            elsif (bankF='1') then waitSeq   <= memWait(5);
            end if ;
        end process waitseqgen ; 

     -- +==================================================================+	
     -- | slave wait processes                                             |
     -- |                                                                  |
     -- | wait if                                                          |
     -- |    first beat and memWaitStart and addr has just been latched    |
     -- | or                                                               |
     -- |    first beat and waitReg (more than 1 wait state)               |
     -- | or                                                               |
     -- |    seq beat and waitReg                                          |
     -- | else ready                                                       |
     -- +==================================================================+	

        slavelatch : process ( slavehclk )
        begin
        if ( slavehclk'event and slavehclk='1') then
            s_addr_latch <= slavehreadyi and slavehsel;
        end if ; 
        end process slavelatch ;

        slavewait : process ( doWork, transReg, waitReg, waitStart, s_addr_latch )
            variable report_string_20 : string(1 to 20) := (others=>' ') ;
            variable display_line     : LINE                             ;
        begin 
            if    (doWork='1' and UNSIGNED(transReg)=UNSIGNED(H_NONSEQ) and UNSIGNED(waitStart)/=0 and s_addr_latch='1' ) then
                slavehreadyo_out_r <= '0' ;
                --report_string_20 := "SLAVE: wait on first" ;
                --std.textio.write (display_line , report_string_20);
                --std.textio.writeline (results_file, display_line );
            elsif (doWork='1' and UNSIGNED(transReg)=UNSIGNED(H_NONSEQ) and UNSIGNED(waitReg)/=0 ) then 
                slavehreadyo_out_r <= '0' ;
                --report_string_20 := "SLAVE: wait         " ;
                --std.textio.write (display_line , report_string_20);
                --std.textio.writeline (results_file, display_line );
            elsif (doWork='1' and UNSIGNED(transReg)=UNSIGNED(H_SEQ) and UNSIGNED(waitReg)/=0) then 
                slavehreadyo_out_r <= '0' ;
                --report_string_20 := "SLAVE: wait         " ;
                --std.textio.write (display_line , report_string_20);
                --std.textio.writeline (results_file, display_line );
            else
                slavehreadyo_out_r <= '1' ;
            end if ; 
        end process slavewait ;

         -- if we are waiting (waitReg>0) and not in a busy decrement the counter
         -- otherwise get the new value from memWait of memWaitStart according to
         -- the transaction type 

         waitStartNext <= waitStart - 1 when ( UNSIGNED(waitStart) > 1 )
                      else "00000000";
  
         slavewaitreg : process ( slavehclk )
         begin
            if ( slavehclk'event and slavehclk='1') then
                if (UNSIGNED(waitReg) /= 0 and doBusyWork/='1') then 
                    waitReg <= waitReg - '1' ;
                elsif (doWork='1' and UNSIGNED(transReg)=UNSIGNED(H_NONSEQ) and UNSIGNED(waitStart)/=0 and s_addr_latch='1' ) then
                    waitReg <= waitStartNext ;
                elsif (seqTrans='1' ) then
                    waitReg <= waitSeq ;
                else 
                    waitReg <= "00000000" ;
                end if ; 
            end if ; 
         end process slavewaitreg ;

         -- read data

         process (wordA,   wordB,   wordC,   wordD,   wordE,   wordF, 
                  bankA,   bankB,   bankC,   bankD,   bankE,   bankF,
                  memMapA, memMapB, memMapC, memMapD, memMapE, memMapF, memWord )
         begin
             if    (bankA='1' and conv_integer(wordA)< membank_size ) then currentVal <= memMapA(conv_integer(wordA)) ; 
             elsif (bankB='1' and conv_integer(wordB)< membank_size ) then currentVal <= memMapB(conv_integer(wordB)) ; 
             elsif (bankC='1' and conv_integer(wordC)< membank_size ) then currentVal <= memMapC(conv_integer(wordC)) ; 
             elsif (bankD='1' and conv_integer(wordD)< membank_size ) then currentVal <= memMapD(conv_integer(wordD)) ; 
             elsif (bankE='1' and conv_integer(wordE)< membank_size ) then currentVal <= memMapE(conv_integer(wordE)) ; 
             elsif (bankF='1' and conv_integer(wordF)< membank_size ) then currentVal <= memMapF(conv_integer(wordF)) ; 
             end if;
         end process ; 

         slavehrdata_out <= (readDataMask and currentVal) when (doWork='1' and writeReg/='1' and slavehreadyo_out_r='1')
                      else (others=>'0');

     -- +===========================================================================+	
     -- |                                                                           |
     -- | process MEMWORK :                                                         |
     -- |                                                                           |
     -- |      +  records reads and writes in memory banks                          |
     -- |      +  writes a text report to the screen                                |
     -- |                                                                           |
     -- +===========================================================================+	

        memwork : process ( slavehclk )

            variable report_string_11   : string(1 to 11) := (others=>' ') ;
            variable report_string_10   : string(1 to 10) := (others=>' ') ;
            variable report_string_9    : string(1 to  9) := (others=>' ') ;
            variable report_string_8    : string(1 to  8) := (others=>' ') ;
            variable report_string_6    : string(1 to  6) := (others=>' ') ;
            variable display_line       : LINE                             ;
            variable decimal            : BOOLEAN := FALSE                 ;
            variable temp_memWord       : std_logic_vector(31 downto 0)    ;

        begin

            if ( slavehclk'event and slavehclk='1') 
            then
	
                if (doWork='1' and slavehreadyo_out_r='1') 
                then
 
                    temp_memWord := currentVal ;

                    if (writeReg='1') 
                    then
                        if (be0='1') then temp_memWord( 7 downto  0) := slavehwdata( 7 downto  0); end if;
                        if (be1='1') then temp_memWord(15 downto  8) := slavehwdata(15 downto  8); end if;
                        if (be2='1') then temp_memWord(23 downto 16) := slavehwdata(23 downto 16); end if;
                        if (be3='1') then temp_memWord(31 downto 24) := slavehwdata(31 downto 24); end if;
		
                        if (bankA='1') then memMapA(conv_integer(wordA)) <= temp_memWord; end if;
                        if (bankB='1') then memMapB(conv_integer(wordB)) <= temp_memWord; end if;
                        if (bankC='1') then memMapC(conv_integer(wordC)) <= temp_memWord; end if;
                        if (bankD='1') then memMapD(conv_integer(wordD)) <= temp_memWord; end if;
                        if (bankE='1') then memMapE(conv_integer(wordE)) <= temp_memWord; end if;
                        if (bankF='1') then memMapF(conv_integer(wordF)) <= temp_memWord; end if;
                    end if;

                    memWord <= temp_memWord ;

                 -- display a text report on screen
                    report_string_10 := "SLAVE:    " ;
                    std.textio.write (display_line , report_string_10);
                    report_string_10 := "          " ;
                    std.textio.write (display_line , report_string_10);
                    report_string_9  := "   addr=[" ;
                    std.textio.write (display_line , report_string_9);
                    if (decimal) then 
                        std.textio.write (display_line, conv_integer(addrReg),right,8);
                    else
                        IEEE.std_logic_textio.hwrite (display_line,addrReg,right,8);
                    end if ; 
                    if (writeReg = '1') 
                    then 
                        report_string_8 := "] WRITE " ;
                    else 
                        report_string_8 := "] READ  " ; 
                    end if;
                    std.textio.write (display_line, report_string_8);

                    report_string_6 := "data=[" ;
                    std.textio.write (display_line , report_string_6);
                    if (writeReg='1') 
                    then 
                        if (decimal) then 
                            std.textio.write (display_line, conv_integer(slavehwdata),right,8);
                        else
                            IEEE.std_logic_textio.hwrite (display_line,slavehwdata,right,8);
                        end if ; 
                    else
                        if (decimal) then 
                            std.textio.write (display_line, conv_integer(slavehrdata_out),right,8);
                        else
                            IEEE.std_logic_textio.hwrite (display_line,slavehrdata_out,right,8);
                        end if ; 
                    end if;
                    report_string_6  := "]     " ;
                    std.textio.write (display_line , report_string_6);
                    report_string_11 := "           " ;
                    std.textio.write (display_line , report_string_11);
                    report_string_10 := "          " ;
                    std.textio.write (display_line , report_string_10);

                    case sizeReg 
                    is
                        when H_BYTE => report_string_10 :=  "     BYTE " ;
                        when H_HWORD=> report_string_10 :=  "HALF WORD " ;
                        when H_WORD => report_string_10 :=  "     WORD " ;
                        when others => report_string_10 :=  " <error>  " ;
                    end case;
                    std.textio.write (display_line , report_string_10);

                    std.textio.writeline(results_file, display_line );		

                end if;

            end if;

        end process memwork;

     -- +==========================================+
     -- |                                          |
     -- | process reportcomptrans :                |
     -- |                                          |
     -- |        Report completed transactions     |
     -- |                                          |
     -- +==========================================+

        reportcomptrans : process ( masterhclk )

            variable report_string_14   : string(1 to 14) := (others=>' ') ;
            variable report_string_9    : string(1 to 9 ) := (others=>' ') ;
            variable report_string_7    : string(1 to 7 ) := (others=>' ') ;
            variable display_line       : LINE                             ;
            variable decimal            : BOOLEAN := FALSE                 ;

        begin

            if ( masterhclk'event and masterhclk='1')
            then
                if (reportTrans(Trns_BUSCOMMD)='1') 
                then 
                    report_string_7 := "MASTER:" ;
                    std.textio.write (display_line, report_string_7);

                    report_string_9 := " trans=[ " ;	
                    std.textio.write (display_line, report_string_9);
                    std.textio.write (display_line, conv_integer(reportTrans(Trns_TRANSNUM_b downto Trns_TRANSNUM_l)),right,4);

                    report_string_9 := "]  addr=[" ;	
                    std.textio.write (display_line, report_string_9);
                    if (decimal) then 
                        std.textio.write (display_line, conv_integer(reportTrans(Trns_ADDR_b downto Trns_ADDR_l)),right,8);
                    else
                        IEEE.std_logic_textio.hwrite (display_line, reportTrans(Trns_ADDR_b downto Trns_ADDR_l),right,8);
                    end if ; 

                    if (reportTrans(Trns_WRITE) = '1') 
                    then 
                        report_string_14 := "] WRITE data=[" ;
                        std.textio.write (display_line, report_string_14);
                        if (decimal) then 
                            std.textio.write (display_line, conv_integer(reportTrans(Trns_DATA_b downto Trns_DATA_l)),right,8);
                        else
                            IEEE.std_logic_textio.hwrite (display_line, reportTrans(Trns_DATA_b downto Trns_DATA_l),right,8);
                        end if ; 
                    else 
                        report_string_14 := "] READ  data=[" ; 
                        std.textio.write (display_line, report_string_14);
                        if (decimal) then 
                            std.textio.write (display_line, conv_integer(reportTrans(Trns_READ_b downto Trns_READ_l)),right,8);
                        else
                            IEEE.std_logic_textio.hwrite (display_line, reportTrans(Trns_READ_b downto Trns_READ_l),right,8);
                        end if ; 
                    end if;

                    report_string_14 := "]   expected=[" ;	
                    std.textio.write (display_line, report_string_14);
                    if (decimal) then 
                        std.textio.write (display_line, conv_integer(reportTrans(Trns_EXPDATA_b downto Trns_EXPDATA_l)),right,8);
                    else
                        IEEE.std_logic_textio.hwrite (display_line, reportTrans(Trns_EXPDATA_b downto Trns_EXPDATA_l),right,8);
                    end if ; 

                    case reportTrans(Trns_SIZE_b-1 downto Trns_SIZE_l) -- (only 2 of the 3 bits are used)
                    is
                        when H_BYTE  => report_string_14 :=  "]         BYTE" ;
                        when H_HWORD => report_string_14 :=  "]    HALF WORD" ;
                        when H_WORD  => report_string_14 :=  "]         WORD" ;
                        when others  => report_string_14 :=  "]      <error>" ;
                    end case;
                    std.textio.write (display_line , report_string_14);

                    if (UNSIGNED(reportTrans(Trns_RESP_b downto Trns_RESP_l))=UNSIGNED(H_OKAY) ) then
                        report_string_9 :=  "  OKAY   " ;
                    else
                        report_string_9 :=  "  ERROR  " ;
                    end if ; 
                    std.textio.write (display_line , report_string_9);

                    std.textio.writeline(results_file, display_line );		
 
                end if;	
            end if;
        end process reportcomptrans;

     -- +====================================================================================+
     -- |                                                                                    |
     -- | process BUSREQUEST :                                                               |
     -- |                                                                                    |
     -- | Bus request state machine                                                          |
     -- |                                                                                    |
     -- |     Bus request machine follows the principle that the arbiter will generally      |
     -- |     only re-assign bus grants at the end of a burst transaction. For defined       |
     -- |     bursts masterhbusreq_out is removed as soon as we masterhave started the       |
     -- |     transaction. Undefined (INCR) bursts will masterhold masterhbusreq_out         |
     -- |     asserted until the last beat of the transaction.                               |
     -- |                                                                                    |
     -- |     Locked transactions must always assert masterhlock_out for at least one        |
     -- |     cycle before the address to be locked to allow the arbiter to see the lock.    |
     -- |     In practice, this means inserting an idle cycle.                               | 
     -- |                                                                                    |
     -- |     Have to be careful using burst and beats from the control word. As soon        |
     -- |     as the master address phase masterhas finished and the addr_ack is asserted    |
     -- |     the testbench can change the control word. So don't use them after the         | 
     -- |     initial request. Use the ahb outputs instead which will tell us what sort      |
     -- |     of transaction we're doing.                                                    |
     -- |                                                                                    |
     -- | Bus request machine master has 5 states:                                           |
     -- |                                                                                    |
     -- |    1) req_idle:  masterhbusreq_out negated. When we want to do something           |
     -- |                  we jump to req_first. The last beat may get a retry               |
     -- |                  response in which case we jump to req_again.                      |
     -- |                                                                                    |
     -- |    2) req_first: masterhbusreq_out asserted. Wait here for masterhgrant            |
     -- |                  and until the transaction starts. If granted and it's an          |
     -- |                  undefined and not a single beat then jump to req_masterhold.      |
     -- |                  Else if it's a single beat jump to req_idle. Otherwise jump       |
     -- |                  to req_using.                                                     |
     -- |                                                                                    |
     -- |    3) req_masterhold: masterhbusreq_out asserted. Hold masterhbusreq_out           |
     -- |                  asserted until last beat of an undefined. If there's a            |
     -- |                  new request then we jump to req_first, otherwise back to          |
     -- |                  req_idle. If we lose masterhgrant in this state then we           |
     -- |                  just stay here with masterhbusreq_out asserted until the          |
     -- |                  transaction can be finished. Also hold in this state if           |
     -- |                  retry is asserted to reduce the chance of releaseing the          |
     -- |                  bus and having to re-request it to complete a transaction.        |
     -- |                                                                                    |
     -- |    4) req_using: masterhbusreq_out negated. Wait here for last beat of             |
     -- |                  defined length transaction. If there's a new request then         |
     -- |                  we jump to req_first, otherwise back to req_idle. If a            |
     -- |                  posted write is errored before the last beat or a transaction     |
     -- |                  is retried or we lose masterhgrant then we jump to                | 
     -- |                  req_again.                                                        |
     -- |                                                                                    |
     -- |    5) req_again: masterhbusreq_out asserted for completion of transaction          |
     -- |                  interrupted by loss of masterhgrant. Wait here for                |
     -- |                  masterhgrant and until the transaction starts then                |
     -- |                  jump to req_using if first_beat is asserted or                    |
     -- |                  req_masterhold if not.                                            |
     -- |                  *** We may see a new address toggle whilst in this state.         |
     -- |                                                                                    |
     -- +====================================================================================+


        single_beat <= '1' when (UNSIGNED(burst)=UNSIGNED(H_SINGLE) or (UNSIGNED(burst)=UNSIGNED(H_INCR) and UNSIGNED(beats)=1))
                  else '0' ;

        last_beat   <= '1' when (address_bus_owned='1' and masterhready='1' and UNSIGNED(address_length) <= 1) 
                  else '0' ;

        retry       <= '1' when (data_bus_owned='1' and (UNSIGNED(masterhresp)=UNSIGNED(H_RETRY) or UNSIGNED(masterhresp)=UNSIGNED(H_SPLIT)))
                  else '0' ;

        error       <= '1' when (data_bus_owned='1' and masterhready='1' and UNSIGNED(masterhresp)=UNSIGNED(H_ERROR))
                  else '0' ;

        masterhbusreq_out <= '1' when (   (start     = '1'           )
                                       or (UNSIGNED(req_state) = UNSIGNED(req_first)     )
                                       or (UNSIGNED(req_state) = UNSIGNED(req_wait)      )
                                       or (UNSIGNED(req_state) = UNSIGNED(req_masterhold))
                                       or (UNSIGNED(req_state) = UNSIGNED(req_again)     ) )
                        else '0' ;

        busrequest : process ( masterhclk , reset)

        begin

            if (masterhclk'event and masterhclk = '1') then 
                if (addr_ack='1') then
                 -- save single_beat for use after it may have changed
                    single_beat_r <= single_beat;
                end if ;
            end if ;

            if (   (masterhclk'event and masterhclk = '1') 
                or (reset'event      and reset      = '1') ) then

                if (reset='1') then
                    req_state <= req_idle;
                else
                  case req_state 
                  is
                    when req_idle       => if (retry='1') then
                                               req_state <= req_again;
                                           elsif (start='1') then
                                               req_state <= req_first;
                                           else
                                               req_state <= req_idle ;
                                           end if ;

                    when req_first      => if (retry='1') then
                                               req_state <= req_again;
                                           elsif (masterhgrant/='1' and not (UNSIGNED(masterhtrans_out_r)=UNSIGNED(H_NONSEQ) and masterhready='1')) then
                                               req_state <= req_first;
                                           elsif (UNSIGNED(masterhtrans_out_r)=UNSIGNED(H_NONSEQ) and masterhready='1') then
                                               if (add_go='1') then
                                                   req_state <= req_first;
                                               elsif (UNSIGNED(burst)=UNSIGNED(H_INCR) and single_beat/='1') then
                                                   req_state <= req_masterhold;
                                               elsif (single_beat='1') then
                                                   req_state <= req_idle;
                                               else
                                                   req_state <= req_using;
                                               end if ;
                                           else
                                               req_state <= req_wait;
                                           end if ;

                    when req_wait       => if (retry='1') then
                                               req_state <= req_again;
                                           elsif (masterhgrant/='1' and not (UNSIGNED(masterhtrans_out_r)=UNSIGNED(H_NONSEQ) and masterhready='1')) then
                                               req_state <= req_first;
                                           elsif (masterhgrant='1' and not (UNSIGNED(masterhtrans_out_r)=UNSIGNED(H_NONSEQ) and masterhready='1')) then
                                               req_state <= req_wait;
                                           elsif (add_go='1') then
                                               req_state <= req_first;
                                           elsif (UNSIGNED(burst)=UNSIGNED(H_INCR) and single_beat/='1') then
                                               req_state <= req_masterhold;
                                           elsif (single_beat_r='1') then
                                               req_state <= req_idle;
                                           else
                                               req_state <= req_using;
                                           end if ;

                    when req_masterhold => if (error='1' and continue_after_error/='1') then
                                               req_state <= req_idle;
                                           elsif (   (masterhgrant/='1' and (conv_integer(address_length) > 1 )) 
                                                  or retry='1' ) then
                                               req_state <= req_again;
                                           elsif (last_beat='1') then
                                               if (start='1') then
                                                   req_state <= req_first;
                                               else
                                                   req_state <= req_idle;
                                               end if ;
                                           elsif (add_go='1') then
                                               req_state <= req_first;
                                           else
                                               req_state <= req_masterhold;
                                           end if ;

                    when req_using      => if (error='1' and continue_after_error/='1') then
                                               req_state <= req_idle;
                                           elsif (last_beat='1') then
                                               if (start='1') then
                                                   req_state <= req_first;
                                               else
                                                   req_state <= req_idle;
                                               end if ;
                                           elsif (   (masterhgrant/='1' and (conv_integer(address_length) > 1 )) 
                                                  or retry='1') then
                                               req_state <= req_again;
                                           else
                                               req_state <= req_using;
                                           end if ;

                    when req_again      => if (error='1' and continue_after_error/='1') then
                                               req_state <= req_idle;
                                           elsif (     (   (data_bus_owned/='1') 
                                                        or (data_bus_owned='1' and (UNSIGNED(masterhresp) = UNSIGNED(H_OKAY))) )
                                                   and address_bus_owned='1' 
                                                   and UNSIGNED(masterhtrans_out_r)=UNSIGNED(H_IDLE) 
                                                   and masterhready='1'
                                                   and masterhlock_out/='1') then
                                               req_state <= req_idle;
                                           elsif (     (masterhgrant/='1' and (conv_integer(address_length) > 1 )) 
                                                    or (not ((UNSIGNED(masterhtrans_out_r)=UNSIGNED(H_NONSEQ)) and (masterhready='1'))) ) then
                                               req_state <= req_again;
                                           elsif (     (    (last_beat='1') 
                                                        or  (UNSIGNED(masterhburst_out_r)=UNSIGNED(H_SINGLE)))
                                                    or (    (UNSIGNED(masterhburst_out_r)=UNSIGNED(H_INCR)) 
                                                        and (single_beat_r='1'))    ) then
                                               req_state <= req_idle;
                                           elsif (first_beat='1') then
                                               req_state <= req_using;
                                           else
                                               req_state <= req_masterhold;
                                           end if ;

                    when others         => req_state <= req_idle;
                                                 
                  end case ;
                end if ;
            end if ;
 
         end process busrequest ;

     -- +------------------------------------------------------+
     -- | Address and Data acknowledge assignments             |
     -- |                                                      |
     -- | Signals when an address has been transferred and a   |
     -- | new one may be presented for the next transaction.   |
     -- +------------------------------------------------------+

        addr_ack <= add_go  ;
        data_ack <= data_go ;

     -- +======================================================+
     -- | process busownership                                 |
     -- |                                                      |
     -- | Data bus ownership follows address by one cycle      |
     -- +======================================================+

        busownership : process (masterhclk, reset)
        begin
        if (   ( masterhclk'event and masterhclk='1')  
            or ( reset'event      and reset='1'     ) ) then 
            if ( reset ='1' ) then
                address_bus_owned <= '0' ;
                data_bus_owned    <= '0' ;
            elsif (masterhready ='1' ) then 
                address_bus_owned <= masterhgrant;
                data_bus_owned    <= address_bus_owned;
            end if ;
        end if ; 
        end process busownership ;

     -- +===============================================================+
     -- | process ENABLEADDRESSPHASE                                    |
     -- |                                                               |
     -- |      add_go enables the address phase for a new transaction   |
     -- |      (not the continuation of a retried transaction or a      |
     -- |      transaction during which we lose the bus).               |
     -- |      It asserts immediately on address request if we're not   |
     -- |      actively using the bus and not waiting for it to be      |
     -- |      re-granted to complete a previous transaction, the       |
     -- |               (masterhtrans_out_r = IDLE)                     |
     -- |      term ensuring it only asserts for one clock.             |
     -- +===============================================================+

        enableaddressphase : process (start, masterhbusreq_out, masterhgrant, masterhready, reading,
                                      writing, masterhtrans_out_r, req_state, length, reset   )
        begin
            if   (     start               = '1' 
                   and masterhbusreq_out   = '1' 
                   and masterhgrant        = '1' 
                   and masterhready        = '1' 
                   and reading            /= '1' 
                   and writing            /= '1'
                   and UNSIGNED(masterhtrans_out_r)=UNSIGNED(H_IDLE) 
                   and UNSIGNED(req_state)        /=UNSIGNED(req_again)
                   and reset              /= '1' ) then
                add_go <= '1' ;
            elsif (    start               = '1' 
                   and masterhbusreq_out   = '1' 
                   and masterhgrant        = '1' 
                   and masterhready        = '1' 
                   and conv_integer(length) < 2
                   and retry              /= '1'
                   and UNSIGNED(masterhtrans_out_r)/=UNSIGNED(H_BUSY) 
                   and UNSIGNED(masterhtrans_out_r)/=UNSIGNED(H_NONSEQ)
                   and reset              /= '1' ) then
                add_go <= '1' ;
            else
                add_go <= '0' ;
            end if ; 
        end process enableaddressphase ;

     -- +=================================================================+
     -- | process COMPLETEDATAPHASE			                                    |
     -- |                                                                 |
     -- |      data_go indicates the completion of the data phase for a   |
     -- |      transaction. Like add_go it asserts when the master        |
     -- |      takes control of the address lines to start a transaction. |
     -- |      It also asserts on all the accepted data beats of a burst  |
     -- |      except the last.                                           |
     -- +=================================================================+

        updatetrans_end : process ( data_bus_owned, reading, writing, masterhready, masterhresp )
            variable boolean_1 : std_logic ;
        begin
            if (UNSIGNED(masterhresp)=UNSIGNED(H_OKAY) or UNSIGNED(masterhresp)=UNSIGNED(H_ERROR)) then boolean_1 := '1' ; else boolean_1 := '0' ; end if ; 
            trans_end <=  (    data_bus_owned
                           and (reading or writing) 
                           and masterhready
                           and boolean_1 ) ;
        end process updatetrans_end ; 


        completedataphase : process (start,   masterhbusreq_out, writing,    reset, 
                                     reading, masterhgrant,  req_state,  trans_end,
                                     length,  masterhready,  need_retry, masterhtrans_out_r )

        begin

            if (    start                = '1' 
                and masterhbusreq_out    = '1' 
                and masterhgrant         = '1' 
                and masterhready         = '1' 
                and reading             /= '1' 
                and writing             /= '1'
                and UNSIGNED(masterhtrans_out_r) = UNSIGNED(H_IDLE)
                and UNSIGNED(req_state)         /= UNSIGNED(req_again)
                and reset               /= '1' 
                and need_retry          /= '1' ) then
                data_go <= '1' ;
            elsif ( start                = '1' 
                and masterhbusreq_out    = '1' 
                and masterhgrant         = '1' 
                and masterhready         = '1' 
                and conv_integer(address_length) > 1 
                and retry               /= '1'
                and reset               /= '1' 
                and (need_retry/='1' or trans_end='1') ) then
                data_go <= '1' ;
            else
                data_go <= '0' ;
            end if ; 

        end process completedataphase ;

     -- +======================================================+
     -- | process UPDATES                                      |
     -- |                                                      |
     -- |    update masterhwrite_out_r, Transaction size,      |
     -- |    busy state and counter on leading edge of clock   |
     -- |    or reset                                          |
     -- +======================================================+

        updates : process ( masterhclk, reset ) 

        begin

            if (   ( masterhclk'event and masterhclk='1')  
                or ( reset'event      and reset='1'     ) ) then 

             -- +------------------------------------------------------+
             -- | masterhwrite_out_r update                            |
             -- |                                                      |
             -- |  Updated on any clock that starts a new transaction  |
             -- +------------------------------------------------------+

                if ( reset='1' ) then
                    masterhwrite_out_r <= '1' ;
                elsif ( addr_ack='1' ) then 
                    masterhwrite_out_r <= write ;
                end if ;

             -- +------------------------------------------------------+
             -- | Transaction size update                              |
             -- |                                                      |
             -- |  Updated on any clock that starts a new transaction  |
             -- +------------------------------------------------------+

                if ( reset ='1' ) then
                    masterhsize_outl <= "000" ;
                elsif ( addr_ack ='1' ) then 
                    masterhsize_outl <= size ;
                end if ;
 
             -- +------------------------------------------------------+
             -- | Busy state and counter update                        |
             -- |                                                      |
             -- |  Insert BUSY states into burst transactions.         |
             -- |  Capture control word. Load counter on every active  |
             -- |  phase and decrement to zero.                        |
             -- +------------------------------------------------------+

                if ( reset ='1' ) then
                    busy_states <= "00" ;
                elsif ( addr_ack ='1' ) then 
                    busy_states <= insert_busy ;
                end if ;
  
                if ( reset ='1' ) then
                    busy_counter <= "00" ;
                elsif ((UNSIGNED(masterhtrans_out_r)=UNSIGNED(H_NONSEQ)) or (UNSIGNED(masterhtrans_out_r) = UNSIGNED(H_SEQ))) then 
                    busy_counter <= busy_states - 1;
                else
                    busy_counter <= busy_counter - ur_OR(busy_counter);
                end if ;

            end if ; 

        end process updates ; 

     -- +=================================================================+
     -- |  RESTART TRANS processes                                        |
     -- |                                                                 |
     -- |  first_masterhtrans_out_r is asserted to enable the first beat  |
     -- |  of a transaction addr_ack (which is always NONSEQ) to :        |
     -- |       + restart a transaction that was interrupted by loss      |
     -- |         of masterhgrant if we receive a new masterhgrant        |
     -- |         whilst in req_again or req_masterhold states.           |
     -- |       + restart a transaction after a RETRY response.           |
     -- |       + restart a transaction after a SPLIT response.           |
     -- |       + break an undefined INCR replay of a retried or split    |
     -- |         wrapping burst at the wrap address boundary.            |
     -- +-----------------------------------------------------------------+

        restarttrans : process (masterhclk, reset)

            variable masterhgrant_in_leading_edge  : std_logic := '0' ;

        begin

            if ( masterhclk'event and masterhclk ='1') then
                masterhgrant_in_r <= masterhgrant;
            end if ;

            masterhgrant_in_leading_edge := masterhgrant and not masterhgrant_in_r ;

            if (   ( masterhclk'event and masterhclk ='1') 
                or ( reset'event      and reset='1'     ) ) then
                if (reset = '1') then
                    new_grant <= '0' ;
                elsif (masterhgrant_in_leading_edge = '1' and first_masterhtrans_out_r /= '1') then
                    new_grant <= '1' ;
                elsif (first_masterhtrans_out_r = '1' or masterhgrant /= '1') then
                    new_grant <= '0' ;
                end if ;
            end if ;

         end process restarttrans ;


         updatefirst_masterhtrans_out_r : process ( addr_ack, masterhgrant, masterhgrant_in_r, new_grant, masterhready, masterhwrite_out_r, 
                                                    first_beat, data_bus_owned, address_bus_owned, length, masterhresp, req_state)

            variable boolean_1 : std_logic := '0' ; 
            variable boolean_2 : std_logic := '0' ; 
            variable boolean_3 : std_logic := '0' ; 
            variable boolean_4 : std_logic := '0' ; 
            variable boolean_5 : std_logic := '0' ; 
            variable masterhgrant_in_leading_edge  : std_logic := '0' ;

         begin

            -- convert booleans in expression to '1's or '0's

            masterhgrant_in_leading_edge := masterhgrant and not masterhgrant_in_r ;

            if (UNSIGNED(req_state)  =UNSIGNED(req_masterhold)) then boolean_1 := '1' ; else boolean_1 := '0' ; end if ;
            if (UNSIGNED(req_state)  =UNSIGNED(req_again)     ) then boolean_2 := '1' ; else boolean_2 := '0' ; end if ;
            if (UNSIGNED(masterhresp)=UNSIGNED(H_RETRY)       ) then boolean_3 := '1' ; else boolean_3 := '0' ; end if ;
            if (UNSIGNED(masterhresp)=UNSIGNED(H_SPLIT)       ) then boolean_4 := '1' ; else boolean_4 := '0' ; end if ;
            if (conv_integer(length) > 1  ) then boolean_5 := '1' ; else boolean_5 := '0' ; end if ;

            first_masterhtrans_out_r <= (addr_ack 
                or ((((masterhgrant_in_leading_edge or (masterhgrant and new_grant)) and masterhready) and (not masterhwrite_out_r)) and (boolean_1 or boolean_2))
                or ((masterhgrant_in_leading_edge or (masterhgrant and new_grant)) and (masterhready and masterhwrite_out_r) and (boolean_1 or boolean_2)  )
                or ((data_bus_owned and masterhready) and (boolean_3 or boolean_4)))
                or (((address_bus_owned and masterhready) and (not first_beat)) and (break_wrap and boolean_5));

         end process updatefirst_masterhtrans_out_r ; 
 
         -- +------------------------------------------------------+
         -- | The only time masterhtrans_out_r changes is when     |
         -- | masterhready is negated is during reset or after     |
         -- | the first cycle of a two-cyle error response.        |
         -- | Otherwise, masterhtrans_out_r can only change when   |
         -- | masterhgrant and masterhready are asserted.          |
         -- +------------------------------------------------------+

         updatemasterhtrans_out_r : process ( masterhclk, reset )

         begin

            if (   ( masterhclk'event and masterhclk='1')  
                or ( reset'event      and reset='1'     ) ) then 
                if (reset='1') then
                    masterhtrans_out_r <= H_IDLE;
                elsif (    data_bus_owned        = '1'
                       and masterhready         /= '1'
                       and UNSIGNED(masterhresp)/=UNSIGNED(H_OKAY)
                       and continue_after_error /= '1' ) then   -- ERROR'ed transactions cancelled
                    masterhtrans_out_r <= H_IDLE;
                elsif (    data_bus_owned        = '1' 
                       and masterhready         /= '1' 
                       and UNSIGNED(masterhresp)/= UNSIGNED(H_OKAY)
                       and UNSIGNED(masterhresp)/= UNSIGNED(H_ERROR)
                       and continue_after_error  = '1' ) then       -- ERROR'ed transactions not cancelled
                    masterhtrans_out_r <= H_IDLE;
                elsif (    masterhgrant='1' 
                       and masterhready='1') then
                    case masterhtrans_out_r
                    is
                        when H_IDLE    => if (first_masterhtrans_out_r='1') then 
                                              masterhtrans_out_r <= H_NONSEQ;
                                          else
                                              masterhtrans_out_r <= H_IDLE;
                                          end if ;
    
                        when H_NONSEQ  |
                             H_SEQ     => if (first_masterhtrans_out_r='1') then 
                                              masterhtrans_out_r <= H_NONSEQ;
                                          elsif ((UNSIGNED(masterhburst_out_r)=UNSIGNED(H_SINGLE)) or (conv_integer(address_length) <= 1) ) then -- Last beat
                                              masterhtrans_out_r <= H_IDLE;
                                          elsif (go_busy = '1') then 
                                              masterhtrans_out_r <= H_BUSY;
                                          else
                                              masterhtrans_out_r <= H_SEQ;
                                          end if ;
    
                        when H_BUSY    => if (first_masterhtrans_out_r='1') then 
                                              masterhtrans_out_r <= H_NONSEQ;
                                          elsif (go_busy='1') then 
                                              masterhtrans_out_r <= H_BUSY;
                                          else
                                              masterhtrans_out_r <= H_SEQ;
                                          end if ;
                        when others    => assert false report "error in masterhtrans_out_r" severity warning;
                    end case ;
                elsif (masterhready='1' and masterhgrant/='1') then
                    masterhtrans_out_r <= H_IDLE;
                end if ;
            end if ;
  
         end process updatemasterhtrans_out_r ;

         -- +------------------------------------------------------+
         -- | One of reading or writing is asserted during any     | 
         -- | data beat for which we are actively using the bus.   |
         -- +------------------------------------------------------+

         updatereadingwriting : process (masterhclk, reset) 

         begin

            if (   ( masterhclk'event and masterhclk='1')  
                or ( reset'event      and reset='1'     ) ) then 
                if (reset='1') then
                    reading <= '0' ;
                    writing <= '0' ;
                elsif (masterhready = '1') then
                    if (    masterhwrite_out_r /= '1'
                        and address_bus_owned   = '1'
                        and UNSIGNED(masterhtrans_out_r)/= UNSIGNED(H_IDLE) 
                        and UNSIGNED(masterhtrans_out_r)/= UNSIGNED(H_BUSY) ) then 
                        reading <= '1' ; 
                    else 
                        reading <= '0' ;
                    end if ;  
                    if (    masterhwrite_out_r  = '1'
                        and address_bus_owned   = '1'
                        and UNSIGNED(masterhtrans_out_r) /= UNSIGNED(H_IDLE) 
                        and UNSIGNED(masterhtrans_out_r )/= UNSIGNED(H_BUSY) ) then  
                        writing <= '1' ;
                    else 
                        writing <= '0' ;
                    end if ; 
                end if ; 
            end if ; 

         end process updatereadingwriting ;

         -- +----------------------------------------------------------+
         -- | Burst size                                               |
         -- |                                                          |
         -- | first_beat is used to keep masterhburst_out_r unchanged  |
         -- | when the first beat is to be replayed. It alse controls  |
         -- | the bus request. A transaction that is split or retried  |
         -- | on any other beat will be replayed as INCR and           |
         -- | masterhbusreq_out must be held asserted.                 |
         -- |                                                          |
         -- | Tmasterhis means that a defined length read that us      |
         -- | interrupted mid-burst will complete as an undefined INCR |
         -- | and may pre-fetch past the end of the defined length     |
         -- | (unless, of course, no_prefetch is asserted).            |
         -- +----------------------------------------------------------+

         burst_beat : process (masterhclk, reset)
         begin
            if (   ( masterhclk'event and masterhclk='1')  
                or ( reset'event      and reset='1'     ) ) then 
                if (reset='1') then
                    first_beat <= '0' ;
                elsif (addr_ack='1') then 
                    first_beat <= '1' ;
                elsif (data_bus_owned='1' and (reading='1' or writing='1') and masterhready='1' and UNSIGNED(masterhresp)=UNSIGNED(H_OKAY)) then
                    first_beat <= '0' ;
                end if ; 
             end if ; 
         end process burst_beat ; 

         burst_burst_out : process (masterhclk, reset)
         begin
            if (   ( masterhclk'event and masterhclk='1')  
                or ( reset'event      and reset='1'     ) ) then 
                if (reset='1') then
                    masterhburst_out_r <= "000" ;
                elsif (addr_ack='1') then 
                    masterhburst_out_r <= burst ;
                elsif (first_masterhtrans_out_r='1' and first_beat/='1') then 
                    masterhburst_out_r <= H_INCR;
                end if ; 
             end if ; 
         end process burst_burst_out ; 

         -- +------------+
         -- | need_retry |
         -- +------------+

         burst_need_retry : process (masterhclk, reset)
         begin
            if (   ( masterhclk'event and masterhclk='1')  
                or ( reset'event      and reset='1'     ) ) then 
                if (reset='1') then
                    need_retry <= '0' ;
                elsif (    data_bus_owned='1' 
                       and masterhready /='1' 
                       and (UNSIGNED(masterhresp)=UNSIGNED(H_RETRY) or UNSIGNED(masterhresp)=UNSIGNED(H_SPLIT)) ) then
                    need_retry <= '1' ;
                elsif (    data_bus_owned='1' 
                       and masterhready  ='1' 
                       and (reading='1' or writing='1')
                       and (UNSIGNED(masterhresp)=UNSIGNED(H_OKAY) or UNSIGNED(masterhresp) = UNSIGNED(H_ERROR)) ) then
                    need_retry <= '0' ;
                end if ;  
             end if ; 
         end process burst_need_retry ; 
 
         burst_wraps : process (masterhclk, reset)
         begin
            if (   ( masterhclk'event and masterhclk='1')  
                or ( reset'event      and reset='1'     ) ) then 
                if (reset = '1') then
                    wrap           <= '0'   ;
                    original_burst <= "000" ;
                    replay_wrap    <= "000" ;
                elsif (addr_ack = '1') then
                    if (UNSIGNED(burst)=UNSIGNED(H_WRAP4) or UNSIGNED(burst)=UNSIGNED(H_WRAP8) or UNSIGNED(burst)=UNSIGNED(H_WRAP16)) then 
                        wrap       <= '1' ;
                    else
                        wrap       <= '0' ;
                    end if ; 
                    original_burst <= burst;
                    replay_wrap    <= "000" ;
                elsif (    data_bus_owned ='1' 
                       and masterhready  /='1' 
                       and wrap           ='1' 
                       and (UNSIGNED(masterhresp)=UNSIGNED(H_RETRY) or UNSIGNED(masterhresp)=UNSIGNED(H_SPLIT)) ) then
                    replay_wrap <= "001" ;
                end if ; 
            end if ; 
        end process burst_wraps ;

     -- +===========================================================+
     -- |  Compute Wrap Mask and Bound bit processes                |
     -- |                                                           |
     -- |  Used to modify next_masterhaddr_out_r during wrapping    |
     -- |  bursts. First case statement forms a mask based on the   |
     -- |  transfer size. This is then shifted left with '1's       |
     -- |  inserted to form the final mask.                         |
     -- |  E.g. masterhsize_outl == word (3'b010) wrapped at a four | 
     -- |  beat boundary results in wrap_mask set to 10'b0000001111 | 
     -- |  allowing the four lsbs of the address to increment and   |
     -- |  wrap addressing sixteen bytes in total.                  |
     -- +===========================================================+

        computeinitwrapmask : process ( masterhsize_outl )
        begin
            case masterhsize_outl
            is
                when "000"  => init_wrap_mask <= "0000000000" ;
                when "001"  => init_wrap_mask <= "0000000001" ;
                when "010"  => init_wrap_mask <= "0000000011" ;
                when "011"  => init_wrap_mask <= "0000000111" ;
                when "100"  => init_wrap_mask <= "0000001111" ;
                when "101"  => init_wrap_mask <= "0000011111" ;
                when "110"  => init_wrap_mask <= "0000111111" ;
                when "111"  => init_wrap_mask <= "0001111111" ;
                when others => init_wrap_mask <= "0000000000" ;
                               assert false report "error in masterhsize_outl" severity warning;
            end case ;
        end process computeinitwrapmask ; 


        computewrapmask : process ( original_burst, init_wrap_mask )
        begin
            case original_burst
            is
                when H_WRAP4  =>  wrap_mask(9 downto 2) <= init_wrap_mask(7 downto 0) ;
                                  wrap_mask(1 downto 0) <= "11" ;
                when H_WRAP8  =>  wrap_mask(9 downto 3) <= init_wrap_mask(6 downto 0) ;
                                  wrap_mask(2 downto 0) <= "111" ;
                when H_WRAP16 =>  wrap_mask(9 downto 4) <= init_wrap_mask(5 downto 0) ;
                                  wrap_mask(3 downto 0) <= "1111" ;
                when others   =>  wrap_mask             <= "0000000000" ;
            end case ;
        end process computewrapmask ;



        computeinitwrapbound : process ( masterhsize_outl )
        begin
            case masterhsize_outl
            is
                when "000"  => init_wrap_boundary_bit <= "00000001" ;
                when "001"  => init_wrap_boundary_bit <= "00000010" ;
                when "010"  => init_wrap_boundary_bit <= "00000100" ;
                when "011"  => init_wrap_boundary_bit <= "00001000" ;
                when "100"  => init_wrap_boundary_bit <= "00010000" ;
                when "101"  => init_wrap_boundary_bit <= "00100000" ;
                when "110"  => init_wrap_boundary_bit <= "01000000" ;
                when "111"  => init_wrap_boundary_bit <= "10000000" ;
                when others => init_wrap_boundary_bit <= "00000000" ;
                               assert false report "error in masterhsize_outl" severity warning;
            end case ;
        end process computeinitwrapbound ; 

        computewrapbound : process ( original_burst, init_wrap_boundary_bit )
        begin
            case original_burst
            is
                when H_WRAP4  => wrap_boundary_bit(9 downto 2) <= init_wrap_boundary_bit ;
                                 wrap_boundary_bit(1 downto 0) <= "00" ;
                when H_WRAP8  => wrap_boundary_bit(9 downto 3) <= init_wrap_boundary_bit(6 downto 0) ;
                                 wrap_boundary_bit(2 downto 0) <= "000" ;
                when H_WRAP16 => wrap_boundary_bit(9 downto 4) <= init_wrap_boundary_bit(5 downto 0) ;
                                 wrap_boundary_bit(3 downto 0) <= "0000" ;
                when others   => wrap_boundary_bit              <= "00000000000" ;
            end case ;
        end process computewrapbound ;

     -- +============================================================+
     -- | CALCULATE ADDRESS processes                                |
     -- +============================================================+

     -- +------------------------------------------------------------+
     -- | Compute address increment                                  |
     -- |                                                            |
     -- | This code allows for all possibilities by inferring        |
     -- | a 3-to-8 decoder on the transfer size. AHB spec is         |
     -- | unclear how a burst with a transfer size greater           |
     -- | than the bus width should be handled.                      |
     -- +------------------------------------------------------------+

        computeaddressincrement : process ( masterhsize_outl )
        begin
            masterhaddr_out_r_inc                                 <= "00000000" ;
            masterhaddr_out_r_inc(conv_integer(masterhsize_outl)) <= '1'        ;
        end process computeaddressincrement ; 

     -- +------------------------------------------------------------+
     -- | Compute next address                                       |
     -- |                                                            |
     -- | Next address is based on the increment computed from the   |
     -- | transfer size, and the burst type, which may tell us to    |
     -- | wrap. Wrapping is achieved by preserving some of the upper |
     -- | bits through use of wrap_mask.                             |
     -- |                                                            |
     -- | If beat n is retried, we're already putting out the        |
     -- | address for beat n+1 so we need to decrement.              |
     -- +------------------------------------------------------------+

        computeinitnextaddress : process (data_bus_owned, masterhresp, masterhready, 
                                          masterhaddr_out_r, masterhaddr_out_r_inc ) 
            variable temp_init_next_masterhaddr_out_r : std_logic_vector (10 downto 0) ;
        begin
            temp_init_next_masterhaddr_out_r(10)         := '1' ;
            temp_init_next_masterhaddr_out_r(9 downto 0) := masterhaddr_out_r(9 downto 0) ;
            if (data_bus_owned='1' and ((UNSIGNED(masterhresp)=UNSIGNED(H_RETRY)) or (UNSIGNED(masterhresp)=UNSIGNED(H_SPLIT)))) then
                init_next_masterhaddr_out_r <= temp_init_next_masterhaddr_out_r - masterhaddr_out_r_inc;
            else
                init_next_masterhaddr_out_r <= temp_init_next_masterhaddr_out_r + masterhaddr_out_r_inc;
            end if ; 
        end process computeinitnextaddress ; 
  

        computenextaddress : process (original_burst, wrap_mask, masterhaddr_out_r, 
                                      init_next_masterhaddr_out_r ) 
        begin
            if (   (UNSIGNED(original_burst)=UNSIGNED(H_WRAP4) )
                or (UNSIGNED(original_burst)=UNSIGNED(H_WRAP8) )
                or (UNSIGNED(original_burst)=UNSIGNED(H_WRAP16)) ) then
                next_masterhaddr_out_r <=    (wrap_mask and init_next_masterhaddr_out_r(9 downto 0)) 
                                          or (not wrap_mask and masterhaddr_out_r(9 downto 0)) ;
            else
                next_masterhaddr_out_r <= init_next_masterhaddr_out_r (9 downto 0) ;
            end if ;
        end process computenextaddress ; 

        break_wrap <=       replay_wrap(1)
                      and ( ur_OR(init_next_masterhaddr_out_r and wrap_boundary_bit) xor ur_OR(masterhaddr_out_r(10 downto 0) and wrap_boundary_bit)  ) ;


     -- +------------------------------------------------------------+
     -- | Address Generation                                         |
     -- |                                                            |
     -- | AHB address has to track the changing address during       |
     -- | bursts. next_masterhaddr_out_r computes the next address.  | 
     -- |                                                            |
     -- | NOTE: It is incumbent upon the command file not to attempt |
     -- | a transaction that would cross a 1Kbyte address boundary.  |
     -- |                                                            |
     -- | Address is normally updated after each address phase. It   |
     -- | is also updated during the second cycle of a two cycle     |
     -- | retry or split response to rewind the address and allow    |
     -- | the transaction to be replayed.                            |
     -- +------------------------------------------------------------+

        addressgeneration : process (masterhclk, reset)
        begin
            if (   ( masterhclk'event and masterhclk='1')  
                or ( reset'event      and reset='1'     ) ) then 
                if (reset='1') then
                    masterhaddr_out_r <= (OTHERS => '0' ) ;
                elsif (addr_ack='1') then
                    masterhaddr_out_r <= start_address ;
                elsif (    data_bus_owned ='1'
                       and masterhready   ='1' 
                       and (UNSIGNED(masterhresp)=UNSIGNED(H_RETRY) or UNSIGNED(masterhresp)=UNSIGNED(H_SPLIT)) ) then 
                    masterhaddr_out_r(9 downto 0) <= next_masterhaddr_out_r ;
                elsif (    address_bus_owned ='1'
                       and masterhready      ='1'
                       and (UNSIGNED(masterhtrans_out_r)=UNSIGNED(H_NONSEQ) or UNSIGNED(masterhtrans_out_r)=UNSIGNED(H_SEQ)) ) then
                    masterhaddr_out_r(9 downto 0) <= next_masterhaddr_out_r ;
                end if ; 
            end if; 
        end process addressgeneration ;

     -- +============================================================+
     -- | WRITEDATA processes                                        |
     -- |                                                            |
     -- | If generate_data is negated then initial data is taken     |
     -- | from data input. If generate_data is asserted then data is |
     -- | generated from the address offset to match that expected   |
     -- | by the checkers.                                           |
     -- |                                                            |
     -- | The expected data and the transaction number follow the    |
     -- | write data.                                                |
     -- |                                                            |
     -- | At the end of a burst data is set to X so we can ensure    |
     -- | nothing is relying on invalid data.                        |
     -- +============================================================+

        writedatapipeandretry: process (masterhclk)
        begin
            if ( masterhclk'event and masterhclk='1') then
                if (    data_bus_owned  ='1' 
                    and masterhready   /='1' 
                    and (UNSIGNED(masterhresp)=UNSIGNED(H_RETRY) or UNSIGNED(masterhresp)=UNSIGNED(H_SPLIT)) ) then
                    masterhwdata_out_r_retry <= masterhwdata_out_r ;
                elsif (addr_ack='1' or data_ack='1') then
                    masterhwdata_out_r_pipe  <= data ;
                end if ;
            end if ; 
        end process writedatapipeandretry ;

        addr_offset(7 downto 2) <= masterhaddr_out_r (7 downto 2) ;
        addr_offset(1 downto 0) <= "00" ;      

        writedata: process (masterhclk, reset)
        begin
            if (   ( masterhclk'event and masterhclk='1')  
                or ( reset'event      and reset='1'     ) ) then 
                if (reset='1') then 
                    masterhwdata_out_r <= (OTHERS=> '0') ;
                elsif (address_bus_owned /='1' and masterhready='1') then
                    masterhwdata_out_r <= (OTHERS=> 'X') ;
                elsif (masterhready='1' and generate_data /='1') then
                    if (address_bus_owned='1' and masterhwrite_out_r='1' and need_retry='1' and trans_end/='1') then
                        masterhwdata_out_r <= masterhwdata_out_r_retry;
                    elsif (address_bus_owned='1' and masterhwrite_out_r='1' and UNSIGNED(masterhtrans_out_r)=UNSIGNED(H_NONSEQ)) then
                        masterhwdata_out_r <= masterhwdata_out_r_pipe ; 
                    elsif (UNSIGNED(length) = 0 ) then
                        masterhwdata_out_r <= (OTHERS=> 'X') ;
                    elsif (address_bus_owned='1' and masterhwrite_out_r='1' and UNSIGNED(masterhtrans_out_r)=UNSIGNED(H_SEQ)) then
                        masterhwdata_out_r <= masterhwdata_out_r_pipe; 
                    end if ;
                elsif (masterhready='1' and generate_data='1') then
                    if (address_bus_owned='1' and masterhwrite_out_r='1' and UNSIGNED(masterhtrans_out_r)=UNSIGNED(H_NONSEQ)) then
                        masterhwdata_out_r (31 downto 24) <= addr_offset ;
                        masterhwdata_out_r (23 downto 16) <= addr_offset ;
                        masterhwdata_out_r (15 downto  8) <= addr_offset ;
                        masterhwdata_out_r ( 7 downto  0) <= addr_offset ;
                    elsif (UNSIGNED(length) = 0 ) then
                        masterhwdata_out_r <= (OTHERS=> 'X') ;
                    elsif (address_bus_owned='1' and masterhwrite_out_r='1' and UNSIGNED(masterhtrans_out_r)=UNSIGNED(H_SEQ)) then
                        masterhwdata_out_r (31 downto 24) <= addr_offset ;
                        masterhwdata_out_r (23 downto 16) <= addr_offset ;
                        masterhwdata_out_r (15 downto  8) <= addr_offset ;
                        masterhwdata_out_r ( 7 downto  0) <= addr_offset ;
                    end if ;
                end if ; 
            end if ; 
        end process writedata ;

     -- +================================================================+
     -- | Transaction Details processes                                  |
     -- |                                                                |
     -- | The transactor pipeline consists of four stages                |
     -- |                                                                |
     -- |    nextTrans - the next transaction from the store             |
     -- | controlTrans - the current control / address stage transaction |
     -- |    dataTrans - the data stage transaction                      |
     -- |  reportTrans - the completed stage for reporting               |
     -- |                                                                |
     -- |  controlTrans is updated from nextTrans when a new transaction |
     -- |  begins or from dataTrans in the case of split/retry           |
     -- +================================================================+

        transdetails : process (masterhclk)
        begin 
            if ( masterhclk'event and masterhclk='1') then
                if (    data_bus_owned ='1' 
                    and masterhready /='1'
                    and (UNSIGNED(masterhresp)=UNSIGNED(H_RETRY) or UNSIGNED(masterhresp)=UNSIGNED(H_SPLIT)) ) then
                    retryTrans   <= dataTrans ;
                elsif (addr_ack='1' or data_ack='1') then
                    controlTrans <= nextTrans ;
                end if ;
            end if ;
        end process transdetails ;

        setdatatransdetails : process (masterhclk, reset)
        begin 
            if (   ( masterhclk'event and masterhclk='1')  
                or ( reset'event      and reset='1'     ) ) then 
                if (    address_bus_owned = '1' 
                    and masterhready = '1' 
                    and reset /= '1'
                    and (need_retry/='1' or trans_end='1') ) then

                    dataTrans                                             <= controlTrans       ;
                    dataTrans (Trns_ADDR_b      downto Trns_ADDR_l     )  <= masterhaddr_out_r  ;
                    dataTrans (Trns_WRITE                              )  <= masterhwrite_out_r ;
                    dataTrans (Trns_LOCK                               )  <= masterhlock_out    ;
                    dataTrans (Trns_TRANSTYPE_b downto Trns_TRANSTYPE_l)  <= masterhtrans_out_r ;
                    dataTrans (Trns_BURSTTYPE_b downto Trns_BURSTTYPE_l)  <= masterhburst_out_r ;
                    dataTrans (Trns_SIZE_b      downto Trns_SIZE_l     )  <= masterhsize_outl   ;

                elsif (    address_bus_owned = '1' 
                       and masterhready = '1' 
                       and reset /='1' 
                       and need_retry ='1' ) then

                    dataTrans                                             <= retryTrans         ;
                    dataTrans (Trns_ADDR_b      downto Trns_ADDR_l     )  <= masterhaddr_out_r  ;
                    dataTrans (Trns_WRITE                              )  <= masterhwrite_out_r ;
                    dataTrans (Trns_LOCK                               )  <= masterhlock_out    ;
                    dataTrans (Trns_TRANSTYPE_b downto Trns_TRANSTYPE_l)  <= masterhtrans_out_r ;
                    dataTrans (Trns_BURSTTYPE_b downto Trns_BURSTTYPE_l)  <= masterhburst_out_r ;
                    dataTrans (Trns_SIZE_b      downto Trns_SIZE_l     )  <= masterhsize_outl   ;

                elsif ( (address_bus_owned /= '1' and masterhready='1') or reset='1') then

                    dataTrans                                             <= idleTrans          ;

                end if ; 
            end if ;
        end process setdatatransdetails ;


        setreporttransdetails : process (masterhclk)
        begin 
            if ( masterhclk'event and masterhclk='1') then
                if (trans_end='1' and need_retry /='1') then
                    reportTrans (Trns_RESP_b downto Trns_RESP_l) <= masterhresp;
                    reportTrans (Trns_READ_b downto Trns_READ_l) <= masterhrdata; 
                    reportTrans (Trns_BUSY   downto          0 ) <= dataTrans(Trns_BUSY downto 0);
                elsif (trans_end='1' and need_retry = '1') then
                    reportTrans (Trns_RESP_b downto Trns_RESP_l) <= masterhresp;
                    reportTrans (Trns_READ_b downto Trns_READ_l) <= masterhrdata; 
                    reportTrans (Trns_BUSY   downto          0 ) <= retryTrans(Trns_BUSY downto 0);
                else
                    reportTrans                                  <= idleTrans;
                end if ; 
            end if ;
        end process setreporttransdetails ;  

     -- +------------------+
     -- | masterhlock_out  |
     -- +------------------+
  
        masterhlock_out <= '0' ;
  
-- +--------------------------------------------------------------------+
-- +--------------------------------------------------------------------+

end behaviour ; -- alt_exc_upcore


----------------------------------------------------------
--                   ALTDDIO_IN
----------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;

entity altddio_in is
	generic (width : positive := 1;
		 power_up_high : string := "OFF");
	port (datain : in std_logic_vector(width-1 downto 0);
	      inclock : in std_logic;
	      inclocken : in std_logic := '1';
	      aset : in std_logic := '0';
	      aclr : in std_logic := '0';
	      dataout_H : out std_logic_vector(width-1 downto 0);
	      dataout_L : out std_logic_vector(width-1 downto 0));
end altddio_in;
	 
architecture behave of altddio_in is
begin
process (inclock, aset, aclr)
variable dataout_H_tmp, dataout_L_tmp : std_logic_vector(width-1 downto 0);
begin
        if (NOW = 0 ps) then
           if (power_up_high = "OFF") then
              dataout_H_tmp := (others => '0');
              dataout_L_tmp := (others => '0');
	   else
              dataout_H_tmp := (others => '1');
              dataout_L_tmp := (others => '1');
           end if;
 	end if;
	if (aclr = '1') then
	   dataout_H_tmp := (others => '0');
	   dataout_L_tmp := (others => '0');
	elsif (aset = '1') then
	      dataout_H_tmp := (others => '1');
	      dataout_L_tmp := (others => '1');
	elsif (inclock = '1' and inclocken = '1') then
	   dataout_H_tmp := datain;
	elsif (inclock = '1' and inclocken = '1') then
	   dataout_L_tmp := datain;
	end if;	
	dataout_L <= dataout_L_tmp;
	dataout_H <= dataout_H_tmp;
end process;
end behave;
----------------------------------------------------------
--                   ALTDDIO_OUT
----------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;

entity altddio_out is
	generic (width : positive := 1;
		 power_up_high : string := "OFF");
	port (datain_H : in std_logic_vector(width-1 downto 0);
	      datain_L : in std_logic_vector(width-1 downto 0);
	      outclock : in std_logic;
	      outclocken : in std_logic := '1';
	      aset : in std_logic := '0';
	      aclr : in std_logic := '0';
	      oe : in std_logic;
	      dataout : out std_logic_vector(width-1 downto 0));
end altddio_out;
	 
architecture behave of altddio_out is
begin
process (outclock, aset, aclr, oe)
variable dataout_tmp : std_logic_vector(width-1 downto 0);
begin
	if (NOW = 0 ps) then
	   if (power_up_high = "OFF") then
	      dataout_tmp := (others => '0');
	   else
	      dataout_tmp := (others => '1');
	   end if;
 	end if;
	if (aclr = '1') then
	   dataout_tmp := (others => '0');
	elsif (aset = '1') then
	   dataout_tmp := (others => '1');
	elsif (outclock = '1' and outclocken = '1') then
	   dataout_tmp := datain_H;
	elsif (outclock = '1' and outclocken = '1') then
	   dataout_tmp := datain_L;
	end if;
	if (oe = '0') then
	   dataout_tmp := (others => 'Z');
	end if;
	dataout <= dataout_tmp;
end process;
end behave;
-------------------------------------------------------------
--  		ALTDDIO_BIDIR 
-------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;

entity altddio_bidir is
	generic(width : positive := 1; 
                power_up_high : string := "OFF");
	port (datain_H : in std_logic_vector(width-1 downto 0);
	      datain_L : in std_logic_vector(width-1 downto 0);
	      inclock : in std_logic;
	      inclocken : in std_logic := '1';
	      outclock : in std_logic;
	      outclocken : in std_logic := '1';
	      aset : in std_logic := '0';
	      aclr : in std_logic := '0';
	      oe : in std_logic;
	      dataout_H : out std_logic_vector(width-1 downto 0);
	      dataout_L : out std_logic_vector(width-1 downto 0);
	      padout : inout std_logic_vector(width-1 downto 0));

end altddio_bidir;
architecture struct of altddio_bidir is

signal padout_in, padout_out : std_logic_vector(width-1 downto 0);
component altddio_in
	generic(width : positive := 8;
                power_up_high : string := "OFF");
        port (datain : in std_logic_vector(width-1 downto 0);
              inclock : in std_logic;
              inclocken : in std_logic := '1';
	      aset : in std_logic := '0';
	      aclr : in std_logic := '0';
              dataout_H : out std_logic_vector(width-1 downto 0);
              dataout_L : out std_logic_vector(width-1 downto 0));
end component;

component altddio_out
        generic (width : positive := 8;
                 power_up_high : string := "OFF");
        port (datain_H : in std_logic_vector(width-1 downto 0);
              datain_L : in std_logic_vector(width-1 downto 0);
              outclock : in std_logic;
              outclocken : in std_logic := '1';
	      aset : in std_logic := '0';
	      aclr : in std_logic := '0';
	      oe : in std_logic;
              dataout : out std_logic_vector(width-1 downto 0));
end component;

begin

padout_in <= padout when  oe = '0' else (others => 'Z');
padout <= padout_out when oe = '1' else (others => 'Z');

u1: altddio_in 
	generic map (width => width,
                     power_up_high => power_up_high)
	port map (datain => padout_in, inclock => inclock, 
                  inclocken => inclocken, aset => aset, aclr => aclr,
                  dataout_H => dataout_H, dataout_L => dataout_L);

u2: altddio_out 
	generic map (width => width,
                     power_up_high => power_up_high)
     	port map (datain_H => datain_H, datain_L => datain_L, 
                  outclock => outclock, outclocken => outclocken, 
                  aset => aset, aclr => aclr, oe => oe, dataout => padout_out);
end struct;
------------------------------------------------------------------
-- 			HSSI_PLL
------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity hssi_pll is
    generic
      ( clk0_multiply_by        : integer := 1;
        clk1_divide_by          : integer := 1;
        input_frequency         : integer := 1000);
    port
      ( clk    : in std_logic := '0';
        areset : in std_logic := '0';
        clk0   : out std_logic;
        clk1   : out std_logic;
        locked : out std_logic );
end hssi_pll;

architecture hssi_pll of hssi_pll is

SIGNAL clk0_period, clk1_period, half_inclk : time;
SIGNAL clk0_phase_delay, clk1_phase_delay : time := 0 ps;
SIGNAL new_clk0, new_clk1 : std_logic;
SIGNAL start_outclk : std_logic;
SIGNAL pll_lock : std_logic := '0';
SIGNAL lock_on_rise, lock_on_fall : integer := 0;
SIGNAL clk_check : std_logic := '0';

begin

process (clk, pll_lock, clk_check)
variable expected_cycle, real_cycle : real;
variable inclk_ps : time;
variable violation : boolean := false;
variable pll_lock_tmp : std_logic := '0';
variable start_lock_count, stop_lock_count : integer := 0;
variable pll_last_rising_edge, pll_last_falling_edge : time := 0 ps;
variable pll_rising_edge_count : integer := 0;
variable pll_cycle, pll_duty_cycle : time ;
variable clk_per_tolerance : time;
variable expected_next_clk_edge : time := 0 ps;
variable lock_low : integer := 2;
variable lock_high : integer := 2;
begin
    if (areset = '1') then
        pll_rising_edge_count := 0;
        violation := false;
        pll_lock_tmp := '0';
        pll_lock <= '0';
        start_lock_count := 0;
        stop_lock_count := 0;
    else
        if (clk'event and clk = '1' and now > 0 ns) then
            if (pll_lock_tmp = '1') then
                clk_check <= not clk_check after (inclk_ps+clk_per_tolerance)/2.0;
            end if;
            if pll_rising_edge_count = 0 then      -- at 1st rising edge
                inclk_ps := (input_frequency / 1 ) * 1 ps;
                half_inclk <= inclk_ps/2;
                clk_per_tolerance := 0.025 * inclk_ps;
                clk0_period <= inclk_ps / clk0_multiply_by;
                clk1_period <= inclk_ps / clk0_multiply_by * clk1_divide_by;
                pll_duty_cycle := inclk_ps/2;
                start_outclk <= '0';
                clk0_phase_delay <= 0 ps;
                clk1_phase_delay <= 0 ps;
    
            elsif pll_rising_edge_count = 1 then      -- at 2nd rising edge
                pll_cycle := now - pll_last_rising_edge;    -- calculate period
                expected_cycle := real(input_frequency) / 1000.0;
                real_cycle := REAL( (NOW - pll_last_rising_edge) / 1 ns);
                if ((NOW - pll_last_rising_edge) < (inclk_ps - clk_per_tolerance)  or
                    (NOW - pll_last_rising_edge) > (inclk_ps + clk_per_tolerance)) then
                    ASSERT FALSE
                    REPORT " Inclock_Period Violation "
                    SEVERITY WARNING;
                    violation := true;
                    if (pll_lock = '1') then
                        stop_lock_count := stop_lock_count + 1;
                        if (stop_lock_count = lock_low) then
                            pll_lock_tmp := '0';
                        end if;
                    end if;
                else
                    violation := false;
                end if;
                if ((now - pll_last_falling_edge) < (pll_duty_cycle - clk_per_tolerance/2) or
                    (now - pll_last_falling_edge) > (pll_duty_cycle + clk_per_tolerance/2)) then
                    ASSERT FALSE
                    REPORT "Duty Cycle Violation"
                    SEVERITY WARNING;
                    violation := true;
                else
                    violation := false;
                end if;
            else
                if ((now - pll_last_rising_edge) < (inclk_ps - clk_per_tolerance) or
                    (now - pll_last_rising_edge) > (inclk_ps + clk_per_tolerance)) then
                    ASSERT FALSE
                    REPORT "Cycle Violation"
                    SEVERITY WARNING;
                    violation := true;
                    if (pll_lock = '1') then
                        stop_lock_count := stop_lock_count + 1;
                        if (stop_lock_count = lock_low) then
                            pll_lock_tmp := '0';
                        end if;
                    end if;
                else
                    violation := false;
                end if;
            end if;
            pll_last_rising_edge := now;
            pll_rising_edge_count := pll_rising_edge_count +1;
        
            if (not violation) then
                start_lock_count := start_lock_count + 1;
            else
                start_lock_count := 0;
            end if;
        
            if (start_lock_count = (lock_high + 1)) then
                pll_lock_tmp := '1';
                lock_on_rise <= 1;
            end if;
        elsif (clk'event and clk= '0' and now > 0 ns) then
            if (pll_lock_tmp = '1') then
                clk_check <= not clk_check after (inclk_ps+clk_per_tolerance)/2.0;
            end if;
            if (now > 0 ns and ((now - pll_last_rising_edge) < (pll_duty_cycle - clk_per_tolerance/2) or
               (now - pll_last_rising_edge) > (pll_duty_cycle + clk_per_tolerance/2))) then
                ASSERT FALSE
                REPORT "Duty Cycle Violation"
                SEVERITY WARNING;
                violation := true;
                if (pll_lock = '1') then
                    stop_lock_count := stop_lock_count + 1;
                    if (stop_lock_count = lock_low) then
                        pll_lock_tmp := '0';
                    end if;
                end if;
            else
                violation := false;
            end if;
            pll_last_falling_edge := now;
            if (not violation) then
                start_lock_count := start_lock_count + 1;
            else
                start_lock_count := 0;
            end if;
            if (start_lock_count = (lock_high + 1)) then
                pll_lock_tmp := '1';
                lock_on_fall <= 1;
            end if;
        else
            if pll_lock_tmp = '1' then
                if (clk = '1') then
                    expected_next_clk_edge := pll_last_rising_edge + (inclk_ps+clk_per_tolerance)/2.0;
                else
                    expected_next_clk_edge := pll_last_falling_edge + (inclk_ps+clk_per_tolerance)/2.0;
                end if;
                violation := false;
                if (now < expected_next_clk_edge) then
                    clk_check <= not clk_check after (expected_next_clk_edge - now);
                elsif (now = expected_next_clk_edge) then
                    clk_check <= not clk_check after (inclk_ps+clk_per_tolerance)/2.0;
                else
                    ASSERT FALSE
                    REPORT "Inclock_Period Violation"
                    SEVERITY WARNING;
                    violation := true;
                    if (pll_lock = '1') then
                        stop_lock_count := stop_lock_count + 1;
                        if (stop_lock_count = lock_low) then
                            pll_lock_tmp := '0';
                        else
                            clk_check <= not clk_check after (inclk_ps/2.0);
                        end if;
                    end if;
                end if;
            end if;
        end if;
        pll_lock <= pll_lock_tmp;
        if (pll_lock'event and pll_lock = '0') then
            start_lock_count := 0;
            stop_lock_count := 0;
            lock_on_rise <= 0;
            lock_on_fall <= 0;
        end if;
    end if;  -- if not areset
end process;

process (new_clk0, pll_lock)
variable first_clk0_cycle : boolean := true;
variable clk0_tmp : std_logic;
begin
    if (areset = '1') then
        clk0_tmp := 'X';
    else
        if (pll_lock = '0') then
            first_clk0_cycle := true;
            new_clk0 <= start_outclk;
        elsif (pll_lock = '1') then
            if (first_clk0_cycle) then
                first_clk0_cycle := false;
    --          clk0_tmp := start_outclk;
                if (lock_on_rise = 1) then
                    new_clk0 <= not start_outclk after clk0_phase_delay;
                elsif (lock_on_fall = 1) then
                    new_clk0 <= not start_outclk after (clk0_phase_delay + half_inclk);
                end if;
            else
                clk0_tmp := new_clk0;
                new_clk0 <= not new_clk0 after (clk0_period/2.0);
            end if;
        end if;
    end if;
end process;

process (new_clk1, pll_lock)
variable first_clk1_cycle : boolean := true;
variable clk1_tmp : std_logic;
begin
    if (areset = '1') then
        clk1_tmp := 'X';
    else
        if (pll_lock = '0') then
            first_clk1_cycle := true;
            new_clk1 <= start_outclk;
        elsif (pll_lock = '1') then
            if (first_clk1_cycle) then
                first_clk1_cycle := false;
    --          clk1_tmp := start_outclk;
                if (lock_on_rise = 1) then
                    new_clk1 <= not start_outclk after clk1_phase_delay;
                elsif (lock_on_fall = 1) then
                    new_clk1 <= not start_outclk after (clk1_phase_delay + half_inclk);
                end if;
            else
                clk1_tmp := new_clk1;
                new_clk1 <= not new_clk1 after (clk1_period/2.0);
            end if;
        end if;
    end if;
end process;

locked <= pll_lock;

end hssi_pll;
------------------------------------------------------------------------
-- ram7x20_syn
--
library IEEE;
use IEEE.std_logic_1164.all;

entity ram7x20_syn is
	generic (
		ram_width					: integer := 20
	);	

	port (
		wclk	: in std_logic;
		rstl	: in std_logic := '1'; 
		waddr : in std_logic_vector(2 downto 0);
		raddr : in std_logic_vector(2 downto 0);
		datain	: in std_logic_vector(19 downto 0);
		we			: in std_logic := '0';
		re			: in std_logic := '0';
		dataout	: out std_logic_vector(19 downto 0)
	);

end ram7x20_syn;


architecture hssi_ram7x20_syn of ram7x20_syn is
	signal ram_array_d_0 : std_logic_vector(ram_width-1 downto 0) := (OTHERS => '0');
	signal ram_array_d_1 : std_logic_vector(ram_width-1 downto 0) := (OTHERS => '0');
	signal ram_array_d_2 : std_logic_vector(ram_width-1 downto 0) := (OTHERS => '0');
	signal ram_array_d_3 : std_logic_vector(ram_width-1 downto 0) := (OTHERS => '0');
	signal ram_array_d_4 : std_logic_vector(ram_width-1 downto 0) := (OTHERS => '0');
	signal ram_array_d_5 : std_logic_vector(ram_width-1 downto 0) := (OTHERS => '0');
	signal ram_array_d_6 : std_logic_vector(ram_width-1 downto 0) := (OTHERS => '0');
	signal ram_array_q_0 : std_logic_vector(ram_width-1 downto 0) := (OTHERS => '0');
	signal ram_array_q_1 : std_logic_vector(ram_width-1 downto 0) := (OTHERS => '0');
	signal ram_array_q_2 : std_logic_vector(ram_width-1 downto 0) := (OTHERS => '0');
	signal ram_array_q_3 : std_logic_vector(ram_width-1 downto 0) := (OTHERS => '0');
	signal ram_array_q_4 : std_logic_vector(ram_width-1 downto 0) := (OTHERS => '0');
	signal ram_array_q_5 : std_logic_vector(ram_width-1 downto 0) := (OTHERS => '0');
	signal ram_array_q_6 : std_logic_vector(ram_width-1 downto 0) := (OTHERS => '0');
	signal data_reg_0 : std_logic_vector(ram_width-1 downto 0) := (OTHERS => '0');
	signal data_reg_1 : std_logic_vector(ram_width-1 downto 0) := (OTHERS => '0');
	signal data_reg_2 : std_logic_vector(ram_width-1 downto 0) := (OTHERS => '0');
	signal data_reg_3 : std_logic_vector(ram_width-1 downto 0) := (OTHERS => '0');
	signal data_reg_4 : std_logic_vector(ram_width-1 downto 0) := (OTHERS => '0');
	signal data_reg_5 : std_logic_vector(ram_width-1 downto 0) := (OTHERS => '0');
	signal data_reg_6 : std_logic_vector(ram_width-1 downto 0) := (OTHERS => '0');
	signal data_out_i : std_logic_vector(19 downto 0);

begin
	
	-- Modelling the read port 
	-- Assuming address trigerred operation only 
	--assignment
	
	data_reg_0 <= datain when waddr = "000" else
						ram_array_q_0;
	data_reg_1 <= datain when waddr = "001" else
						ram_array_q_1;
	data_reg_2 <= datain when waddr = "010" else
						ram_array_q_2;
	data_reg_3 <= datain when waddr = "011" else
						ram_array_q_3;
	data_reg_4 <= datain when waddr = "100" else
						ram_array_q_4;
	data_reg_5 <= datain when waddr = "101" else
						ram_array_q_5;
	data_reg_6 <= datain when waddr = "110" else
						ram_array_q_6;

	dataout <= data_out_i when re = '1' else
						(OTHERS => '0');

	process (wclk, rstl, waddr, raddr, datain, ram_array_q_0, ram_array_q_1, ram_array_q_2, ram_array_q_3, ram_array_q_4, ram_array_q_5, ram_array_q_6, data_reg_0, data_reg_1, data_reg_2, data_reg_3, data_reg_4, data_reg_5, data_reg_6)
	variable dataout_tmp : std_logic_vector(19 downto 0);
	begin

		case raddr is  
			when "000" => data_out_i <= ram_array_q_0;
			when "001" => data_out_i <= ram_array_q_1;
			when "010" => data_out_i <= ram_array_q_2;
			when "011" => data_out_i <= ram_array_q_3;
			when "100" => data_out_i <= ram_array_q_4;
			when "101" => data_out_i <= ram_array_q_5;
			when "110" => data_out_i <= ram_array_q_6;
			when others => data_out_i <= data_out_i;
		end case;

		if (re = '1') then
			dataout_tmp := data_out_i;
		else
			dataout_tmp := (OTHERS => '0');
		end if;

		--Modelling the write port 
		if (rstl = '0') then
			ram_array_q_0 <= (OTHERS => '0');
			ram_array_q_1 <= (OTHERS => '0');
			ram_array_q_2 <= (OTHERS => '0'); 
			ram_array_q_3 <= (OTHERS => '0'); 
			ram_array_q_4 <= (OTHERS => '0'); 
			ram_array_q_5 <= (OTHERS => '0'); 
			ram_array_q_6 <= (OTHERS => '0'); 
		else 
			if (wclk'event and wclk = '1') then
				ram_array_q_0 <= ram_array_d_0;
				ram_array_q_1 <= ram_array_d_1;
				ram_array_q_2 <= ram_array_d_2;
				ram_array_q_3 <= ram_array_d_3;
				ram_array_q_4 <= ram_array_d_4;
				ram_array_q_5 <= ram_array_d_5;
				ram_array_q_6 <= ram_array_d_6;
	  		end if;
			if (we = '1') then
				ram_array_d_0 <= data_reg_0;
				ram_array_d_1 <= data_reg_1;
				ram_array_d_2 <= data_reg_2;
				ram_array_d_3 <= data_reg_3;
				ram_array_d_4 <= data_reg_4;
				ram_array_d_5 <= data_reg_5;
				ram_array_d_6 <= data_reg_6;
	  		else 
				ram_array_d_0 <= ram_array_q_0;
				ram_array_d_1 <= ram_array_q_1;
				ram_array_d_2 <= ram_array_q_2;
				ram_array_d_3 <= ram_array_q_3;
				ram_array_d_4 <= ram_array_q_4;
				ram_array_d_5 <= ram_array_q_5;
				ram_array_d_6 <= ram_array_q_6;
	  		end if;
		end if;


	end process;

end hssi_ram7x20_syn;

----------------------------------------------------------------
-- 			hssi_fifo
----------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;

entity hssi_fifo is
	generic (
		channel_width           : integer := 20);

	port (
			clk0		: in std_logic;
			clk1		: in std_logic;
			datain	: in std_logic_vector(19 downto 0);
			we			: in std_logic := '0';
			re			: in std_logic := '0';
			reset		: in std_logic := '0';
			devclrn	: in std_logic := '1';
			devpor	: in std_logic := '1';
			empty		: out std_logic;
			overflow	: out std_logic;
			dataout	: out std_logic_vector(19 downto 0));


end hssi_fifo;

architecture synchronizer of hssi_fifo is
	signal ram_we: std_logic;
	signal ram_reset, ram_re : std_logic;
	signal ram_datain : std_logic_vector (channel_width-1 downto 0);
	signal ram_dataout : std_logic_vector (channel_width-1 downto 0);
	signal wrPtr0 : std_logic_vector (2 downto 0) := "000";
	signal wrPtr1 : std_logic_vector (2 downto 0) := "000";
	signal wrPtr2 : std_logic_vector (2 downto 0) := "000";
	signal wrPtr : std_logic_vector (2 downto 0) := "000";
	signal rdPtr : std_logic_vector (2 downto 0) := "000";
	signal preRdPtr : std_logic_vector (2 downto 0) := "111";
	signal preRdPtr1 : std_logic_vector (2 downto 0) := "111";
	signal preRdPtr2 : std_logic_vector (2 downto 0) := "111";
	signal wrAddr : std_logic_vector (2 downto 0) := "000";
	signal dataout_tmp : std_logic_vector (channel_width-1 downto 0);
	signal empty_tmp : std_logic;

component ram7x20_syn
	generic (
		ram_width					: integer := 20
	);

	port (
		wclk	: in std_logic;
		rstl	: in std_logic := '1'; 
		waddr	: in std_logic_vector(2 downto 0);
		raddr	: in std_logic_vector(2 downto 0);
		datain	: in std_logic_vector(19 downto 0);
		we			: in std_logic := '0';
		re			: in std_logic := '0';
		dataout	: out std_logic_vector(19 downto 0)
	);
end component;

begin

	ram_reset <= NOT reset;
	ram_re <= re AND empty_tmp;

	-- ram7x20_syn
	fifo_ram: ram7x20_syn
					generic map (ram_width => channel_width)
					port map (wclk => clk0, rstl => ram_reset, waddr => wrAddr, raddr => rdPtr, datain => ram_datain, we => ram_we, re => ram_re, dataout => ram_dataout);

	process (clk0, clk1, reset, we, re, datain, devclrn, devpor, wrPtr, wrPtr0, wrPtr1, wrPtr2, rdPtr, preRdPtr, preRdPtr1, preRdPtr2)  

	variable overflow_tmp : std_logic;
	variable empty_tmp_var : std_logic;


	begin
		if (now = 0 ns) then
			dataout_tmp <= (OTHERS => '0');
			ram_datain <= (OTHERS => '0');
			overflow_tmp :=  '1';
			empty_tmp <=  '1';
			empty_tmp_var :=  '1';
			wrAddr <=  "000";
			rdPtr <=  "000";
			wrPtr <=  "000";
			wrPtr0 <=  "000";
			wrPtr1 <=  "000";
			wrPtr2 <=  "000";
			preRdPtr <=  "111";
			preRdPtr1 <=  "111";
			preRdPtr2 <=  "111";
			ram_we <= '0';
		end if;

		if ((devpor = '0') or (devclrn = '0')) then
			dataout_tmp <= (OTHERS => '0');
			ram_datain <= (OTHERS => '0');
			overflow_tmp :=  '0';
			empty_tmp <=  '0';
			empty_tmp_var :=  '0';
			wrAddr <=  "000";
			rdPtr <=  "000";
			wrPtr <=  "000";
			wrPtr0 <=  "000";
			wrPtr1 <=  "000";
			wrPtr2 <=  "000";
			preRdPtr <=  "111";
			preRdPtr1 <=  "111";
			preRdPtr2 <=  "111";
			ram_we <= '0';
		end if;
		if (reset = '1') then
			dataout_tmp <= (OTHERS => '0');
			ram_datain <= (OTHERS => '0');
			overflow_tmp :=  '0';
			empty_tmp <=  '0';
			empty_tmp_var :=  '0';
			wrAddr <=  "000";
			rdPtr <=  "000";
			wrPtr <=  "000";
			wrPtr0 <=  "000";
			wrPtr1 <=  "000";
			wrPtr2 <=  "000";
			preRdPtr <=  "111";
			preRdPtr1 <=  "111";
			preRdPtr2 <=  "111";
			ram_we <= '0';
		else
			if (clk1'event and clk1 = '1') then
				if (re = '1' and empty_tmp_var = '1') then
					dataout_tmp <= ram_dataout;
					case rdPtr is
						when "000" => rdPtr <= "001";
						when "001" => rdPtr <= "010";
						when "010" => rdPtr <= "011";
						when "011" => rdPtr <= "100";
						when "100" => rdPtr <= "101";
						when "101" => rdPtr <= "110";
						when "110" => rdPtr <= "000";
						when others => rdPtr <= "000";
					end case;
					preRdPtr <= rdPtr;
				else
					dataout_tmp <= dataout_tmp;
				end if;
				--synchronize write pointers.
				wrPtr1 <= wrPtr;
				wrPtr2 <= wrPtr1;
			end if;
			if (clk0'event and clk0 = '1') then
				wrPtr <= wrPtr0;
				if (we = '1' and overflow_tmp = '1') then
					ram_we <= '1';
					ram_datain <= datain;
					wrAddr <= wrPtr0;
					case wrPtr0 is
						when "000" => wrPtr0 <= "001";
						when "001" => wrPtr0 <= "010";
						when "010" => wrPtr0 <= "011";
						when "011" => wrPtr0 <= "100";
						when "100" => wrPtr0 <= "101";
						when "101" => wrPtr0 <= "110";
						when "110" => wrPtr0 <= "000";
						when others => wrPtr0 <= "000";
					end case;
				else
					ram_we <= '0';
					wrAddr <= wrAddr;
					ram_datain <= ram_datain;
					wrPtr0 <= wrPtr0;
				end if;
				--synchronize read pointers.
				preRdPtr1 <= preRdPtr;
				preRdPtr2 <= preRdPtr1;
			end if;

			if (wrPtr0 = preRdPtr2) then
				overflow_tmp := '0';
			else
				overflow_tmp := '1';
			end if;
			if (rdPtr = wrPtr2) then
				empty_tmp_var := '0';
			else
				empty_tmp_var := '1';
			end if;
		
		end if;


	empty_tmp <= empty_tmp_var;
        overflow <= overflow_tmp;
	end process;
        empty <= empty_tmp;
        dataout <= dataout_tmp;

end synchronizer;
-------------------------------------------------------------
--			 HSSI_RX
-------------------------------------------------------------

library IEEE, std;
use IEEE.std_logic_1164.all;

entity hssi_rx is
    generic (
                channel_width           : integer := 20;
                operation_mode          : String  := "lvds";
                run_length  	          : integer := 1);

        port (
					clk			: in std_logic;
					datain		: in std_logic;
					areset		: in std_logic := '0';
					feedback		: in std_logic := '0';
					fbkcntl		: in std_logic := '0';
					devclrn		: in std_logic := '1';
					devpor		: in std_logic := '1';
					clkout		: out std_logic;
					rlv			: out std_logic;
					locked		: out std_logic;
					dataout		: out std_logic_vector(19 downto 0));
end hssi_rx;

architecture receiver of hssi_rx is
signal fbena, fbin : std_logic;

begin


process (clk, devpor, devclrn, areset, fbena)
variable clk_count : integer := 0; --follow the 1st edge
variable deser_data_arr : std_logic_vector(channel_width-1 downto 0);
variable dataout_tmp : std_logic_vector(19 downto 0);
variable clkout_tmp : std_logic;
variable rlv_tmp : std_logic := '0';
variable locked_tmp : std_logic := '0';
variable clkout_last_value : std_logic;
variable last_datain : std_logic;
variable rlv_count : integer := 0; 
variable data_changed : std_logic := '0';
variable rlv_flag : std_logic := '0';
variable datain_ipd : std_logic;

begin

	if (now = 0 ns) then
		dataout_tmp := (OTHERS => '0');
		clkout_last_value := clk;
		rlv_tmp :=  '0';
		clkout_tmp :=  '0';
		data_changed :=  '0';
	end if;
	if (areset = '1') then
		dataout_tmp := (OTHERS => '0');
		clkout_tmp :=  '0';
		clk_count := 0;
		rlv_tmp := '0';
		locked_tmp := '0';
		clkout_last_value := clk;
      for i in channel_width-1 downto 0 loop
			deser_data_arr(i) := '0';
      end loop;
		rlv_count := 0;
		rlv_flag := '0';
		last_datain := 'X';
		data_changed := '0';
	else
		if (fbena = '1') then
			datain_ipd := fbin;
		else
			datain_ipd := datain;
		end if;
	   if (clk'event and clk = '1') then
			if (clkout_last_value = 'U') then
				clkout_last_value := clk;
				clkout_tmp := clk;
			end if;
			if (clk_count = channel_width) then
				clk_count :=0;
				clkout_tmp := NOT (clkout_last_value);
			elsif (clk_count = (channel_width+1)/2) then
				clkout_tmp := NOT (clkout_last_value);
			elsif (clk_count < channel_width) then
				clkout_tmp := clkout_last_value;
			end if;
			if (operation_mode = "cdr") then
				if (rlv_flag = '1') then
					rlv_tmp := '1';
				else
					rlv_tmp := '0';
				end if;
				if (last_datain /= datain_ipd) then
					data_changed := '1';
					last_datain := datain_ipd;
				else
					rlv_count := rlv_count + 1;
					data_changed := '0';
				end if;
				if (rlv_count > run_length) then
					rlv_flag := '1';
				end if;
				if (data_changed = '1') then
					rlv_count := 1;
					rlv_flag := '0';
				end if;
			end if;
	   end if;
	   if (clk'event and clk = '0') then
			if (clkout_last_value = 'U') then
				clkout_last_value := clk;
				clkout_tmp := clk;
			end if;
			clk_count := clk_count + 1;
	      if (clk_count = 3) then
				dataout_tmp(channel_width-1 downto 0) := deser_data_arr;
	      end if;
	      for i in channel_width-1 downto 1 loop
				deser_data_arr(i) := deser_data_arr(i-1);
	      end loop;
	      deser_data_arr(0) := datain_ipd;
	   end if;

		if (clkout_tmp /= 'U') then
			clkout_last_value := clkout_tmp;
		end if;
	end if;

	dataout <= dataout_tmp;
        clkout <= clkout_tmp;
        rlv <= rlv_tmp;
        locked <= locked_tmp;
end process;

end receiver;
----------------------------------------------------------------------
-- 				HSSI_TX
----------------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;

entity hssi_tx is
    generic (
                channel_width           : integer := 20);

        port (
                clk             : in std_logic;
                areset          : in std_logic := '0';
                datain          : in std_logic_vector(19 downto 0);
                devclrn         : in std_logic := '1';
					 devpor			  : in std_logic := '1';
                clkout          : out std_logic;
                dataout         : out std_logic);

end hssi_tx;

architecture transmitter of hssi_tx is

begin

process (clk, areset, devclrn, devpor)  -- need to generate clkout here
variable i : integer := 0;
variable dataout_tmp : std_logic;
variable indata : std_logic_vector(channel_width-1 downto 0);
variable regdata : std_logic_vector(channel_width-1 downto 0);
variable fast_clk_count : integer := channel_width; -- always follow the first edge
variable clkout_tmp : std_logic;
variable clkout_last_value : std_logic;
begin

	if (now = 0 ns) then
		dataout_tmp := '0';
		clkout_last_value := clk;
   end if;

   if ((devpor = '0') or (devclrn = '0') or (areset = '1')) then
		dataout_tmp := '0';
		clkout_tmp := '0';
		fast_clk_count := channel_width;
      for i in channel_width-1 downto 0 loop --reset register
			indata(i) := '0';
			regdata(i) := '0';
		end loop;
   else
      if (clk'event and clk = '1') then
      	if (clkout_last_value = 'U') then --for initial value
				clkout_last_value := clk;
				clkout_tmp := clk;
			end if;
			if (fast_clk_count = channel_width) then
				fast_clk_count := 0;
				clkout_tmp := NOT (clkout_last_value);
			elsif (fast_clk_count = (channel_width+1)/2) then
				clkout_tmp := NOT (clkout_last_value);
			elsif (fast_clk_count < channel_width) then
				clkout_tmp := clkout_last_value;
	      end if;
			fast_clk_count := fast_clk_count + 1;
			if (fast_clk_count = 3) then --shifting out new data 
         	for i in channel_width-1 downto 0 loop
					regdata(i) := indata(i);
				end loop;
			end if;
         dataout_tmp := regdata(channel_width - 1);
         for i in channel_width-1 downto 1 loop
				regdata(i) := regdata(i-1);
			end loop;
      end if;
      if (clk'event and clk = '0') then  -- falling edge
      	if (clkout_last_value = 'U') then --for initial value
				clkout_last_value := clk;
				clkout_tmp := clk;
			end if;
			if (fast_clk_count = 3) then --loading 
				indata := datain(channel_width-1 downto 0);
			end if;
      end if;
   end if;

	if (clkout_tmp /= 'U') then
		clkout_last_value := clkout_tmp;
	end if;

	dataout <= dataout_tmp;
        clkout <= clkout_tmp;
        
end process;

end transmitter;
------------------------------------------------------------------------
--			ALTCDR_RX
------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;

entity altcdr_rx is
	generic (
		number_of_channels: positive := 1;
		deserialization_factor : positive := 1;
		inclock_period : positive;
		run_length : integer := 43;
		inclock_boost : positive := 1;
		intended_device_family : string := "MERCURY");
	port (
		rx_in : in std_logic_vector(number_of_channels-1 downto 0);
		rx_inclock : in std_logic;
		rx_coreclock : in std_logic;
		rx_fifo_rden : in std_logic_vector(number_of_channels downto 0);
		rx_aclr : in std_logic;
		rx_pll_aclr : in std_logic;
		rx_out : out std_logic_vector(deserialization_factor*number_of_channels-1 downto 0);
		rx_outclock : out std_logic;
		rx_locklost : out std_logic_vector(number_of_channels-1 downto 0);
		rx_pll_locked : out std_logic;
		rx_empty : out std_logic_vector(number_of_channels-1 downto 0);
		rx_full : out std_logic_vector(number_of_channels-1 downto 0);
		rx_rlv : out std_logic_vector(number_of_channels-1 downto 0));
end altcdr_rx;	

architecture struct of altcdr_rx is
type cdrword is array (number_of_channels downto 0) of std_logic_vector(deserialization_factor-1 downto 0);
signal w_rx_inclock0 : std_logic;
signal w_rx_clkout : std_logic_vector(number_of_channels-1 downto 0);
signal w_rx_out : cdrword;
component hssi_pll
  generic
      ( clk0_multiply_by        : integer := 1;
        input_frequency         : integer := 1000);
  port
      ( clk    : in std_logic := '0';
        areset : in std_logic := '0';
        clk0   : out std_logic;
        locked : out std_logic );
end component;
component hssi_rx
    generic (
        channel_width   : integer := 20;
        operation_mode  : string := "cdr";
        run_length      : integer := 1);
    port (
        clk             : in std_logic;
        datain          : in std_logic;
        areset          : in std_logic := '0';
        clkout          : out std_logic;
        rlv             : out std_logic;
        locked          : out std_logic;
        dataout         : out std_logic_vector(channel_width-1 downto 0));
end component;
component hssi_fifo
  generic (
        channel_width   : integer := 20);

  port (
        clk0    : in std_logic;
        clk1    : in std_logic;
        datain  : in std_logic_vector(channel_width-1 downto 0);
        re      : in std_logic := '0';
        reset   : in std_logic := '0';
        empty   : out std_logic;
        overflow : out std_logic;
        dataout : out std_logic_vector(channel_width-1 downto 0));
end component;

begin

pll: hssi_pll
	generic map (clk0_multiply_by => inclock_boost,
		     input_frequency => inclock_period)
	port map (clk => rx_inclock, areset => rx_aclr, 
		  clk0 => w_rx_inclock0, locked => rx_pll_locked);

rx: for i in 0 to number_of_channels-1 generate
	rx: hssi_rx 
     		generic map (channel_width => deserialization_factor,
			     run_length => run_length)
		port map (clk => w_rx_inclock0, datain => rx_in(i),
		  	  areset => rx_aclr, clkout => w_rx_clkout(i),
			  locked => rx_locklost(i), rlv => rx_rlv(i),
			  dataout => w_rx_out(i));
end generate;

fifo: for i in 0 to number_of_channels-1 generate
	fifo: hssi_fifo
		generic map (channel_width => deserialization_factor)
		port map (clk1 => rx_coreclock, clk0 => w_rx_clkout(i),
		          re => rx_fifo_rden(i), datain => w_rx_out(i),
			  overflow => rx_full(i), empty => rx_empty(i),
			  dataout => rx_out((i+1)*deserialization_factor-1 downto i*deserialization_factor));
end generate;

rx_outclock <= w_rx_clkout(0);

end struct;
----------------------------------------------------------------------
--			ALTCDR_TX
----------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;

entity altcdr_tx is
	generic (
		number_of_channels: positive := 1;
		deserialization_factor : positive := 1;
		inclock_period : positive;
		inclock_boost : positive := 1;
		intended_device_family : string := "MERCURY");
	port (
		tx_in : in std_logic_vector(deserialization_factor*number_of_channels-1 downto 0);
		tx_inclock : in std_logic;
		tx_coreclock : in std_logic;
		tx_fifo_wren : in std_logic_vector(number_of_channels downto 0);
		tx_aclr : in std_logic;
		tx_pll_aclr : in std_logic;
		tx_out : out std_logic_vector(number_of_channels-1 downto 0);
		tx_outclock : out std_logic;
		tx_pll_locked : out std_logic;
		tx_empty : out std_logic_vector(number_of_channels-1 downto 0);
		tx_full : out std_logic_vector(number_of_channels-1 downto 0));
end altcdr_tx;	

architecture struct of altcdr_tx is
type cdrword is array (number_of_channels downto 0) of std_logic_vector(deserialization_factor-1 downto 0);
signal w_tx_inclock0 : std_logic;
signal w_tx_clkout : std_logic_vector(number_of_channels-1 downto 0);
signal fifo_out : cdrword;
component hssi_pll
  generic
      ( clk0_multiply_by        : integer := 1;
        input_frequency       : integer := 1000);
  port
      ( clk    : in std_logic := '0';
        areset : in std_logic := '0';
        clk0   : out std_logic;
        locked : out std_logic );
end component;
component hssi_tx
    generic (
        channel_width   : integer := 20);
    port (
        clk             : in std_logic;
        datain          : in std_logic_vector(channel_width-1 downto 0);
        areset          : in std_logic := '0';
        clkout          : out std_logic;
        dataout         : out std_logic);
end component;
component hssi_fifo
  generic (
        channel_width   : integer := 20);

  port (
        clk0    : in std_logic;
        clk1    : in std_logic;
        datain  : in std_logic_vector(channel_width-1 downto 0);
        we      : in std_logic := '0';
        reset   : in std_logic := '0';
        empty   : out std_logic;
        overflow : out std_logic;
        dataout : out std_logic_vector(channel_width-1 downto 0));
end component;
begin
pll: hssi_pll
        generic map (clk0_multiply_by => inclock_boost,
                     input_frequency => inclock_period)
        port map (clk => tx_inclock, areset => tx_aclr,
                  clk0 => w_tx_inclock0, locked => tx_pll_locked);

fifo: for i in 0 to number_of_channels-1 generate
        fifo: hssi_fifo
                generic map (channel_width => deserialization_factor)
                port map (clk1 => tx_coreclock, clk0 => w_tx_clkout(i),
                          we => tx_fifo_wren(i), datain => tx_in((i+1)*deserialization_factor-1 downto i*deserialization_factor),
                          overflow => tx_full(i), empty => tx_empty(i),
                          dataout => fifo_out(i));
end generate;

tx: for i in 0 to number_of_channels-1 generate
        tx: hssi_tx
                generic map (channel_width => deserialization_factor)
                port map (clk => w_tx_inclock0, datain => fifo_out(i),
                          areset => tx_aclr, clkout => w_tx_clkout(i),
                          dataout => tx_out(i));
end generate;

tx_outclock <= w_tx_clkout(0);
end struct;

--------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity LCELL is
   port(
      A_IN                           :  in    std_logic;
      A_OUT                          :  out   std_logic);
end LCELL;

architecture BEHAVIOR of LCELL is
begin
        A_OUT <= A_IN;
end BEHAVIOR;


library ieee;
use ieee.std_logic_1164.all;

entity GLOBAL is
   port(
      A_IN                           :  in    std_logic;
      A_OUT                          :  out   std_logic);
end GLOBAL;

architecture BEHAVIOR of GLOBAL is
begin
        A_OUT <= A_IN;
end BEHAVIOR;

library ieee;
use ieee.std_logic_1164.all;

entity CARRY is
   port(
      A_IN                           :  in    std_logic;
      A_OUT                          :  out   std_logic);
end CARRY;

architecture BEHAVIOR of CARRY is
begin
        A_OUT <= A_IN;
end BEHAVIOR;


library ieee;
use ieee.std_logic_1164.all;

entity CASCADE is
   port(
      A_IN                           :  in    std_logic;
      A_OUT                          :  out   std_logic);
end CASCADE;

architecture BEHAVIOR of CASCADE is
begin
        A_OUT <= A_IN;
end BEHAVIOR;

